GLR_C = {}

local L = LibStub("AceLocale-3.0"):GetLocale("GuildLotteryRaffle")

function GLR_C:Toggle()
	
	local SavedStatus = glrCharacter.Data.Settings.CreateCalendarEvents
	local canEdit = CanEditGuildEvent()
	
	if canEdit then
		if SavedStatus then
			glrCharacter.Data.Settings.CreateCalendarEvents = false
		else
			glrCharacter.Data.Settings.CreateCalendarEvents = true
		end
	else
		glrCharacter.Data.Settings.CreateCalendarEvents = false
		GLR:Print(L["Cant Create Calendar Events"])
	end
	
end

function GLR_C:CreateAnnouncement(state)
	
	local FullPlayerName = (GetUnitName("PLAYER", false) .. "-" .. string.gsub(string.gsub(GetRealmName(), "-", ""), "%s+", ""))
	local canEdit = CanEditGuildEvent()
	local year, month, day, hour, minute
	local AnnouncementTitle = ""
	local MaxTickets = ""
	local TicketPrice = ""
	
	C_Calendar.CloseEvent() --Closes Calendar Events if opened while mod is creating event.
	
	if canEdit then
		
		if state == "Lottery" then
			AnnouncementTitle = L["Calendar Lottery Title"]
		elseif state == "Raffle" then
			AnnouncementTitle = L["Calendar Raffle Title"]
		end
		month = tostring(tonumber(string.sub(glrCharacter.Event[state].Date, 1, 2))) --Done like this to translate "07" into "7" as WoW doesn't like "07" for July
		day = tostring(tonumber(string.sub(glrCharacter.Event[state].Date, 4, 5)))
		year = "20" .. string.sub(glrCharacter.Event[state].Date, 7, 8)
		hour = string.sub(glrCharacter.Event[state].Date, 12, 13)
		minute = string.sub(glrCharacter.Event[state].Date, 15, 16)
		MaxTickets = glrCharacter.Event[state].MaxTickets
		TicketPrice = glrCharacter.Event[state].TicketPrice
		
		local AnnouncementDescription = string.gsub(string.gsub(string.gsub(L["Calendar Guild Announcement"], "%%TicketPrice", TicketPrice), "%%MaxTickets", MaxTickets), "%%Player", FullPlayerName)
		
		C_Calendar.CreateGuildAnnouncementEvent()
		C_Calendar.EventSetDate(month,day,year)
		C_Calendar.EventSetTitle(AnnouncementTitle)
		C_Calendar.EventSetDescription(AnnouncementDescription)
		C_Calendar.EventSetTime(hour,minute)
		C_Calendar.EventSetType(5)
		C_Calendar.AddEvent()
		C_Calendar.CloseEvent()
		
	else
		glrCharacter.Data.Settings.CreateCalendarEvents = false
		GLR:Print(L["Cant Create Calendar Events"])
	end
	
end