GLR = LibStub("AceAddon-3.0"):NewAddon("GuildLotteryRaffle", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0", "AceHook-3.0")
GLR_Core = {}
GLR_Libs = {}
GLR_Version = GetAddOnMetadata("GuildLotteryRaffle", "Version")
local GLR_VersionString = "301000"
GLR_Libs.WhoLib = LibStub:GetLibrary("LibWho-2.0")
glrLotteryDrawInProgress = false -- Prevents the mod from starting the same lottery draw until the current one has finished.
glrRaffleDrawInProgress = false
glrAbortRoll = false
-- |cfff7ff4d -The Color Code
-- 0.97, 1, 0.30 -The SetText Color Code

glrHistory = glrHistory or {}
glrCharacter = glrCharacter or {}
glrTemp = glrTemp or {} --Temp table that releases all info upon each login, used to hold Ticket Numbers to send to players
glrTempStatus = glrTempStatus or {}

GLR_Core.Font = "Interface\\AddOns\\GuildLotteryRaffle\\Fonts\\PT_Sans_Narrow.TTF"
GLR_Core.ButtonFont = "Interface\\AddOns\\GuildLotteryRaffle\\Fonts\\Intro_Black.TTF"

local raffleTicketNumbersTable = {}
local raffleWinners = {}
local scannedMailExtraGold = {}
glrUpdateTickets = {}
glrScannedMail = {}

GLR_SelectLotteryPlayer = 0
GLR_SelectRafflePlayer = 0
GLR_CreateCalendarEvents = false

local GLRGuildCheckComplete = false
local GLRGuildCheck = 0
local remainingJackpot = 0
local MailEntries = 0
local firstPrize
local secondPrize
local thirdPrize
local firstWinningTicket
local secondWinningTicket
local thirdWinningTicket
local rp1 = false
local rp2 = false
local rp3 = false
local rp1t = ""
local rp2t = ""
local rp3t = ""
local raffleCompleted = false
local lotteryCompleted = false
local lotteryWinnerFound = false
local clearPreviousJackpot = false
local abortPrinted = false
local ScanMailBuffer = false
local isAddOnLoaded = false
local DetectPhrases = true
local DetectOtherPhrases = true
local PlayerName = GetUnitName("PLAYER", false)
local FullPlayerName = (GetUnitName("PLAYER", false) .. "-" .. string.gsub(string.gsub(GetRealmName(), "-", ""), "%s+", ""))
local PlayerRealmName = string.sub(FullPlayerName, string.find(FullPlayerName, "-") + 1)

local L = LibStub("AceLocale-3.0"):GetLocale("GuildLotteryRaffle")
local glrChat = DEFAULT_CHAT_FRAME
local Initalizeation = CreateFrame("Frame")
local ScanMailFrame = CreateFrame("Frame")
local configUI = LibStub("AceConfig-3.0")
local dialog = LibStub("AceConfigDialog-3.0")
local lotteryOrRaffle
--Holds Raffle Prize Data when setting a new Raffle, which is then transfered to the save data file.
local holdRaffleInfo = { ["FirstPrize"] = { ["ItemName"] = "", ["ItemLink"] = "" }, ["SecondPrize"] = { ["ItemName"] = "", ["ItemLink"] = "" }, ["ThirdPrize"] = { ["ItemName"] = "", ["ItemLink"] = "" } }

local ClassColor = {
	[L["Death Knight"]] = { 0.77, 0.12, 0.23 },
	[L["Demon Hunter"]] = { 0.64, 0.19, 0.79 },
	[L["Druid"]] = { 1.0, 0.49, 0.04 },
	[L["Hunter"]] = { 0.67, 0.83, 0.45 },
	[L["Mage"]] = { 0.41, 0.80, 0.94 },
	[L["Monk"]] = { 0.33, 0.54, 0.52 },
	[L["Paladin"]] = { 0.96, 0.55, 0.73 },
	[L["Priest"]] = { 1.0, 1.0, 1.0 },
	[L["Rogue"]] = { 1.0, 0.96, 0.41 },
	[L["Shaman"]] = { 0.0, 0.44, 0.87 },
	[L["Warlock"]] = { 0.58, 0.51, 0.79 },
	[L["Warrior"]] = { 0.78, 0.61, 0.43 }
}

local NewUpdateFrame = CreateFrame("Frame", "GLR_NewUpdateFrame", UIParent, "InsetFrameTemplate3")
NewUpdateFrame:SetPoint("CENTER", UIParent)
NewUpdateFrame:SetSize(190, 60)
NewUpdateFrame:EnableMouse(true)
NewUpdateFrame:SetResizable(false)
NewUpdateFrame:Hide()

local NewUpdateFrameCloseButton = CreateFrame("Button", "GLR_NewUpdateFrameCloseButton", NewUpdateFrame, "UIPanelCloseButton")
NewUpdateFrameCloseButton:SetPoint("TOPRIGHT", NewUpdateFrame, "TOPRIGHT", 3, 3)

local NewUpdateFrameTitle = NewUpdateFrame:CreateFontString("NewUpdateFrameTitle", "OVERLAY", "GameFontNormalSmall")
NewUpdateFrameTitle:SetPoint("TOP", NewUpdateFrame, "TOP", 0, -5)
NewUpdateFrameTitle:SetText(L["Guild Lottery & Raffles"])
NewUpdateFrameTitle:SetFont(GLR_Core.Font, 12)

local NewUpdateFrameText = NewUpdateFrame:CreateFontString("NewUpdateFrameText", "OVERLAY", "GameFontNormalSmall")
NewUpdateFrameText:SetPoint("CENTER", NewUpdateFrame, "CENTER", 0, -8)
NewUpdateFrameText:SetText(L["NewUpdateFrame Changes"] .. ".")
NewUpdateFrameText:SetFont(GLR_Core.ButtonFont, 14)

local function NewUpdate()
	NewUpdateFrame:Show()
end

local function CheckForGivenOrSold()
	if glrCharacter.Data.Settings.CurrentlyActiveLottery then
		local count = 0
		for i = 1, #glrCharacter.Lottery.Entries.Names do
			local name = glrCharacter.Lottery.Entries.Names[i]
			if glrCharacter.Lottery.Entries.Tickets[name].Given == nil then
				glrCharacter.Lottery.Entries.Tickets[name].Given = 0
			end
			if glrCharacter.Lottery.Entries.Tickets[name].Sold == nil then
				glrCharacter.Lottery.Entries.Tickets[name].Sold = glrCharacter.Lottery.Entries.Tickets[name].NumberOfTickets
				count = count + glrCharacter.Lottery.Entries.Tickets[name].Sold
			end
			if count > glrCharacter.Event.Lottery.TicketsSold then
				local diff = count - glrCharacter.Event.Lottery.TicketsSold
				glrCharacter.Lottery.Entries.Tickets[name].Sold = glrCharacter.Lottery.Entries.Tickets[name].Sold - diff
				glrCharacter.Lottery.Entries.Tickets[name].Given = diff
			end
		end
	end
	if glrCharacter.Data.Settings.CurrentlyActiveRaffle then
		local count = 0
		for i = 1, #glrCharacter.Raffle.Entries.Names do
			local name = glrCharacter.Raffle.Entries.Names[i]
			if glrCharacter.Raffle.Entries.Tickets[name].Given == nil then
				glrCharacter.Raffle.Entries.Tickets[name].Given = 0
			end
			if glrCharacter.Raffle.Entries.Tickets[name].Sold == nil then
				glrCharacter.Raffle.Entries.Tickets[name].Sold = glrCharacter.Raffle.Entries.Tickets[name].NumberOfTickets
				count = count + glrCharacter.Raffle.Entries.Tickets[name].Sold
			end
			if count > glrCharacter.Event.Raffle.TicketsSold then
				local diff = count - glrCharacter.Event.Raffle.TicketsSold
				glrCharacter.Raffle.Entries.Tickets[name].Sold = glrCharacter.Raffle.Entries.Tickets[name].Sold - diff
				glrCharacter.Raffle.Entries.Tickets[name].Given = diff
			end
		end
	end
end

local function CommaValue(amount)
	local formatted = amount
	while true do
		formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
		if (k==0) then
			break
		end
	end
	return formatted
end

local function GetMoneyValue(value, EventType, NumberType, PlaceType, Previous)
	local total = value
	local event = EventType
	local NumberValue = NumberType
	local place = PlaceType
	local PrevEvent = Previous
	local round = glrCharacter.Data.Settings.RoundJackpot
	if string.find(total, "%.") == nil then
		total = total .. ".0000"
	end
	if string.sub(total, string.find(total, "%.") + 1, string.find(total, "%.") + 1) == "" then
		total = tostring(total) .. "00"
		if string.sub(total, string.find(total, "%.") + 3, string.find(total, "%.") + 3) == "" then
			total = total .. "00"
		elseif string.sub(total, string.find(total, "%.") + 4, string.find(total, "%.") + 4) == "" then
			total = total .. "0"
		end
	elseif string.sub(total, string.find(total, "%.") + 2, string.find(total, "%.") + 2) == "" then
		total = tostring(total) .. "0"
		if string.sub(total, string.find(total, "%.") + 3, string.find(total, "%.") + 3) == "" then
			total = total .. "00"
		elseif string.sub(total, string.find(total, "%.") + 4, string.find(total, "%.") + 4) == "" then
			total = total .. "0"
		end
	elseif string.sub(total, string.find(total, "%.") + 3, string.find(total, "%.") + 3) == "" then
		total = tostring(total) .. "00"
	elseif string.sub(total, string.find(total, "%.") + 4, string.find(total, "%.") + 4) == "" then
		total = tostring(total) .. "0"
	end
	
	local Gold = string.sub(total, 1, string.find(total, "%.") - 1)
	local Silver = string.sub(total, string.find(total, "%.") + 1, string.find(total, "%.") + 2)
	local Copper = string.sub(total, string.find(total, "%.") + 3, string.find(total, "%.") + 4)
	
	if event == "Lottery" and NumberValue == "Jackpot" and round then
		Gold = tonumber(Gold)
		Silver = tonumber(Silver)
		Copper = tonumber(Copper)
		if Copper >= 50 then
			Copper = "00"
			Silver = Silver + 1
			if Silver >= 50 then
				Silver = "00"
				Gold = tostring(Gold + 1)
			else
				Silver = "00"
			end
		elseif Silver >= 50 then
			Copper = "00"
			Silver = "00"
			Gold = tostring(Gold + 1)
		else
			Copper = "00"
			Silver = "00"
		end
		if place then
			local startingGold = 0
			local tickets = 0
			local price = 0
			if PrevEvent then
				startingGold = tonumber(glrCharacter.PreviousEvent.Lottery.Settings.StartingGold)
				tickets = glrCharacter.PreviousEvent.Lottery.Settings.TicketsSold
				price = tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketPrice)
			else
				startingGold = tonumber(glrCharacter.Event.Lottery.StartingGold)
				tickets = glrCharacter.Event.Lottery.TicketsSold
				price = tonumber(glrCharacter.Event.Lottery.TicketPrice)
			end
			local jackpotGold = startingGold + ( tickets * price )
			local TotalGold = GetMoneyValue(jackpotGold, "Lottery", "Jackpot", false, false)
			local check, _ = string.gsub(string.gsub(TotalGold, ",", ""), L["Value_Gold_Short"], "")
			if tonumber(string.sub(check, string.len(check), string.len(check))) >= 5 and tonumber(check) >= 12 then
				Gold = tostring(Gold + 1)
			else
				Gold = tostring(Gold)
			end
		else
			Gold = tostring(Gold)
		end
	end
	
	if tonumber(Copper) == 0 then
		if tonumber(Silver) == 0 then
			if tonumber(Gold) > 0 then
				Gold = CommaValue(Gold)
				total = Gold .. L["Value_Gold_Short"]
			else
				total = Gold .. L["Value_Gold_Short"] .. " " .. Silver .. L["Value_Silver_Short"] .. " " .. Copper .. L["Value_Copper_Short"]
			end
		else
			if tonumber(Gold) == 0 then
				total = Silver .. L["Value_Silver_Short"]
			else
				Gold = CommaValue(Gold)
				total = Gold .. L["Value_Gold_Short"] .. " " .. Silver .. L["Value_Silver_Short"]
			end
		end
	else
		if tonumber(Silver) == 0 then
			if tonumber(Gold) == 0 then
				total = Copper .. L["Value_Copper_Short"]
			else
				Gold = CommaValue(Gold)
				total = Gold .. L["Value_Gold_Short"] .. " " .. Copper .. L["Value_Copper_Short"]
			end
		else
			if tonumber(Gold) == 0 then
				total = Silver .. L["Value_Silver_Short"] .. " " .. Copper .. L["Value_Copper_Short"]
			else
				Gold = CommaValue(Gold)
				total = Gold .. L["Value_Gold_Short"] .. " " .. Silver .. L["Value_Silver_Short"] .. " " .. Copper .. L["Value_Copper_Short"]
			end
		end
	end
	return total
end

local DataString = ""
local function GetDataString(ExportType)
	local UnsoldTickets = 0
	for i = 1, #glrCharacter.PreviousEvent[ExportType].Data.TicketPool do
		UnsoldTickets = UnsoldTickets + 1
	end
	--UnsoldTickets = tostring(UnsoldTickets)
	local t = {}
	for i = 1, #glrCharacter.PreviousEvent[ExportType].Data.Entries.Names do
		table.insert(t, glrCharacter.PreviousEvent[ExportType].Data.Entries.Names[i])
	end
	sort(t)
	if ExportType == "Lottery" then
		local round = glrCharacter.PreviousEvent[ExportType].Settings.RoundJackpot
		local WinStatus = glrCharacter.PreviousEvent[ExportType].Settings.WonType
		local jackpotGold = tostring( tonumber(glrCharacter.PreviousEvent[ExportType].Settings.StartingGold) + tonumber(glrCharacter.PreviousEvent[ExportType].Settings.TicketPrice) * tonumber(glrCharacter.PreviousEvent[ExportType].Settings.TicketsSold) )
		local secondPlaceGold = glrCharacter.PreviousEvent[ExportType].Settings.SecondPlace
		if tonumber(glrCharacter.PreviousEvent[ExportType].Settings.SecondPlace) ~= nil then
			secondPlaceGold = tostring( ( ( tonumber(glrCharacter.PreviousEvent[ExportType].Settings.StartingGold) + tonumber(glrCharacter.PreviousEvent[ExportType].Settings.TicketPrice) * tonumber(glrCharacter.PreviousEvent[ExportType].Settings.TicketsSold) ) * ( tonumber(glrCharacter.PreviousEvent[ExportType].Settings.SecondPlace) / 100 ) ) )
		end
		local startingGold = glrCharacter.PreviousEvent[ExportType].Settings.StartingGold
		local ticketPrice = glrCharacter.PreviousEvent[ExportType].Settings.TicketPrice
		local jackpot = GetMoneyValue(jackpotGold, "Lottery", "Jackpot", round, true)
		local start = GetMoneyValue(startingGold, "", "", false, true)
		local ticketPrices = GetMoneyValue(ticketPrice, "", "", false, true)
		local second = secondPlaceGold
		if tonumber(secondPlaceGold) ~= nil then
			second = GetMoneyValue(secondPlaceGold, "Lottery", "Jackpot", round, true)
		end
		local GuildAmount = tostring( ( ( tonumber(glrCharacter.PreviousEvent[ExportType].Settings.StartingGold) + tonumber(glrCharacter.PreviousEvent[ExportType].Settings.TicketPrice) * tonumber(glrCharacter.PreviousEvent[ExportType].Settings.TicketsSold) ) * ( tonumber(glrCharacter.PreviousEvent[ExportType].Settings.GuildCut) / 100 ) ) )
		local NoGuildAmount = glrCharacter.PreviousEvent[ExportType].Settings.NoGuildCut
		local WonAmount = ""
		local WonValue = ""
		DataString = '"' .. "Player Name" .. '","' .. "Date" .. '","' .. "Ticket Price" .. '","' .. "Tickets" .. '","' .. "Max Tickets" .. '","' .. "Starting Amount" .. '","' .. "Jackpot" .. '","' .. "Second Place" .. '","' .. "Ticket Series" .. '","' .. "Winning #" .. '","' .. "Unsold Tickets" .. '"'
		DataString = DataString .. '\n"' .. "Event Info For: " .. glrCharacter.PreviousEvent[ExportType].Settings.EventName .. '","' .. glrCharacter.PreviousEvent[ExportType].Settings.Date .. '","' .. ticketPrices .. '","' .. "Sold: " .. tostring(glrCharacter.PreviousEvent[ExportType].Settings.TicketsSold) .. " Given: " .. tostring(glrCharacter.PreviousEvent[ExportType].Settings.GiveAwayTickets) .. '","' .. glrCharacter.PreviousEvent[ExportType].Settings.MaxTickets .. '","' .. start .. '","' .. jackpot .. '","' .. second .. '","' .. tostring(glrCharacter.PreviousEvent[ExportType].Settings.FirstTicketNumber) .. '","' .. glrCharacter.PreviousEvent[ExportType].Data.Winner .. '","' .. UnsoldTickets .. '"'
		local WinnerFound = false
		for i = 1, #t do
			local Winner = false
			local name = t[i]
			local tickets = tostring(glrCharacter.PreviousEvent[ExportType].Data.Entries.Tickets[name].NumberOfTickets)
			local range = tostring(glrCharacter.PreviousEvent[ExportType].Data.Entries.TicketRange[name].LowestTicketNumber) .. "-" .. tostring(glrCharacter.PreviousEvent[ExportType].Data.Entries.TicketRange[name].HighestTicketNumber)
			if not WinnerFound then -- Saves on processing power once the winner is found.
				for j = 1, #glrCharacter.PreviousEvent[ExportType].Data.Entries.TicketNumbers[name] do
					if glrCharacter.PreviousEvent[ExportType].Data.Entries.TicketNumbers[name][j] == glrCharacter.PreviousEvent[ExportType].Data.Winner then
						WonAmount = tostring(tonumber(jackpotGold) - (tonumber(jackpotGold) * (tonumber(glrCharacter.PreviousEvent[ExportType].Settings.GuildCut) / 100)))
						if not WinStatus then
							WonAmount = tostring(tonumber(jackpotGold) * (tonumber(glrCharacter.PreviousEvent[ExportType].Settings.SecondPlace) / 100))
						end
						WonValue = GetMoneyValue(WonAmount, "Lottery", "Jackpot", round, true)
						Winner = true
						WinnerFound = true
						break
					end
				end
			end
			if Winner then
				DataString = DataString .. '\n"' .. name .. '","","","' .. tickets .. '","","","","","' .. range .. '","Winner!","' .. WonValue .. '"'
			else
				DataString = DataString .. '\n"' .. name .. '","","","' .. tickets .. '","","","","","' .. range .. '","",""'
			end
		end
		if not WinnerFound and NoGuildAmount then
			GuildAmount = "0"
		end
		GuildValue = GetMoneyValue(GuildAmount, "Lottery", "Jackpot", round, true)
		DataString = DataString .. '\n"","","","","","","","","","Guilds Cut:","' .. GuildValue .. '"'
	elseif ExportType == "Raffle" then
		DataString = '"' .. "Player Name" .. '","' .. "Date" .. '","' .. "Ticket Price" .. '","' .. "Tickets" .. '","' .. "Max Tickets" .. '","' .. "First Place (#)" .. '","' .. "Second Place (#)" .. '","' .. "Third Place(#)" .. '","' .. "Ticket Series" .. '","' .. "Winner(s)" .. '","' .. "Unsold Tickets" .. '"'
		local Second = "None"
		local Third = "None"
		local Max = 1
		if glrCharacter.PreviousEvent[ExportType].Settings.SecondPlace ~= false then
			Second = glrCharacter.PreviousEvent[ExportType].Settings.SecondPlace .. " (" .. glrCharacter.PreviousEvent[ExportType].Data.SecondWinner .. ")"
			Max = Max + 1
		end
		if glrCharacter.PreviousEvent[ExportType].Settings.ThirdPlace ~= false then
			Third = glrCharacter.PreviousEvent[ExportType].Settings.ThirdPlace .. " (" .. glrCharacter.PreviousEvent[ExportType].Data.SecondWinner .. ")"
			Max = Max + 1
		end
		DataString = DataString .. '\n"' .. "Event Info For: " .. glrCharacter.PreviousEvent[ExportType].Settings.EventName .. '","' .. glrCharacter.PreviousEvent[ExportType].Settings.Date .. '","' .. glrCharacter.PreviousEvent[ExportType].Settings.TicketPrice .. '","' .. "Sold: " .. tostring(glrCharacter.PreviousEvent[ExportType].Settings.TicketsSold) .. " Given: " .. tostring(glrCharacter.PreviousEvent[ExportType].Settings.GiveAwayTickets) .. '","' .. glrCharacter.PreviousEvent[ExportType].Settings.MaxTickets .. '","' .. glrCharacter.PreviousEvent[ExportType].Settings.FirstPlace .. " (" .. glrCharacter.PreviousEvent[ExportType].Data.FirstWinner .. ")" .. '","' .. Second .. '","' .. Third .. '","' .. tostring(glrCharacter.PreviousEvent[ExportType].Settings.FirstTicketNumber) .. '","' .. Max .. '","' .. UnsoldTickets .. '"'
		local Winner = false
		local c = 0
		for i = 1, #t do
			local FirstFound = false
			local SecondFound = false
			local ThirdFound = false
			local name = t[i]
			local tickets = tostring(glrCharacter.PreviousEvent[ExportType].Data.Entries.Tickets[name].NumberOfTickets)
			local range = tostring(glrCharacter.PreviousEvent[ExportType].Data.Entries.TicketRange[name].LowestTicketNumber) .. "-" .. tostring(glrCharacter.PreviousEvent[ExportType].Data.Entries.TicketRange[name].HighestTicketNumber)
			if not Winner then -- Saves on processing power once the winner is found.
				for j = 1, #glrCharacter.PreviousEvent[ExportType].Data.Entries.TicketNumbers[name] do
					if glrCharacter.PreviousEvent[ExportType].Data.Entries.TicketNumbers[name][j] == glrCharacter.PreviousEvent[ExportType].Data.FirstWinner then
						FirstFound = true
						c = c + 1
					elseif glrCharacter.PreviousEvent[ExportType].Data.Entries.TicketNumbers[name][j] == glrCharacter.PreviousEvent[ExportType].Data.SecondWinner and glrCharacter.PreviousEvent[ExportType].Settings.SecondPlace ~= false then
						SecondFound = true
						c = c + 1
					elseif glrCharacter.PreviousEvent[ExportType].Data.Entries.TicketNumbers[name][j] == glrCharacter.PreviousEvent[ExportType].Data.ThirdWinner and glrCharacter.PreviousEvent[ExportType].Settings.ThirdPlace ~= false then
						ThirdFound = true
						c = c + 1
					end
				end
			end
			if c == Max then
				Winner = true
			end
			if FirstFound then
				DataString = DataString .. '\n"' .. name .. '","","","' .. tickets .. '","","","","","' .. range .. '","First Place!",""'
			elseif SecondFound then
				DataString = DataString .. '\n"' .. name .. '","","","' .. tickets .. '","","","","","' .. range .. '","Second Place!",""'
			elseif ThirdFound then
				DataString = DataString .. '\n"' .. name .. '","","","' .. tickets .. '","","","","","' .. range .. '","Third Place!",""'
			else
				DataString = DataString .. '\n"' .. name .. '","","","' .. tickets .. '","","","","","' .. range .. '","",""'
			end
		end
	end
	return DataString
end

function GLR:ExportData(ExportType)
	local function NOOP() return end
	StaticPopupDialogs["GLREXPORTLOTTERYDATA"] = StaticPopupDialogs["GLREXPORTLOTTERYDATA"] or {
		text = L["Data Export - Copy Text"],
		button1 = OKAY,
		hasEditBox = 1,
		OnShow = function(self, data)
			GetDataString(ExportType)
			self.editBox:SetScript('OnEditFocusGained', function(thisbox)
				thisbox:HighlightText(0, -1)
			end)
			self.editBox:SetText(DataString)
		end,
		OnHide = NOOP,
		OnAccept = NOOP,
		OnCancel = NOOP,
		EditBoxOnEscapePressed = function(self, ...) self:GetParent():Hide() end,
		EditBoxOnTextChanged = function(self, ...)
			self:SetText(DataString)
			self:SetFocus()
			self:HighlightText()
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1
	}
	StaticPopup_Show("GLREXPORTLOTTERYDATA")
end

local GLR_AddOnMessageTable = { ["ActiveEvents"] = { ["Lottery"] = {}, ["Raffle"] = {} }, ["HasMod"] = { [1] = FullPlayerName .. "!" .. GLR_VersionString } }
local GLR_AddOnMessages = CreateFrame("Frame")
GLR_AddOnMessages:RegisterEvent("CHAT_MSG_ADDON")
GLR_AddOnMessages:SetScript("OnEvent", function(self, event, prefix, message, channel, sender)
	if event == "CHAT_MSG_ADDON" and channel == "GUILD" and message ~= nil and sender ~= nil then
		if prefix == "GLR_DEBUG" then
			if string.find(message, "%%Addon_Author") then
				C_ChatInfo.SendAddonMessage("GLR_DEBUG", FullPlayerName .. " Debug Comm Received", "GUILD")
			else
				GLR:Print("Debug Comm Received")
			end
		end
		if prefix == "GLR_LOGIN" then
			for i = 1, #GLR_AddOnMessageTable.HasMod do
				local name = string.sub(GLR_AddOnMessageTable.HasMod[i], 1, string.find(GLR_AddOnMessageTable.HasMod[i], '%!') - 1)
				if name == sender and name ~= FullPlayerName then
					table.remove(GLR_AddOnMessageTable.HasMod, i)
					break
				end
			end
		end
		if prefix == "GLR_LOGOUT" then
			for i = 1, #GLR_AddOnMessageTable.HasMod do
				local name = string.sub(GLR_AddOnMessageTable.HasMod[i], 1, string.find(GLR_AddOnMessageTable.HasMod[i], '%!') - 1)
				if name == sender then
					table.remove(GLR_AddOnMessageTable.HasMod, i)
					break
				end
			end
		end
		if prefix == "GLR_HASMOD" then
			local continue = true
			for i = 1, #GLR_AddOnMessageTable.HasMod do
				local name = string.sub(GLR_AddOnMessageTable.HasMod[i], 1, string.find(GLR_AddOnMessageTable.HasMod[i], '%!') - 1)
				if name == sender then
					continue = false
					break
				end
			end
			if continue then
				local UserVersion = string.sub(message, 1, string.find(message, '?') - 1)
				table.insert(GLR_AddOnMessageTable.HasMod, sender .. "!" .. UserVersion)
				if tonumber(UserVersion) < tonumber(GLR_VersionString) then
					local AlertUser = "|cfff7ff4d" .. string.gsub(L["GLR_AddOn_Communication_Others_VersionOutdated"], "%%name", sender) .. "|r"
					GLR:Print(AlertUser)
				elseif tonumber(UserVersion) > tonumber(GLR_VersionString) then
					local AlertUser = "|cfff7ff4d" ..  string.gsub(string.gsub(L["GLR_AddOn_Communication_Your_VersionOutdated"], "%%version_current", GLR_Version), "%%version_new", string.sub(message, string.find(message, '?') + 1)) .. "|r"
					GLR:Print(AlertUser)
				end
				C_ChatInfo.SendAddonMessage("GLR_HASMOD", GLR_VersionString .. "?" .. GLR_Version, "GUILD")
			end
		end
		if prefix == "GLR_CHECK" then
			if string.find(message, "%%lottery_true") then
				local continue = true
				for i = 1, #GLR_AddOnMessageTable.ActiveEvents.Lottery do
					if GLR_AddOnMessageTable.ActiveEvents.Lottery[i] == sender then
						continue = false
						break
					end
				end
				if continue then
					table.insert(GLR_AddOnMessageTable.ActiveEvents.Lottery, sender)
				end
			elseif string.find(message, "%%lottery_false") then
				for i = 1, #GLR_AddOnMessageTable.ActiveEvents.Lottery do
					if GLR_AddOnMessageTable.ActiveEvents.Lottery[i] == sender then
						table.remove(GLR_AddOnMessageTable.ActiveEvents.Lottery, i)
					end
				end
			end
			if string.find(message, "%%raffle_true") then
				local continue = true
				for i = 1, #GLR_AddOnMessageTable.ActiveEvents.Raffle do
					if GLR_AddOnMessageTable.ActiveEvents.Raffle[i] == sender then
						continue = false
						break
					end
				end
				if continue then
					table.insert(GLR_AddOnMessageTable.ActiveEvents.Raffle, sender)
				end
			elseif string.find(message, "%%raffle_false") then
				for i = 1, #GLR_AddOnMessageTable.ActiveEvents.Raffle do
					if GLR_AddOnMessageTable.ActiveEvents.Raffle[i] == sender then
						table.remove(GLR_AddOnMessageTable.ActiveEvents.Raffle, i)
					end
				end
			end
			if GLR_AddOnMessageTable.ActiveEvents.Lottery[1] ~= nil then
				sort(GLR_AddOnMessageTable.ActiveEvents.Lottery)
			end
			if GLR_AddOnMessageTable.ActiveEvents.Raffle[1] ~= nil then
				sort(GLR_AddOnMessageTable.ActiveEvents.Raffle)
			end
		end
	end
end)

--Purpose: To facilitate the transfer of the old Saved Data structure.
--Should be kept as a permanent function, to only be considered for removal at the launch of the next WoW Expansion after BfA.
local function GLR_TransferTables()
	if glrEvents ~= nil then
		for t, v in pairs(glrEvents) do
			if t == "Lottery" then
				for k, j in pairs(glrEvents[t]) do
					if k == "LotteryDate" then
						glrCharacter.Event.Lottery["Date"] = j
					elseif k == "LotteryName" then
						glrCharacter.Event.Lottery["EventName"] = j
					else
						glrCharacter.Event.Lottery[k] = j
					end
				end
			end
			if t == "Raffle" then
				for k, j in pairs(glrEvents[t]) do
					if k == "RaffleDate" then
						glrCharacter.Event.Raffle["Date"] = j
					elseif k == "RaffleName" then
						glrCharacter.Event.Raffle["EventName"] = j
					else
						glrCharacter.Event.Raffle[k] = j
					end
				end
			end
		end
	end
	if glrRaffleData ~= nil then
		glrCharacter.Data.Raffle = glrRaffleData
	end
	if glrProfile ~= nil then
		for t, v in pairs(glrProfile.Settings) do
			if t ~= "Profile" and t ~= "PreviousLottery" then
				glrCharacter.Data.Settings[t] = v
			elseif t == "Profile" then
				for k, j in pairs(glrProfile.Settings[t]) do
					for x, y in pairs(glrProfile.Settings[t][k]) do
						glrCharacter.Data.Settings[t][k][x] = y
					end
				end
			elseif t == "PreviousLottery" then
				for k, j in pairs(glrProfile.Settings[t]) do
					glrCharacter.Data.Settings[t][k] = j
				end
			end
		end
	end
	if glrLotteryEntries ~= nil then
		if glrLotteryEntries.Lottery ~= nil then
			glrCharacter.Lottery.Entries = glrLotteryEntries.Lottery
		end
	end
	if glrRaffleEntries ~= nil then
		if glrRaffleEntries.Raffle ~= nil then
			glrCharacter.Raffle.Entries = glrRaffleEntries.Raffle
		end
	end
	if glrTicketPool ~= nil then
		if glrTicketPool.Lottery ~= nil then
			glrCharacter.Lottery.TicketPool = glrTicketPool.Lottery
		end
		if glrTicketPool.Raffle ~= nil then
			glrCharacter.Raffle.TicketPool = glrTicketPool.Raffle
		end
	end
	if glrMessageStatus ~= nil then
		if glrMessageStatus.Lottery ~= nil then
			glrCharacter.Lottery.MessageStatus = glrMessageStatus.Lottery
		end
		if glrMessageStatus.Raffle ~= nil then
			glrCharacter.Raffle.MessageStatus = glrMessageStatus.Raffle
		end
	end
end

local function GenerateRosterNames()
	local t = {}
	local status = glrCharacter.Data.Settings.MultiGuild
	if glrRosterTotal == 0 then
		if not status then
			GLR_U:UpdateRosterTable()
		else
			GLR_U:PopulateMultiGuildTable()
		end
	end
	if not status then
		for i = 1, #glrRoster do
			local text = glrRoster[i]
			local playerName = string.sub(text, 1, string.find(text, '%[') - 1)
			local playerLevel = string.sub(text, string.find(text, '%(') + 1, string.find(text, '%)') - 1)
			playerName = strjoin(".", playerName, playerLevel)
			table.insert(t, playerName)
		end
	else
		for i = 1, #glrMultiGuildRoster do
			local text = glrMultiGuildRoster[i]
			local playerName = string.sub(text, 1, string.find(text, '%[') - 1)
			local playerLevel = string.sub(text, string.find(text, '%(') + 1, string.find(text, '%)') - 1)
			playerName = strjoin(".", playerName, playerLevel)
			table.insert(t, playerName)
		end
	end
	sort(t)
	return t
end

local function SendRequestedInfo(sender, target, state)
	local continue = false
	local active = false
	local list = {}
	local c = 0
	if state == "Lottery" and glrCharacter.Data.Settings.CurrentlyActiveLottery then
		active = true
	elseif state == "Raffle" and glrCharacter.Data.Settings.CurrentlyActiveRaffle then
		active = true
	end
	if target ~= "" and active then
		if string.find(target, "-") then
			for t, v in pairs(glrCharacter[state].Entries.Names) do
				if v == target then
					continue = true
					break
				end
			end
			if not continue then
				local message = string.gsub(L["Detect Other Event: No One Found"], "%%target", target)
				SendChatMessage(message, "WHISPER", nil, sender)
			end
		else
			for t, v in pairs(glrCharacter[state].Entries.Names) do
				if string.find(string.lower(v), string.lower(target)) then
					table.insert(list, v)
					c = c + 1
				end
			end
			if c == 1 then
				target = list[c]
				continue = true
			else
				if c == 0 then
					local message = string.gsub(L["Detect Other Event: No One Found"], "%%target", target)
					SendChatMessage(message, "WHISPER", nil, sender)
				else
					local message = string.gsub(string.gsub(string.gsub(L["Detect Other Event: Multiple Found"], "%%target", target), "%%event", string.lower(L[state])), "%%host", FullPlayerName)
					SendChatMessage(message, "WHISPER", nil, sender)
				end
			end
		end
	else
		if target == "" and active then
			local InvalidMessage = string.gsub(string.gsub(L["Detect Other Event: No Valid Text"], "%%event", string.lower(L[state])), "%%host", PlayerName)
			SendChatMessage(InvalidMessage, "WHISPER", nil, sender)
		else
			local InactiveMessage = string.gsub(L["Send Info No Active Event"], "%%event", L[state])
			SendChatMessage(InactiveMessage, "WHISPER", nil, sender)
		end
	end
	if continue then
		local Tickets = tostring(glrCharacter[state].Entries.Tickets[target].NumberOfTickets)
		local LowEnd = tostring(glrCharacter[state].Entries.TicketRange[target].LowestTicketNumber)
		local HighEnd = tostring(glrCharacter[state].Entries.TicketRange[target].HighestTicketNumber)
		local message = string.gsub(string.gsub(string.gsub(string.gsub(string.gsub(L["Detect Other Event: Target Found"], "%%target", target), "%%num", Tickets), "%%e", state), "%%low", LowEnd), "%%high", HighEnd)
		
		SendChatMessage(message, "WHISPER", nil, sender)
		
		if glrCharacter.Data.OtherStatus[state][target] == nil then
			glrCharacter.Data.OtherStatus[state][target] = { ["Requesters"] = sender, ["sentMessage"] = false }
		else
			local senders = glrCharacter.Data.OtherStatus[state][target].Requesters
			if senders ~= sender then
				if not string.find(string.lower(senders), string.lower(sender)) then
					senders = glrCharacter.Data.OtherStatus[state][target].Requesters .. ", " .. sender
				end
			end
			glrCharacter.Data.OtherStatus[state][target] = { ["Requesters"] = senders, ["sentMessage"] = false }
		end
		
	end
	C_Timer.After(2, function(self) DetectOtherPhrases = true end)
end

local function SendTicketHolderNotification(key, names, t, TargetName)
	local status = glrCharacter.Data.Settings.MultiGuild
	local continue = true
	if status then
		local online = TargetName.Online
		if not online then
			continue = false
		end
	end
	if continue then
		local message = string.gsub(string.gsub(L["Detect Other Event: Notify Player (short msg)"], "%%users", names), "%%e", t)
		local length = string.len(message)
		if length >= 255 then
			local LongMsg = string.gsub(L["Detect Other Event: Notify Player (long msg)"], "%%e", t)
			local ta = {}
			local lt = {}
			local bypass = true
			local done = false
			local mnt = 0
			local nm = 0
			local steps = 4
			
			SendChatMessage(LongMsg, "WHISPER", nil, key)
			
			for v in string.gmatch(names, "[^, ]+") do
				table.insert(ta, v)
				mnt = mnt + 1
			end
			
			sort(ta)
			
			for i = 1, #ta do --Recursive loop to search if multiple instances of the same name exist, and remove one of them. No break point in case more than two copies exist.
				for j = i + 1, #ta do
					if ta[i] == ta[j] then
						table.remove(ta, j)
					end
				end
			end
			
			local ts = ta[1]
			table.remove(ta, 1)
			
			if mnt >= 10 then
				bypass = false
			end
			
			for i = 1, #ta do
				
				for j = 1, steps do
					if length > 0 or not done then
						if ta[1] == nil then
							break
						end
						if ta[2] == nil then
							ts = strjoin(", & ", ts, ta[1])
							table.remove(ta, 1)
						else
							ts = strjoin(", ", ts, ta[1])
							table.remove(ta, 1)
						end
					end
				end
				
				if not done then
					nm = nm + 1
					if not bypass then
						table.insert(lt, ts)
					end
					length = length - string.len(ts)
				end
				
				if bypass then
					SendChatMessage(ts, "WHISPER", nil, key)
				end
				
				if ta[1] == nil then
					done = true
				end
				
				if done then
					break
				end
				
				ts = ta[1]
				table.remove(ta, 1)
				
			end
			
			if not bypass then
				local ms = 0.25
				sort(lt)
				for i = 1, nm do
					C_Timer.After(ms, function(self)
						SendChatMessage(lt[1], "WHISPER", nil, key)
						table.remove(lt, 1)
					end)
					ms = ms + 0.25
					if lt[1] == nil then
						break
					end
				end
			end
			
		else
			local ta = {}
			
			for v in string.gmatch(names, "[^, ]+") do
				table.insert(ta, v)
			end
			
			for i = 1, #ta do --Recursive loop to search if multiple instances of the same name exist, and remove one of them. No break point in case more than two copies exist.
				for j = i + 1, #ta do
					if ta[i] == ta[j] then
						table.remove(ta, j)
					end
				end
			end
			
			sort(ta)
			
			local ts = ta[1]
			table.remove(ta, 1)
			
			for i = 1, #ta do
				if ta[i + 1] == nil then
					ts = strjoin(", & ", ts, ta[i])
					break
				else
					ts = strjoin(", ", ts, ta[i])
				end
			end
			
			local msg = string.gsub(string.gsub(L["Detect Other Event: Notify Player (short msg)"], "%%users", ts), "%%e", t)
			
			SendChatMessage(msg, "WHISPER", nil, key)
		end
		glrCharacter.Data.OtherStatus[t][key] = nil
	end
end

--------------------------------------------- ---------
----------- SLASH COMMAND HANDLER -----------
---------------------------------------------
----- TELLS THE MOD WHAT TO LISTEN FOR ------
---------------------------------------------

function GLR:SlashCommands(input)
	
	local text = string.lower(input)
	
	local command,value,_ = strsplit(" ", text)
	
	local CheckGuild = GLR_U:CheckGuildName()
	
	if command == "open" or command == "" then
		self:ShowGLRFrame()
	end
	
	if command == "help" then
		
		if CheckGuild then
			GLR_U:UpdateInfo(false)
		end
		
		if GLR_UI.GLR_MainFrame:IsVisible() == true then
			GLR_UI.GLR_MainFrame:Hide()
		end
		GLR_U:GetLinkedNames()
		GLR_U:GetLinkedGuilds()
		GLR_U:UpdateMultiGuildTable()
		--Done twice to go to the correct config window, a 3rd time just in case
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
		
	end
	
	if command == "config" or command == "opt" or command == "options" or command == "option" then
		
		if CheckGuild then
			GLR_U:UpdateInfo(false)
		end
		
		if GLR_UI.GLR_MainFrame:IsVisible() == true then
			GLR_UI.GLR_MainFrame:Hide()
		end
		GLR_U:GetLinkedNames()
		GLR_U:GetLinkedGuilds()
		GLR_U:UpdateMultiGuildTable()
		--Done twice to go to the correct config window, a 3rd time just in case
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.general)
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.general)
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.general)
		
	end
	
	if command == "events" or command == "event" then
		
		if CheckGuild then
			GLR_U:UpdateInfo(false)
		end
		
		if GLR_UI.GLR_MainFrame:IsVisible() == true then
			GLR_UI.GLR_MainFrame:Hide()
		end
		GLR_U:GetLinkedNames()
		GLR_U:GetLinkedGuilds()
		GLR_U:UpdateMultiGuildTable()
		--Done twice to go to the correct config window, a 3rd time just in case
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.events)
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.events)
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.events)
		
	end
	
	if command == "profiles" or command == "profile" then
		
		if CheckGuild then
			GLR_U:UpdateInfo(false)
		end
		
		if GLR_UI.GLR_MainFrame:IsVisible() == true then
			GLR_UI.GLR_MainFrame:Hide()
		end
		GLR_U:GetLinkedNames()
		GLR_U:GetLinkedGuilds()
		GLR_U:UpdateMultiGuildTable()
		--Done twice to go to the correct config window, a 3rd time just in case
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.profiles)
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.profiles)
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.profiles)
		
	end
	
	if command == "messages" or command == "message" then
		
		if CheckGuild then
			GLR_U:UpdateInfo(false)
		end
		
		if GLR_UI.GLR_MainFrame:IsVisible() == true then
			GLR_UI.GLR_MainFrame:Hide()
		end
		GLR_U:GetLinkedNames()
		GLR_U:GetLinkedGuilds()
		GLR_U:UpdateMultiGuildTable()
		--Done twice to go to the correct config window, a 3rd time just in case
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.messages)
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.messages)
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.messages)
		
	end
	
	if command == "giveaway" or command == "give" then
		
		if CheckGuild then
			GLR_U:UpdateInfo(false)
		end
		
		if GLR_UI.GLR_MainFrame:IsVisible() == true then
			GLR_UI.GLR_MainFrame:Hide()
		end
		GLR_U:GetLinkedNames()
		GLR_U:GetLinkedGuilds()
		GLR_U:UpdateMultiGuildTable()
		--Done twice to go to the correct config window, a 3rd time just in case
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.giveaway)
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.giveaway)
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.giveaway)
		
	end
	
	if command == "export" then
		local continue = false
		local complete = false
		local Export = "Lottery"
		local DoCommand = string.lower(string.sub(text, string.find(text, "export") + 7))
		if DoCommand == string.lower(L["Lottery"]) or DoCommand == "lottery" then
			Export = "Lottery"
			complete = true
			if glrCharacter.PreviousEvent.Lottery.Available then
				continue = true
			end
		elseif DoCommand == string.lower(L["Raffle"]) or DoCommand == "raffle" then
			Export = "Raffle"
			complete = true
			if glrCharacter.PreviousEvent.Raffle.Available then
				continue = true
			end
		end
		if continue then
			GLR:ExportData(Export)
		elseif complete then
			local message = string.gsub("Invalid Command. No Previous %e Event Data Available.", "%%e", Export)
			GLR:Print(message)
		else
			local message = string.gsub("Incomplete Command. Valid: /glr export %e", "%%e", string.lower(L[Export]))
			GLR:Print(message)
		end
	end
	
end

function GLR:MinimapIconFunction(button)
	
	local CTRL = IsControlKeyDown()
	
	if button == "LeftButton" then
		if not CTRL then
			GLR:ShowGLRFrame()
		elseif CTRL then
			GLR:AlertGuild()
		end
	end
	
	if button == "RightButton" then
		if not CTRL then
			local CheckGuild = GLR_U:CheckGuildName()
			if CheckGuild then
				GLR_U:UpdateInfo(false)
			end
			if GLR_UI.GLR_MainFrame:IsVisible() then
				GLR_UI.GLR_MainFrame:Hide()
			end
			GLR_U:GetLinkedNames()
			GLR_U:GetLinkedGuilds()
			GLR_U:UpdateMultiGuildTable()
			InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
			InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
			InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
		end
	end
	
end

--------------------------------------------- ---------
----------------- ON ENABLE -----------------
---------------------------------------------
----- THE MOD NEEDS TO DO CERTAIN THINGS ----
---------- WHEN IT BECOMES ENABLED ----------
---------------------------------------------

function GLR:OnEnable()
	
	--self:RegisterEvent("CHAT_MSG_WHISPER")
	--self:RegisterEvent("CHAT_MSG_GUILD")
	--self:RegisterEvent("PLAYER_LOGOUT")
	--self:RegisterEvent("PLAYER_LOGIN")
	
end

function GLR:OnInitialize()
	
	-- initialize configuration options
	self.options = GLR_O:OptionsTable()
	configUI:RegisterOptionsTable("GuildLotteryRaffle", self.options)
	self.optionsFrame = dialog:AddToBlizOptions("GuildLotteryRaffle", "Guild Lottery & Raffles", nil, "glrInfo")
	self.optionsFrame.general = dialog:AddToBlizOptions("GuildLotteryRaffle", L["Configuration Panel Options Tab"], "Guild Lottery & Raffles", "generalOptions")
	self.optionsFrame.events = dialog:AddToBlizOptions("GuildLotteryRaffle", L["Configuration Panel Events Tab"], "Guild Lottery & Raffles", "eventSettings")
	self.optionsFrame.profiles = dialog:AddToBlizOptions("GuildLotteryRaffle", L["Configuration Panel Profiles Tab"], "Guild Lottery & Raffles", "profileOptions")
	self.optionsFrame.messages = dialog:AddToBlizOptions("GuildLotteryRaffle", L["Configuration Panel Message Tab"], "Guild Lottery & Raffles", "messageOptions")
	self.optionsFrame.giveaway = dialog:AddToBlizOptions("GuildLotteryRaffle", L["Configuration Panel Giveaway Tab"], "Guild Lottery & Raffles", "giveawayOptions")
	
	-- registers custom slash commands (see function for details)
	GLR:RegisterChatCommand('glr', 'SlashCommands')
	
end

function GLR:PLAYER_LOGIN()
	
	for t, v in pairs(glrHistory.TransferAvailable) do
		for k, v in pairs(glrHistory.TransferAvailable[t]) do
			if glrHistory.TransferAvailable[t][k] then
				if t == "Lottery" then
					if glrHistory.TransferData[k].Data.Settings.NoGuildCut == nil then
						glrHistory.TransferData[k].Data.Settings.NoGuildCut = false
					end
				end
			end
		end
	end
	
	if glrHistory.Profile ~= nil then
		if glrHistory.Profile.Messages.Raffle ~= nil then
			for t, v in pairs(glrHistory.Profile.Messages.Raffle) do
				for i = 1, #glrHistory.Profile.Messages.Raffle[t] do
					if i == 8 and glrHistory.Profile.Messages.Raffle[t][i] == false then
						glrHistory.Profile.Messages.Raffle[t][7] = L["Raffle Draw Step 1"] .. ": %raffle_prizes"
						glrHistory.Profile.Messages.Raffle[t][8] = L["Alert Guild Whisper For Raffle Info"]
						glrHistory.Profile.Messages.Raffle[t][9] = false
					end
				end
			end
		end
	end
	
	if glrHistory.TransferStatus ~= nil then
		if glrHistory.TransferStatus.Lottery[FullPlayerName] then
			glrCharacter.Data.Settings.CurrentlyActiveLottery = false
			glrCharacter.Data.OtherStatus.Lottery = {}
			glrCharacter.Event.Lottery = {}
			glrCharacter.Lottery = { ["MessageStatus"] = {}, ["TicketPool"] = {}, ["Entries"] = { ["TicketNumbers"] = {}, ["TicketRange"] = {}, ["Tickets"] = {}, ["Names"] = {}, } }
			glrHistory.TransferStatus.Lottery[FullPlayerName] = false
			glrHistory.TransferAvailable.Lottery[FullPlayerName] = false
		end
		if glrHistory.TransferStatus.Raffle[FullPlayerName] then
			glrCharacter.Data.Settings.CurrentlyActiveRaffle = false
			glrCharacter.Data.OtherStatus.Raffle = {}
			glrCharacter.Data.Raffle = { ["FirstPrizeData"] = { ["ItemLink"] = {}, ["ItemName"] = {}, }, ["SecondPrizeData"] = { ["ItemLink"] = {}, ["ItemName"] = {}, }, ["ThirdPrizeData"] = { ["ItemLink"] = {}, ["ItemName"] = {}, }, }
			glrCharacter.Event.Raffle = {}
			glrCharacter.Raffle = { ["MessageStatus"] = {}, ["TicketPool"] = {}, ["Entries"] = { ["TicketNumbers"] = {}, ["TicketRange"] = {}, ["Tickets"] = {}, ["Names"] = {}, } }
			glrHistory.TransferStatus.Raffle[FullPlayerName] = false
			glrHistory.TransferAvailable.Raffle[FullPlayerName] = false
		end
	end
	
	if glrCharacter.Data.Settings.CurrentlyActiveLottery then
		table.insert(GLR_AddOnMessageTable.ActiveEvents.Lottery, FullPlayerName)
	end
	if glrCharacter.Data.Settings.CurrentlyActiveRaffle then
		table.insert(GLR_AddOnMessageTable.ActiveEvents.Raffle, FullPlayerName)
	end
	
	C_ChatInfo.SendAddonMessage("GLR_LOGIN", FullPlayerName, "GUILD")
	C_Timer.After(10, function(self)
		local lottery = tostring(glrCharacter.Data.Settings.CurrentlyActiveLottery)
		local raffle = tostring(glrCharacter.Data.Settings.CurrentlyActiveRaffle)
		C_ChatInfo.SendAddonMessage("GLR_HASMOD", GLR_VersionString .. "?" .. GLR_Version, "GUILD")
		C_ChatInfo.SendAddonMessage("GLR_CHECK", "%lottery_" .. lottery .. "!%raffle_" .. raffle, "GUILD")
	end)
	
	if glrCharacter == nil then
		glrCharacter = {}
	end
	if glrCharacter.Data == nil then
		glrCharacter.Data = {}
	end
	if glrCharacter.Data.Settings == nil then
		glrCharacter.Data.Settings = {}
	end
	if glrCharacter.Data.Settings.Status == nil then
		glrCharacter.Data.Settings.Status = "Lottery"
	end
	if glrCharacter.Data.Settings.Status == "Lottery" then
		GLR_UI.GLR_MainFrame.GLR_RaffleFrame:Hide()
	elseif glrCharacter.Data.Settings.Status == "Raffle" then
		GLR_UI.GLR_MainFrame.GLR_LotteryFrame:Hide()
	end
	
	if glrCharacter.Event.Lottery.EventName ~= nil then
		if glrCharacter.Event.Lottery.GiveAwayTickets == nil then
			glrCharacter.Event.Lottery.GiveAwayTickets = 0
		end
	end
	if glrCharacter.Event.Raffle.EventName ~= nil then
		if glrCharacter.Event.Raffle.GiveAwayTickets == nil then
			glrCharacter.Event.Raffle.GiveAwayTickets = 0
		end
	end
	
	GLR:Initalize()
	
end

function GLR:PLAYER_LOGOUT()
	
	C_ChatInfo.SendAddonMessage("GLR_LOGOUT", FullPlayerName, "GUILD")
	
	local CheckGuild = GLR_U:CheckGuildName()
	local guildName, _, _, _ = GetGuildInfo("PLAYER")
	local EventStatus = false
	
	if glrCharacter.Data.Settings.CurrentlyActiveLottery then
		EventStatus = true
	elseif glrCharacter.Data.Settings.CurrentlyActiveRaffle then
		EventStatus = true
	end
	
	if guildName == nil and CheckGuild then
		guildName, _, _, _ = GetGuildInfo("PLAYER")
	end
	
	if glrHistory == nil then
		glrHistory = {}
	end
	
	if glrHistory.CharacterGuilds == nil then
		glrHistory.CharacterGuilds = {}
	end
	
	if guildName ~= nil then
		
		if glrCharacter.Data.Settings.GuildName == nil then
			glrCharacter.Data.Settings.GuildName = guildName
		elseif glrCharacter.Data.Settings.GuildName ~= guildName then
			glrCharacter.Data.Settings.GuildName = guildName
		end
		
	end
	
	if glrCharacter.Data.Settings.UserName == nil or glrCharacter.Data.Settings.UserName == "" or glrCharacter.Data.Settings.UserName ~= FullPlayerName then
		
		glrCharacter.Data.Settings.UserName = FullPlayerName
		
	end
	
	if glrHistory.Profile.Lottery[FullPlayerName] == nil then
		glrHistory.Profile.Lottery[FullPlayerName] = { ["StartingGold"] = "0", ["MaxTickets"] = "0", ["TicketPrice"] = "0", ["SecondPlace"] = "0", ["GuildCut"] = "0", ["Guaranteed"] = false }
	else
		local ProfileTable = glrCharacter.Data.Settings.Profile.Lottery
		glrHistory.Profile.Lottery[FullPlayerName] = ProfileTable
	end
	
	if glrHistory.Profile.Raffle[FullPlayerName] == nil then
		glrHistory.Profile.Raffle[FullPlayerName] = { ["MaxTickets"] = "0", ["TicketPrice"] = "0", ["InvalidItems"] = false }
	else
		local ProfileTable = glrCharacter.Data.Settings.Profile.Raffle
		glrHistory.Profile.Raffle[FullPlayerName] = ProfileTable
	end
	
	if glrHistory.Profile.Messages.Lottery[FullPlayerName] == nil then
		glrHistory.Profile.Messages.Lottery[FullPlayerName] = {}
		glrHistory.Profile.Messages.Lottery[FullPlayerName] = { [1] = L["Alert Guild GLR Title"], [2] = L["Alert Guild Lottery Scheduled"] .. ": %lottery_date", [3] = L["Lottery"] .. " " .. L["Alert Guild Event Name"] .. ": %lottery_name", [4] = L["Alert Guild Ticket Info Part 1"] .. " %lottery_price " .. L["Alert Guild Ticket Info Part 2"], [5] = L["Alert Guild Ticket Info Part 3"] .. " %lottery_max " .. L["Alert Guild Ticket Info Part 4"], [6] = L["Alert Guild Tickets Bought"] .. ": %lottery_gold", [7] = L["Alert Guild Whisper For Lottery Info"], [8] = false }
	else
		glrHistory.Profile.Messages.Lottery[FullPlayerName] = glrCharacter.Data.Messages.GuildAlerts.Lottery
	end
	
	if glrHistory.Profile.Messages.Raffle[FullPlayerName] == nil then
		glrHistory.Profile.Messages.Raffle[FullPlayerName] = {}
		glrHistory.Profile.Messages.Raffle[FullPlayerName] = { [1] = L["Alert Guild GLR Title"], [2] = L["Alert Guild Raffle Scheduled"] .. ": %raffle_date", [3] = L["Raffle"] .. " " .. L["Alert Guild Event Name"] .. ": %raffle_name", [4] = L["Alert Guild Ticket Info Part 1"] .. " %raffle_price " .. L["Alert Guild Ticket Info Part 2"], [5] = L["Alert Guild Ticket Info Part 3"]  .. " %raffle_max " .. L["Alert Guild Ticket Info Part 4"], [6] = "%raffle_gold " .. L["Alert Guild Raffle Tickets Bought"], [7] = L["Alert Guild Whisper For Raffle Info"], [8] = false }
	else
		glrHistory.Profile.Messages.Raffle[FullPlayerName] = glrCharacter.Data.Messages.GuildAlerts.Raffle
	end
	
	if glrHistory.Profile.Messages.Both[FullPlayerName] == nil then
		glrHistory.Profile.Messages.Both[FullPlayerName] = {}
		glrHistory.Profile.Messages.Both[FullPlayerName] = { [1] = L["Alert Guild GLR Title"], [2] = L["Alert Guild LaR Scheduled"] .. ":", [3] = L["Lottery"] .. ": %lottery_date, " .. L["Raffle"] .. ": %raffle_date", [4] = L["Lottery"] .. " " .. L["Alert Guild Event Name"] .. ": %lottery_name, " .. L["Raffle"] .. " " .. L["Alert Guild Event Name"] .. ": %raffle_name.", [5] = L["Lottery"] .. ": " .. L["Alert Guild Ticket Info Part 1"] .. " %lottery_price " .. L["Alert Guild Ticket Info Part 2"], [6] = L["Lottery"] .. ": " .. L["Alert Guild Ticket Info Part 3"] .. " %lottery_max " .. L["Alert Guild Ticket Info Part 4"], [7] = L["Lottery"] .. ": " .. L["Alert Guild Tickets Bought"] .. " %lottery_gold", [8] = L["Raffle"] .. ": " .. L["Alert Guild Ticket Info Part 1"] .. " %raffle_price " .. L["Alert Guild Ticket Info Part 2"], [9] = L["Raffle"] .. ": " .. L["Alert Guild Ticket Info Part 3"] .. " %raffle_max " .. L["Alert Guild Ticket Info Part 4"], [10] = L["Raffle"] .. ": %raffle_gold " .. L["Alert Guild Raffle Tickets Bought"], [11] = L["Alert Guild Whisper For LaR Info"], [12] = false }
	else
		glrHistory.Profile.Messages.Both[FullPlayerName] = glrCharacter.Data.Messages.GuildAlerts.Both
	end
	
	if glrHistory.ActiveEvents[FullPlayerName] == nil then
		glrHistory.ActiveEvents[FullPlayerName] = EventStatus
	else
		glrHistory.ActiveEvents[FullPlayerName] = EventStatus
	end
	
	if glrHistory.TransferData ~= nil then
		local t = {}
		local continue = false
		if glrCharacter.Data.Settings.CurrentlyActiveLottery or glrCharacter.Data.Settings.CurrentlyActiveRaffle then
			continue = true
		end
		glrHistory.TransferAvailable.Lottery[FullPlayerName] = glrCharacter.Data.Settings.CurrentlyActiveLottery
		glrHistory.TransferAvailable.Raffle[FullPlayerName] = glrCharacter.Data.Settings.CurrentlyActiveRaffle
		if continue then
			for key, val in pairs(glrCharacter) do
				if key == "Data" then
					if t[key] == nil then
						t[key] = {}
					end
					for k, v in pairs(glrCharacter[key]) do
						if k == "Raffle" and glrCharacter.Data.Settings.CurrentlyActiveRaffle then
							if t[key][k] == nil then
								t[key][k] = {}
							end
							t[key][k] = glrCharacter[key][k]
						elseif k == "Settings" then
							if t[key][k] == nil then
								t[key][k] = {}
							end
							if glrCharacter.Data.Settings.CurrentlyActiveLottery then
								t[key][k]["TicketSeries"] = glrCharacter[key][k].TicketSeries
								t[key][k]["NoGuildCut"] = glrCharacter[key][k].NoGuildCut
							end
							if glrCharacter.Data.Settings.CurrentlyActiveRaffle then
								t[key][k]["RaffleSeries"] = glrCharacter[key][k].RaffleSeries
								t[key][k]["AllowMultipleRaffleWinners"] = glrCharacter[key][k].AllowMultipleRaffleWinners
							end
							for n, u in pairs(glrCharacter[key][k]) do
								if n == "PreviousLottery" then
									if t[key][k][n] == nil then
										t[key][k][n] = {}
									end
									t[key][k][n] = glrCharacter[key][k][n]
								end
							end
						elseif k == "OtherStatus" then
							if t[key][k] == nil then
								t[key][k] = {}
							end
							t[key][k] = glrCharacter[key][k]
						end
					end
				elseif key == "Event" then
					if t[key] == nil then
						t[key] = {}
					end
					for k, v in pairs(glrCharacter[key]) do
						if k == "Lottery" and glrCharacter.Data.Settings.CurrentlyActiveLottery then
							if t[key][k] == nil then
								t[key][k] = {}
							end
							t[key][k] = glrCharacter[key][k]
						elseif k == "Raffle" and glrCharacter.Data.Settings.CurrentlyActiveRaffle then
							if t[key][k] == nil then
								t[key][k] = {}
							end
							t[key][k] = glrCharacter[key][k]
						end
					end
				elseif key == "Lottery" and glrCharacter.Data.Settings.CurrentlyActiveLottery then
					if t[key] == nil then
						t[key] = {}
					end
					for k, v in pairs(glrCharacter[key]) do
						if t[key][k] == nil then
							t[key][k] = {}
						end
						t[key][k] = glrCharacter[key][k]
					end
				elseif key == "Raffle" and glrCharacter.Data.Settings.CurrentlyActiveRaffle then
					if t[key] == nil then
						t[key] = {}
					end
					for k, v in pairs(glrCharacter[key]) do
						if t[key][k] == nil then
							t[key][k] = {}
						end
						t[key][k] = glrCharacter[key][k]
					end
				end
			end
			glrHistory.TransferData[FullPlayerName] = t
		else
			glrHistory.TransferData[FullPlayerName] = nil
		end
	end
	
	local numTotalMembers, _, _ = GetNumGuildMembers()
	local faction, _ = UnitFactionGroup("PLAYER")
	if glrHistory.GuildRanks[faction][guildName] ~= nil then
		local t = {}
		for i = 1 , GuildControlGetNumRanks() do
			t[i] = GuildControlGetRankName(i)
		end
		glrHistory.GuildRanks[faction][guildName] = t
	end
	
end

function GLR:Initalize()
	
	local faction, _ = UnitFactionGroup("PLAYER")
	local guildName, _, _, _ = GetGuildInfo("PLAYER")
	local dateTimeString = string.sub(date(), 1, string.find(date(), " ") - 1)
	local dateTime = time()
	local EventStatus = false
	
	if glrCharacter.Data.Settings.CurrentlyActiveLottery then
		EventStatus = true
	elseif glrCharacter.Data.Settings.CurrentlyActiveRaffle then
		EventStatus = true
	end
	
	if glrHistory == nil then
		glrHistory = {}
	end
	
	if glrHistory.CharacterGuilds == nil then
		glrHistory.CharacterGuilds = {}
	end
	
	if glrHistory.MultiGuildStatus == nil then
		glrHistory.MultiGuildStatus = {}
	end
	
	if glrHistory.GuildStatus == nil then
		glrHistory.GuildStatus = {}
	end
	
	if glrHistory.GuildStatus.Alliance == nil then
		glrHistory.GuildStatus.Alliance = {}
	end
	
	if glrHistory.GuildStatus.Horde == nil then
		glrHistory.GuildStatus.Horde = {}
	end
	
	if glrHistory.GuildRoster == nil then
		glrHistory.GuildRoster = {}
	end
	
	if glrHistory.GuildRoster.Alliance == nil then
		glrHistory.GuildRoster.Alliance = {}
	end
	
	if glrHistory.GuildRoster.Horde == nil then
		glrHistory.GuildRoster.Horde = {}
	end
	
	if glrHistory.GuildRanks == nil then
		glrHistory.GuildRanks = {}
	end
	
	if glrHistory.GuildRanks.Alliance == nil then
		glrHistory.GuildRanks.Alliance = {}
	end
	
	if glrHistory.GuildRanks.Horde == nil then
		glrHistory.GuildRanks.Horde = {}
	end
	
	if glrHistory.CrossFaction == nil then
		glrHistory.CrossFaction = {}
	end
	
	if glrHistory.ActiveEvents == nil then
		glrHistory.ActiveEvents = {}
	end
	
	if glrHistory.ActiveEvents[FullPlayerName] == nil then
		glrHistory.ActiveEvents[FullPlayerName] = EventStatus
	else
		glrHistory.ActiveEvents[FullPlayerName] = EventStatus
	end
	
	if glrHistory.PlayerFaction == nil then
		glrHistory.PlayerFaction = {}
	end
	
	if glrHistory.PlayerFaction[FullPlayerName] == nil then
		glrHistory.PlayerFaction[FullPlayerName] = {}
		glrHistory.PlayerFaction[FullPlayerName] = faction
	else
		local CheckFaction = glrHistory.PlayerFaction[FullPlayerName]
		if CheckFaction ~= faction then
			glrHistory.PlayerFaction[FullPlayerName] = faction --Redoes it in case a player changes faction.
		end
	end
	
	if glrHistory.GuildFaction == nil then
		glrHistory.GuildFaction = {}
	end
	
	if glrHistory.GuildFaction.Alliance == nil then
		glrHistory.GuildFaction.Alliance = {}
	end
	
	if glrHistory.GuildFaction.Horde == nil then
		glrHistory.GuildFaction.Horde = {}
	end
	
	if glrHistory.Profile == nil then
		glrHistory.Profile = {}
	end
	
	if glrHistory.Profile.Lottery == nil then
		glrHistory.Profile.Lottery = {}
	end
	
	if glrHistory.Profile.Raffle == nil then
		glrHistory.Profile.Raffle = {}
	end
	
	if glrHistory.Profile.Lottery[FullPlayerName] == nil then
		glrHistory.Profile.Lottery[FullPlayerName] = { ["StartingGold"] = "0", ["MaxTickets"] = "0", ["TicketPrice"] = "0", ["SecondPlace"] = "0", ["GuildCut"] = "0", ["Guaranteed"] = false }
	else
		local ProfileTable = glrCharacter.Data.Settings.Profile.Lottery
		glrHistory.Profile.Lottery[FullPlayerName] = ProfileTable
	end
	
	if glrHistory.Profile.Raffle[FullPlayerName] == nil then
		glrHistory.Profile.Raffle[FullPlayerName] = { ["MaxTickets"] = "0", ["TicketPrice"] = "0", ["InvalidItems"] = false }
	else
		local ProfileTable = glrCharacter.Data.Settings.Profile.Raffle
		glrHistory.Profile.Raffle[FullPlayerName] = ProfileTable
	end
	
	if glrHistory.Profile.Messages == nil then
		glrHistory.Profile.Messages = {}
	end
	
	if glrHistory.Profile.Messages.Lottery == nil then
		glrHistory.Profile.Messages.Lottery = {}
	end
	
	if glrHistory.Profile.Messages.Raffle == nil then
		glrHistory.Profile.Messages.Raffle = {}
	end
	
	if glrHistory.Profile.Messages.Both == nil then
		glrHistory.Profile.Messages.Both = {}
	end
	
	if glrHistory.Profile.Messages.Lottery[FullPlayerName] == nil then
		glrHistory.Profile.Messages.Lottery[FullPlayerName] = {}
		glrHistory.Profile.Messages.Lottery[FullPlayerName] = { [1] = L["Alert Guild GLR Title"], [2] = L["Alert Guild Lottery Scheduled"] .. ": %lottery_date", [3] = L["Lottery"] .. " " .. L["Alert Guild Event Name"] .. ": %lottery_name", [4] = L["Alert Guild Ticket Info Part 1"] .. " %lottery_price " .. L["Alert Guild Ticket Info Part 2"], [5] = L["Alert Guild Ticket Info Part 3"] .. " %lottery_max " .. L["Alert Guild Ticket Info Part 4"], [6] = L["Alert Guild Tickets Bought"] .. ": %lottery_gold", [7] = L["Alert Guild Whisper For Lottery Info"], [8] = false }
	else
		glrHistory.Profile.Messages.Lottery[FullPlayerName] = glrCharacter.Data.Messages.GuildAlerts.Lottery
	end
	
	if glrHistory.Profile.Messages.Raffle[FullPlayerName] == nil then
		glrHistory.Profile.Messages.Raffle[FullPlayerName] = {}
		glrHistory.Profile.Messages.Raffle[FullPlayerName] = { [1] = L["Alert Guild GLR Title"], [2] = L["Alert Guild Raffle Scheduled"] .. ": %raffle_date", [3] = L["Raffle"] .. " " .. L["Alert Guild Event Name"] .. ": %raffle_name", [4] = L["Alert Guild Ticket Info Part 1"] .. " %raffle_price " .. L["Alert Guild Ticket Info Part 2"], [5] = L["Alert Guild Ticket Info Part 3"]  .. " %raffle_max " .. L["Alert Guild Ticket Info Part 4"], [6] = "%raffle_gold " .. L["Alert Guild Raffle Tickets Bought"], [7] = L["Alert Guild Whisper For Raffle Info"], [8] = false }
	else
		glrHistory.Profile.Messages.Raffle[FullPlayerName] = glrCharacter.Data.Messages.GuildAlerts.Raffle
	end
	
	if glrHistory.Profile.Messages.Both[FullPlayerName] == nil then
		glrHistory.Profile.Messages.Both[FullPlayerName] = {}
		glrHistory.Profile.Messages.Both[FullPlayerName] = { [1] = L["Alert Guild GLR Title"], [2] = L["Alert Guild LaR Scheduled"] .. ":", [3] = L["Lottery"] .. ": %lottery_date, " .. L["Raffle"] .. ": %raffle_date", [4] = L["Lottery"] .. " " .. L["Alert Guild Event Name"] .. ": %lottery_name, " .. L["Raffle"] .. " " .. L["Alert Guild Event Name"] .. ": %raffle_name.", [5] = L["Lottery"] .. ": " .. L["Alert Guild Ticket Info Part 1"] .. " %lottery_price " .. L["Alert Guild Ticket Info Part 2"], [6] = L["Lottery"] .. ": " .. L["Alert Guild Ticket Info Part 3"] .. " %lottery_max " .. L["Alert Guild Ticket Info Part 4"], [7] = L["Lottery"] .. ": " .. L["Alert Guild Tickets Bought"] .. " %lottery_gold", [8] = L["Raffle"] .. ": " .. L["Alert Guild Ticket Info Part 1"] .. " %raffle_price " .. L["Alert Guild Ticket Info Part 2"], [9] = L["Raffle"] .. ": " .. L["Alert Guild Ticket Info Part 3"] .. " %raffle_max " .. L["Alert Guild Ticket Info Part 4"], [10] = L["Raffle"] .. ": %raffle_gold " .. L["Alert Guild Raffle Tickets Bought"], [11] = L["Alert Guild Whisper For LaR Info"], [12] = false }
	else
		glrHistory.Profile.Messages.Both[FullPlayerName] = glrCharacter.Data.Messages.GuildAlerts.Both
	end
	
	if glrCharacter == nil then
		glrCharacter = {}
	end
	
	if glrCharacter.Data == nil then
		glrCharacter.Data = {}
	end
	
	if glrCharacter.Data.Defaults == nil then
		glrCharacter.Data.Defaults = {}
	end
	
	if glrCharacter.Data.Settings == nil then
		glrCharacter.Data.Settings = {}
	end
	
	if glrCharacter.Lottery == nil then
		glrCharacter.Lottery = {}
	end
	
	if glrCharacter.Lottery.Entries == nil then
		glrCharacter.Lottery.Entries = {}
	end
	
	if glrCharacter.Raffle == nil then
		glrCharacter.Raffle = {}
	end
	
	if glrCharacter.Raffle.Entries == nil then
		glrCharacter.Raffle.Entries = {}
	end
	
	if glrCharacter.Data.Defaults.LotteryDate == nil then --Placed here instead of inside the ADDON_LOADED function because date() returns "" there
		glrCharacter.Data.Defaults.LotteryDate = dateTimeString
	end
	
	local GetMonth = GLR:GetCurrentMonth()
	local GetDay = GLR:GetCurrentDay()
	local GetYear = GLR:GetCurrentYear()
	local GetHour = GLR:GetCurrentHour()
	local GetMinute = GLR:GetCurrentMinute()
	
	GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionText:SetText(GetMonth)
	GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionText:SetText(GetDay)
	GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionText:SetText(GetYear)
	GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionText:SetText(GetHour)
	GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionText:SetText(GetMinute)
	
	GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionText:SetText(GetMonth)
	GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionText:SetText(GetDay)
	GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionText:SetText(GetYear)
	GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionText:SetText(GetHour)
	GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionText:SetText(GetMinute)
	
	if glrCharacter.Data.Settings.Status == "Lottery" then
		GLR_UI.GLR_MainFrame.GLR_RaffleFrame:Hide()
	elseif glrCharacter.Data.Settings.Status == "Raffle" then
		GLR_UI.GLR_MainFrame.GLR_LotteryFrame:Hide()
	end
	
	if glrHistory.Names == nil then
		glrHistory.Names = {}
		table.insert(glrHistory.Names, FullPlayerName)
	else
		local isFound = false
		for t, v in pairs(glrHistory.Names) do
			if v == FullPlayerName then
				isFound = true
			end
		end
		if not isFound then
			table.insert(glrHistory.Names, FullPlayerName)
		end
	end
	
	GLR_U:UpdateRosterTable()
	GLR_U:UpdateInfo(false)
	
	local CheckGuild = GLR_U:CheckGuildName()
	
	if CheckGuild then
		guildName, _, _, _ = GetGuildInfo("PLAYER")
	end
	
	if guildName ~= nil then
		
		if glrCharacter.Data.Settings.GuildName == nil then --Used to track whether or not to reply to message events, prevents spam to players not in the players guild.
			glrCharacter.Data.Settings.GuildName = guildName
		elseif glrCharacter.Data.Settings.GuildName ~= guildName then --Updates the players guild name if they switch.
			glrCharacter.Data.Settings.GuildName = guildName
		end
		
	end
	
	if glrHistory.MultiGuildStatus[FullPlayerName] == nil then
		local status = glrCharacter.Data.Settings.MultiGuild
		glrHistory.MultiGuildStatus[FullPlayerName] = {}
		glrHistory.MultiGuildStatus[FullPlayerName] = status
	else
		local status = glrCharacter.Data.Settings.MultiGuild
		local compare = glrHistory.MultiGuildStatus[FullPlayerName]
		
		if compare ~= status then
			glrCharacter.Data.Settings.MultiGuild = compare
		end
	end
	
	if glrHistory.CrossFaction[FullPlayerName] == nil then
		local FactionStatus = glrCharacter.Data.Settings.CrossFactionEvents
		glrHistory.CrossFaction[FullPlayerName] = {}
		glrHistory.CrossFaction[FullPlayerName] = FactionStatus
	else
		local FactionStatus = glrCharacter.Data.Settings.CrossFactionEvents
		local CurrentStatus = glrHistory.CrossFaction[FullPlayerName]
		if CurrentStatus ~= FactionStatus then
			glrHistory.CrossFaction[FullPlayerName] = FactionStatus
		end
	end
	
	local gName = glrCharacter.Data.Settings.GuildName
	
	if gName ~= nil and gName ~= "GLR - No Guild" and gName ~= "" then
		
		if glrHistory.CharacterGuilds[FullPlayerName] == nil then
			glrHistory.CharacterGuilds[FullPlayerName] = {}
			glrHistory.CharacterGuilds[FullPlayerName] = gName
		else
			local tName = glrHistory.CharacterGuilds[FullPlayerName]
			
			if tName ~= gName then
				glrHistory.CharacterGuilds[FullPlayerName] = gName
			end
			
		end
		
		if glrHistory.GuildStatus[faction][guildName] == nil then
			local status = glrCharacter.Data.Settings.MultiGuild
			glrHistory.GuildStatus[faction][gName] = {}
			glrHistory.GuildStatus[faction][gName] = status
		else
			local status = glrCharacter.Data.Settings.MultiGuild
			if status then
				glrHistory.GuildStatus[faction][gName] = status
			end
		end
		
	end
	
	if glrCharacter.Data.Settings.Raffle ~= nil then --Fix for patch 3.0.64 where data being Transferred wasn't being placed in the correct spot. This clears up the un-used data.
		glrCharacter.Data.Settings.Raffle = nil
	end
	
	GLR:ToggleLotteryRaffle("update")
	GLR:Initalization()
	
end

--Due to the way certain information is available when first logging in, the Initalize function had to be broken in two.
--This function will check every second upon logging in until GetGuildInfo returns true.
--If however the player is not in a Guild then it will stop checking one minute after logging in.
function GLR:Initalization()
	
	local CheckGuild = GLR_U:CheckGuildName()
	
	if GLRGuildCheck <= 63 and not GLRGuildCheckComplete then
		GLRGuildCheck = GLRGuildCheck + 1
		self:ScheduleTimer("Initalization", 1)
	end
	
	--Not all information that this AddOn uses is completely available once CheckGuild returns true
	--This is why at least 3 seconds must pass before the Initalization can be completed.
	if CheckGuild and GLRGuildCheck >= 3 and GLRGuildCheck <= 63 and not GLRGuildCheckComplete then
		GLRGuildCheckComplete = true
		local guildName, _, _, _ = GetGuildInfo("PLAYER")
		local faction, _ = UnitFactionGroup("PLAYER")
		local canEdit = CanEditGuildEvent()
		local LoginMessages = true
		
		if glrCharacter.Data.Settings.DisableLoginMessages ~= nil then
			if glrCharacter.Data.Settings.DisableLoginMessages then
				LoginMessages = false
			end
		end
		
		if not canEdit then --Prevents user from manually changing from false to true when they can't make Guild Events in the first place.
			glrCharacter.Data.Settings.CreateCalendarEvents = false
		end
		
		if guildName ~= nil then
			if guildName ~= "" then
				
				if glrHistory.GuildRanks[faction][guildName] == nil then
					glrHistory.GuildRanks[faction][guildName] = {}
				end
				
				local numTotalMembers, _, _ = GetNumGuildMembers()
				if glrHistory.GuildRanks[faction][guildName] ~= nil then
					local t = {}
					for i = 1 , GuildControlGetNumRanks() do
						t[i] = GuildControlGetRankName(i)
					end
					glrHistory.GuildRanks[faction][guildName] = t
				end
				
				if glrCharacter.Data.Settings.GuildName == nil then
					glrCharacter.Data.Settings.GuildName = guildName
				elseif glrCharacter.Data.Settings.GuildName ~= guildName then
					glrCharacter.Data.Settings.GuildName = guildName
				end
				
				if glrHistory.CharacterGuilds[FullPlayerName] == nil then
					glrHistory.CharacterGuilds[FullPlayerName] = {}
					glrHistory.CharacterGuilds[FullPlayerName] = guildName
				else
					local tName = glrHistory.CharacterGuilds[FullPlayerName]
					if tName ~= guildName then
						glrHistory.CharacterGuilds[FullPlayerName] = guildName
					end
				end
				
				if glrHistory.GuildFaction[faction][FullPlayerName] == nil then
					glrHistory.GuildFaction[faction][FullPlayerName] = guildName
				elseif glrHistory.GuildFaction[faction][FullPlayerName] ~= guildName then
					glrHistory.GuildFaction[faction][FullPlayerName] = guildName
				end
				
				if glrHistory.GuildStatus[faction][guildName] == nil then
					local status = glrCharacter.Data.Settings.MultiGuild
					glrHistory.GuildStatus[faction][guildName] = {}
					glrHistory.GuildStatus[faction][guildName] = status
				else
					local status = glrCharacter.Data.Settings.MultiGuild
					local current = glrHistory.GuildStatus[faction][guildName]
					if status and not current then
						glrHistory.GuildStatus[faction][guildName] = status
					end
				end
				
				for t, v in pairs(glrHistory.GuildFaction) do
					if t ~= "Alliance" and t ~= "Horde" then
						local slot = glrHistory.GuildFaction[t]
						local name = ""
						for k, v in pairs(glrHistory.CharacterGuilds) do
							if glrHistory.CharacterGuilds[k] == t then
								name = k
								break
							end
						end
						glrHistory.GuildFaction[slot][name] = t
						glrHistory.GuildFaction[t] = nil
					end
				end
				
				for t, v in pairs(glrHistory.GuildStatus) do
					if t ~= "Alliance" and t ~= "Horde" then
						local status = glrHistory.GuildStatus[t]
						local GuildsFaction = ""
						local doBreak = false
						for k, v in pairs(glrHistory.GuildFaction) do
							for key, val in pairs(glrHistory.GuildFaction[k]) do
								if glrHistory.GuildFaction[k][key] == t then
									GuildsFaction = k
									doBreak = true
									break
								end
							end
							if doBreak then
								break
							end
						end
						glrHistory.GuildStatus[GuildsFaction][t] = status
						glrHistory.GuildStatus[t] = nil
					end
				end
				
				for t, v in pairs(glrHistory.GuildRoster) do
					if t ~= "Alliance" and t ~= "Horde" then
						local GuildsFaction = ""
						local continue = false
						for k, v in pairs(glrHistory.GuildFaction) do
							for key, val in pairs(glrHistory.GuildFaction[k]) do
								for i = 1, #glrHistory.GuildRoster[t] do
									local search = string.sub(glrHistory.GuildRoster[t][i], 1, string.find(glrHistory.GuildRoster[t][i], '%[') - 1)
									if search == key and glrHistory.GuildFaction[k][key] == t then
										continue = true
										GuildsFaction = k
										break
									end
								end
								if continue then
									break
								end
							end
							if continue then
								break
							end
						end
						if continue then
							glrHistory.GuildRoster[GuildsFaction][t] = glrHistory.GuildRoster[t]
							glrHistory.GuildRoster[t] = nil
						end
					end
				end
				
			end
		end
		
		local status = glrCharacter.Data.Settings.MultiGuild
		local numTotalMembers, _, _ = GetNumGuildMembers()
		
		if LoginMessages then
			
			if glrCharacter.Lottery.Entries.Names ~= nil then
				
				for t, v in pairs(glrCharacter.Lottery.Entries.Names) do
					
					local targetRealm
					local bypass = false
					local continue = false
					local state = "Lottery"
					local vN = v
					
					if glrCharacter.Lottery.MessageStatus[v] == nil then
						glrCharacter.Lottery.MessageStatus[v] = { ["sentMessage"] = false, ["lastAlert"] = dateTime }
					end
					
					if string.find(string.lower(v), "-") ~= nil then
						targetRealm = string.sub(v, string.find(v, "-") + 1)
					else
						bypass = true
					end
					
					if PlayerRealmName == targetRealm and not bypass then
						vN = string.sub(v, 1, string.find(v, "-") - 1)
					end
					
					if not status then --If the current Lottery/Raffle isn't a Multi-Guild event it doesn't need to do a /who to see if the Player's online.
						for i = 1, numTotalMembers do
							local name, _, _, _, _, _, _, _, isOnline, _, _, _, _, _, _, _ = GetGuildRosterInfo(i)
							if v == name then
								if isOnline then
									continue = true
								end
								break
							end
						end
						if continue then
							if not glrCharacter.Lottery.MessageStatus[v]["sentMessage"] then
								GLR:SendPlayerTheirTicketInfo(glrTemp, vN, state)
							end
						elseif not glrCharacter.Lottery.MessageStatus[v]["sentMessage"] and not continue then
							if glrCharacter.Data.Settings.ToggleChatInfo then
								GLR:Print("|cfff7ff4d" .. v .. " " .. L["Send Info Player Not Online"] .. "|r")
							end
						end
					else
						
						--With Multi-Guild Events enabled, the mod will only attempt to send a message to the target player if they're part of the same faction.
						for key, val in pairs(glrHistory.GuildRoster[faction]) do
							for i = 1, #glrHistory.GuildRoster[faction][key] do
								local CompareText = string.sub(glrHistory.GuildRoster[faction][key][i], 1, string.find(glrHistory.GuildRoster[faction][key][i], '%[') - 1)
								if CompareText == v then
									continue = true
									break
								end
							end
							if continue then
								break
							end
						end
						if continue then
							if not glrCharacter.Lottery.MessageStatus[v]["sentMessage"] then
								local target = GLR_Libs.WhoLib:UserInfo(vN, 
									{
										timeout = 1,
										Online,
										callback = function(target)
											GLR:CheckMultiGuildPlayerStatus(target, glrTemp, vN, state)
										end
									}
								)
							end
						end
						
					end
					
				end
				
			end
			
			if glrCharacter.Raffle.Entries.Names ~= nil then
				
				for t, v in pairs(glrCharacter.Raffle.Entries.Names) do
					
					if glrCharacter.Raffle.MessageStatus[v] == nil then
						glrCharacter.Raffle.MessageStatus[v] = { ["sentMessage"] = false, ["lastAlert"] = dateTime }
					end
					
					local targetRealm
					local bypass = false
					local continue = false
					local state = "Raffle"
					local vN = v
					
					if string.find(string.lower(v), "-") ~= nil then
						targetRealm = string.sub(v, string.find(v, "-") + 1)
					else
						bypass = true
					end
					
					if PlayerRealmName == targetRealm and not bypass then
						vN = string.sub(v, 1, string.find(v, "-") - 1)
					end
					
					if not status then --If the current Lottery/Raffle isn't a Multi-Guild event it doesn't need to do a /who to see if the Player's online.
						for i = 1, numTotalMembers do
							local name, _, _, level, class, _, _, _, isOnline, _, _, _, _, _, _, _ = GetGuildRosterInfo(i)
							if v == name then
								if isOnline then
									continue = true
								end
								break
							end
						end
						if continue then
							if not glrCharacter.Raffle.MessageStatus[v]["sentMessage"] then
								GLR:SendPlayerTheirTicketInfo(glrTemp, vN, state)
							end
						elseif not glrCharacter.Raffle.MessageStatus[v]["sentMessage"] and not continue then
							if glrCharacter.Data.Settings.ToggleChatInfo then
								GLR:Print("|cfff7ff4d" .. v .. " " .. L["Send Info Player Not Online"] .. "|r")
							end
						end
					else
						
						--With Multi-Guild Events enabled, the mod will only attempt to send a message to the target player if they're part of the same faction.
						for key, val in pairs(glrHistory.GuildRoster[faction]) do
							for i = 1, #glrHistory.GuildRoster[faction][key] do
								local CompareText = string.sub(glrHistory.GuildRoster[faction][key][i], 1, string.find(glrHistory.GuildRoster[faction][key][i], '%[') - 1)
								if CompareText == v then
									continue = true
									break
								end
							end
							if continue then
								break
							end
						end
						if continue then
							if not glrCharacter.Raffle.MessageStatus[v]["sentMessage"] then
								local target = GLR_Libs.WhoLib:UserInfo(vN, 
									{
										timeout = 1,
										Online,
										callback = function(target)
											GLR:CheckMultiGuildPlayerStatus(target, glrTemp, vN, state)
										end
									}
								)
							end
						end
						
					end
					
				end
				
			end
			
		end
		
		if glrCharacter.Data.OtherStatus ~= nil then
			for t, v in pairs(glrCharacter.Data.OtherStatus) do
				for key, val in pairs(glrCharacter.Data.OtherStatus[t]) do
					if not glrCharacter.Data.OtherStatus[t][key].sentMessage then
						local names = glrCharacter.Data.OtherStatus[t][key].Requesters
						local continue = false
						local check = false
						local TargetsRealm
						if string.find(string.lower(key), "-") ~= nil then
							TargetsRealm = string.sub(key, string.find(key, "-") + 1)
						end
						if PlayerRealmName == TargetsRealm then
							target = string.sub(key, 1, string.find(key, "-") - 1)
						end
						if not status then
							for i = 1, numTotalMembers do
								local name, _, _, _, _, _, _, _, isOnline, _, _, _, _, _, _, _ = GetGuildRosterInfo(i)
								if key == name then
									if isOnline then
										continue = true
									end
									break
								end
							end
						else
							for keys, vals in pairs(glrHistory.GuildRoster[faction]) do
								for i = 1, #glrHistory.GuildRoster[faction][keys] do
									local CompareText = string.sub(glrHistory.GuildRoster[faction][keys][i], 1, string.find(glrHistory.GuildRoster[faction][keys][i], '%[') - 1)
									if CompareText == key then
										check = true
										break
									end
								end
								if check then
									break
								end
							end
							if check then
								local TargetName = GLR_Libs.WhoLib:UserInfo(target, 
									{
										timeout = 1,
										Online,
										callback = function(TargetName)
											SendTicketHolderNotification(key, names, t, TargetName)
										end
									}
								)
							end
						end
						if continue then
							SendTicketHolderNotification(key, names, t, _)
						end
					end
				end
			end
		end
		
		GLR_U:PopulateMultiGuildTable()
		GLR_U:UpdateMultiGuildTable()
		CheckForGivenOrSold()
		GLR_U:UpdateInfo(false)
		
		glrAddOnLoaded = true
		
		if glrCharacter.Data.Settings.ToggleChatInfo and glrCharacter.Data.Settings.MultiGuild then
			GLR:Print(L["Initalization Complete"])
		end
		
	end
	
end

--Purpose: To act as a buffer when checking Player Online status in a Multi-Guild event.
function GLR:CheckMultiGuildPlayerStatus(target, glrTemp, vN, state)
	local online = target.Online
	if online then
		GLR:SendPlayerTheirTicketInfo(glrTemp, vN, state)
		if glrCharacter.Data.Settings.ToggleChatInfo then
			GLR:Print("|cfff7ff4d" .. vN .. " - " .. L["Send Info Player Online"] .. "|r")
		end
	else
		if glrCharacter.Data.Settings.ToggleChatInfo then
			GLR:Print("|cfff7ff4d" .. vN .. " " .. L["Send Info Player Not Online"] .. "|r")
		end
	end
end

---------------------------------------------
------------ SHOW USER INTERFACE ------------
---------------------------------------------
-------- DISPLAYS THE UI, IF ENABLED --------
---------------------------------------------

function GLR:ShowGLRFrame()
	
	local guildName, _, _, _ = GetGuildInfo("PLAYER")
	
	if glrCharacter.Data.Settings.Status == "Lottery" then
		GLR_UI.GLR_MainFrame.GLR_RaffleFrame:Hide()
	elseif glrCharacter.Data.Settings.Status == "Raffle" then
		GLR_UI.GLR_MainFrame.GLR_LotteryFrame:Hide()
	end
	
	GLR_U:UpdateBorderColor()
	
	lotteryOrRaffle = glrCharacter.Data.Settings.Status
	
	GLR_L:SetFontSizes()
	
	if guildName ~= nil then
		
		if glrCharacter.Data.Settings.enabled == true then
			
			if GLR_UI.GLR_MainFrame:IsVisible() then
				GLR_U:UpdateInfo(false)
				GLR_UI.GLR_MainFrame:Hide()
			else
				GLR_U:UpdateInfo()
				--Quick and dirty way to get font strings to show completely
				GLR_UI.GLR_MainFrame:Show()
				GLR_UI.GLR_MainFrame:Hide()
				GLR_UI.GLR_MainFrame:Show()
			end
			
		else glrChat:AddMessage("|cfff7ff4d" .. L["GLR Disabled Message"] .. "|r") end
		
	else glrChat:AddMessage("|cfff7ff4d" .. L["GLR Disabled No Guild Message"] .. "|r") end
	
	GLR_U:GetLinkedNames()
	GLR_U:GetLinkedGuilds()
	GLR_U:UpdateMultiGuildTable()
	
end

--------------------------------------------- ---------
----------- TOGGLE LOTTERY/RAFFLE -----------
---------------------------------------------
---------- SWITCHES BETWEEN LOTTERY ---------
----------------- AND RAFFLE ----------------
---------------------------------------------

function GLR:ToggleLotteryRaffle(arg)
	
	local LorR = glrCharacter.Data.Settings.Status
	local CheckGuild = GLR_U:CheckGuildName()
	
	if arg == "toggle" then
		
		if GLR_UI.GLR_MainFrame.GLR_RaffleFrame:IsVisible() then
			LorR = "Raffle"
		elseif GLR_UI.GLR_MainFrame.GLR_LotteryFrame:IsVisible() then
			LorR = "Lottery"
		end
		
		glrCharacter.Data.Settings.Status = LorR
		lotteryOrRaffle = LorR
		
		GLR:ToggleLotteryRaffle("update")
		
	end
	
	if arg == "update" then
		
		if LorR == "Lottery" then -- Displays Lottery data
			
			GLR_UI.GLR_MainFrame.GLR_OpenInterfaceOptionsButton:SetPoint("TOP", GLR_UI.GLR_MainFrame.GLR_LotteryFrame.GLR_BeginLotteryButton, "BOTTOM", 0, -5)
			GLR_UI.GLR_MainFrame.GLR_AlertGuildButton:SetPoint("LEFT", GLR_UI.GLR_MainFrame.GLR_LotteryFrame.GLR_NewLotteryButton, "RIGHT", 5, 0)
			
		elseif LorR == "Raffle" then -- Displays Raffle data
			
			GLR_UI.GLR_MainFrame.GLR_OpenInterfaceOptionsButton:SetPoint("TOP", GLR_UI.GLR_MainFrame.GLR_RaffleFrame.GLR_BeginRaffleButton, "BOTTOM", 0, -5)
			GLR_UI.GLR_MainFrame.GLR_AlertGuildButton:SetPoint("LEFT", GLR_UI.GLR_MainFrame.GLR_RaffleFrame.GLR_NewRaffleButton, "RIGHT", 5, 0)
			
		end
		
		if CheckGuild then
			GLR_U:UpdateInfo()
		end
		
	end
	
end

--------------------------------------------- ---------
------------ CONFIRM NEW LOTTERY ------------
---------------------------------------------
---------- CONFIRMS FINAL SETTINGS ----------
-------------- FOR NEW LOTTERY --------------
---------------------------------------------

function GLR:ConfirmNewLotterySettings()
	
	local monthValue = {
		[L["January"]] = L["01"],
		[L["February"]] = L["02"],
		[L["March"]] = L["03"],
		[L["April"]] = L["04"],
		[L["May"]] = L["05"],
		[L["June"]] = L["06"],
		[L["July"]] = L["07"],
		[L["August"]] = L["08"],
		[L["September"]] = L["09"],
		[L["October"]] = L["10"],
		[L["November"]] = L["11"],
		[L["December"]] = L["12"]
	}
	local yearValue = {
		[L["2018"]] = L["18"],
		[L["2019"]] = L["19"]
	}
	local useMonth = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionText:GetText()
	local SelectedMonth = monthValue[useMonth]
	local SelectedDay = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionText:GetText()
	local useYear = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionText:GetText()
	local SelectedYear = yearValue[useYear]
	local SelectedHour = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionText:GetText()
	local SelectedMinute = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionText:GetText()
	local SelectedDate = SelectedMonth .. "/" .. SelectedDay .. "/" .. SelectedYear
	local DateString = SelectedMonth .. "/" .. SelectedDay .. "/" .. SelectedYear .. " @ " .. SelectedHour .. ":" .. SelectedMinute
	local NewLotteryName = GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryNameEditBox:GetText()
	local NewLotteryStartingGold = GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryStartingGoldEditBox:GetText()
	local NewLotteryMaxTickets = GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryMaxTicketsEditBox:GetText()
	local NewLotteryTicketPrice = GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryTicketGoldPriceEditBox:GetText()
	local NewLotterySecondPlace = GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotterySecondPlaceEditBox:GetText()
	local NewLotteryGuildCut = GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryGuildCutEditBox:GetText()
	local GuaranteeWinnerStatus = GLR_UI.GLR_NewLotteryEventFrame.GLR_GuaranteeWinnerCheckButton:GetChecked()
	
	local currentMonth = tonumber(date("%m"))
	local currentDay = tonumber(date("%d"))
	local currentYear = tonumber(date("%y"))
	local currentHour = tonumber(date("%H"))
	local currentMinute = tonumber(date("%M"))
	
	local selectedMonthNumber = tonumber(SelectedMonth)
	local selectedDayNumber = tonumber(SelectedDay)
	local selectedYearNumber = tonumber(SelectedYear)
	local selectedHourNumber = tonumber(SelectedHour)
	local selectedMinuteNumber = tonumber(SelectedMinute)
	
	local GuildCutNumber = -1
	local SecondCutNumber = -1
	local TicketPriceNumber = -1
	local MaxTicketsNumber = -1
	local StartingGoldNumber = -1
	local TotalGuildSecondCut = 101
	
	if NewLotteryGuildCut ~= "" then
		GuildCutNumber = tonumber(NewLotteryGuildCut)
		if GuildCutNumber ~= nil then
			TotalGuildSecondCut = GuildCutNumber
		end
	end
	if NewLotterySecondPlace ~= "" then
		SecondCutNumber = tonumber(NewLotterySecondPlace)
		if SecondCutNumber ~= nil then
			TotalGuildSecondCut = TotalGuildSecondCut + SecondCutNumber
		end
	end
	if NewLotteryTicketPrice ~= "" then
		TicketPriceNumber = tonumber(NewLotteryTicketPrice)
	end
	if NewLotteryMaxTickets ~= "" then
		MaxTicketsNumber = tonumber(NewLotteryMaxTickets)
	end
	if NewLotteryStartingGold ~= "" then
		StartingGoldNumber = tonumber(NewLotteryStartingGold)
	end
	
	local bypass = false
	
	if selectedDayNumber > currentDay or selectedMonthNumber > currentMonth then
		
		bypass = true
		
	end
	
	if GuildCutNumber ~= nil then
		if GuildCutNumber <= 100 and GuildCutNumber >= 0 then
			if SecondCutNumber ~= nil then
				if SecondCutNumber <= 100 and SecondCutNumber >= 0 or GuaranteeWinnerStatus then
					if TotalGuildSecondCut <= 100 and TotalGuildSecondCut >= 0 then
						if TicketPriceNumber ~= nil then
							if TicketPriceNumber >= 0 then
								if MaxTicketsNumber ~= nil then
									if MaxTicketsNumber >= 1 and MaxTicketsNumber <= 50000 then
										if StartingGoldNumber ~= nil then
											if StartingGoldNumber >= 0 then
												if NewLotteryName ~= "" or NewLotteryName ~= nil then
													
													if currentYear == selectedYearNumber then
														if selectedMonthNumber >= currentMonth then
															if selectedDayNumber >= currentDay or bypass then
																if selectedHourNumber >= currentHour or bypass then
																	if currentMinute < selectedMinuteNumber and currentHour == selectedHourNumber or bypass then
																		
																		GLR_UI.GLR_NewLotteryEventFrame.GLR_ConfirmNewLotteryFrame:Show()
																		
																	elseif currentMinute >= selectedMinuteNumber and currentHour ~= selectedHourNumber then
																		
																		GLR_UI.GLR_NewLotteryEventFrame.GLR_ConfirmNewLotteryFrame:Show()
																		
																	else
																		GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Date Error"])
																	end
																else
																	GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Hour Error"])
																end
															else
																GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Day Error"])
															end
														else
															GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Month Error"])
														end
													end
													
													if selectedYearNumber > currentYear then
														GLR_UI.GLR_NewLotteryEventFrame.GLR_ConfirmNewLotteryFrame:Show()
													end
													
												else
													GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Lottery Name Error"])
												end
											else
												GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Starting Gold Error"])
											end
										else
											GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Starting Gold Error"])
										end
									else
										GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Max Ticket Error"])
									end
								else
									GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Max Ticket Error"])
								end
							else
								GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Invalid Ticket Error"])
							end
						else
							GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Invalid Ticket Error"])
						end
					else
						GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Guild & Second Place Error"])
					end
				else
					GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Second Place Error"])
				end
			else
				GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Second Place Error"])
			end
		else
			GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Guild Cut Error"])
		end
	else
		GLR_UI.GLR_NewLotteryEventFrame.GLR_InvalidOption:SetText(L["Guild Cut Error"])
	end
	
end

function GLR:ConfirmNewRaffleSettings()
	
	local monthValue = {
		[L["January"]] = L["01"],
		[L["February"]] = L["02"],
		[L["March"]] = L["03"],
		[L["April"]] = L["04"],
		[L["May"]] = L["05"],
		[L["June"]] = L["06"],
		[L["July"]] = L["07"],
		[L["August"]] = L["08"],
		[L["September"]] = L["09"],
		[L["October"]] = L["10"],
		[L["November"]] = L["11"],
		[L["December"]] = L["12"]
	}
	local yearValue = {
		[L["2018"]] = L["18"],
		[L["2019"]] = L["19"]
	}
	local useMonth = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionText:GetText()
	local SelectedMonth = monthValue[useMonth]
	local SelectedDay = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionText:GetText()
	local useYear = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionText:GetText()
	local SelectedYear = yearValue[useYear]
	local SelectedHour = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionText:GetText()
	local SelectedMinute = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionText:GetText()
	local SelectedDate = SelectedMonth .. "/" .. SelectedDay .. "/" .. SelectedYear
	local DateString = SelectedMonth .. "/" .. SelectedDay .. "/" .. SelectedYear .. " @ " .. SelectedHour .. ":" .. SelectedMinute
	local NewRaffleName = GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleNameEditBox:GetText()
	local NewRaffleMaxTickets = GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleMaxTicketsEditBox:GetText()
	local NewRaffleTicketPrice = GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleTicketGoldPriceEditBox:GetText()
	
	local currentMonth = tonumber(date("%m"))
	local currentDay = tonumber(date("%d"))
	local currentYear = tonumber(date("%y"))
	local currentHour = tonumber(date("%H"))
	local currentMinute = tonumber(date("%M"))
	
	local selectedMonthNumber = tonumber(SelectedMonth)
	local selectedDayNumber = tonumber(SelectedDay)
	local selectedYearNumber = tonumber(SelectedYear)
	local selectedHourNumber = tonumber(SelectedHour)
	local selectedMinuteNumber = tonumber(SelectedMinute)
	
	local bypass = false
	
	if selectedDayNumber > currentDay or selectedMonthNumber > currentMonth then
		
		bypass = true
		
	end
	
	local TicketPriceNumber = -1
	local MaxTicketsNumber = -1
	local NewRaffleFirstPrize = 0
	local NewRaffleSecondPrize = 0
	local NewRaffleThirdPrize = 0
	local TotalRafflePrizes = 0
	
	if NewRaffleMaxTickets ~= "" then
		MaxTicketsNumber = tonumber(NewRaffleMaxTickets)
	end
	if NewRaffleTicketPrice ~= "" then
		TicketPriceNumber = tonumber(NewRaffleTicketPrice)
	end
	
	if holdRaffleInfo.FirstPrize.ItemLink ~= "" then
		NewRaffleFirstPrize = 1
	end
	if holdRaffleInfo.SecondPrize.ItemLink ~= "" then
		NewRaffleSecondPrize = 1
	end
	if holdRaffleInfo.ThirdPrize.ItemLink ~= "" then
		NewRaffleThirdPrize = 1
	end
	
	TotalRafflePrizes = NewRaffleFirstPrize + NewRaffleSecondPrize + NewRaffleThirdPrize
	
	if TicketPriceNumber ~= nil then
		if TicketPriceNumber >= 0 then
			if MaxTicketsNumber ~= nil then
				if MaxTicketsNumber >= 0 and MaxTicketsNumber <= 50000 then
					if NewRaffleName ~= "" or NewRaffleName ~= nil then
						if TotalRafflePrizes >= 1 then
							
							if currentYear == selectedYearNumber then
								if selectedMonthNumber >= currentMonth then
									if selectedDayNumber >= currentDay or bypass then
										if selectedHourNumber >= currentHour or bypass then
											if currentMinute < selectedMinuteNumber and currentHour == selectedHourNumber or bypass then
												
												GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText("")
												GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmNewRaffleFrame:Show()
												
											elseif currentMinute >= selectedMinuteNumber and currentHour ~= selectedHourNumber then
												
												GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText("")
												GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmNewRaffleFrame:Show()
												
											else
												GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText(L["Date Error"])
											end
										else
											GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText(L["Hour Error"])
										end
									else
										GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText(L["Day Error"])
									end
								else
									GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText(L["Month Error"])
								end
							end
							
							if selectedYearNumber > currentYear then
								GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText("")
								GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmNewRaffleFrame:Show()
							end
							
						else
							GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText(L["Prize Error"])
						end
					else
						GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText(L["Lottery Name Error"])
					end
				else
					GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText(L["Max Ticket Error"])
				end
			else
				GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText(L["Max Ticket Error"])
			end
		else
			GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText(L["Invalid Ticket Error"])
		end
	else
		GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText(L["Invalid Ticket Error"])
	end
	
end

--------------------------------------------- ---------
----------- SETS NEW EVENT SETTINGS ---------
---------------------------------------------
-------- BASED OFF OF ABOVE FUNCTION --------
---------------------------------------------

function GLR:SetNewEventSettings(EventType)
	
	local CheckGuild = GLR_U:CheckGuildName()
	local monthValue = {
		[L["January"]] = L["01"],
		[L["February"]] = L["02"],
		[L["March"]] = L["03"],
		[L["April"]] = L["04"],
		[L["May"]] = L["05"],
		[L["June"]] = L["06"],
		[L["July"]] = L["07"],
		[L["August"]] = L["08"],
		[L["September"]] = L["09"],
		[L["October"]] = L["10"],
		[L["November"]] = L["11"],
		[L["December"]] = L["12"]
	}
	local yearValue = {
		[L["2018"]] = L["18"],
		[L["2019"]] = L["19"]
	}
	local useMonth = ""
	local SelectedMonth = ""
	local SelectedDay = ""
	local useYear = ""
	local SelectedYear = ""
	local SelectedHour = ""
	local SelectedMinute = ""
	local SelectedDate = ""
	local DateString = ""
	local NewEventName = ""
	local NewStartingGold = ""
	local NewMaxTickets = ""
	local NewTicketPrice = ""
	local NewLotterySecondPlace = ""
	local NewLotteryGuildCut = ""
	local CheckMarkStatus = ""
	local previousJackpot = ""
	local NewRaffleFirstPlace
	local NewRaffleSecondPlace
	local NewRaffleThirdPlace
	local First = false
	local Second = false
	local TicketSeries = 0
	local guildName, _, _, _ = GetGuildInfo("PLAYER")
	local state = EventType
	local CreateCalendarEvent = glrCharacter.Data.Settings.CreateCalendarEvents
	local status = glrCharacter.Data.Settings.MultiGuild
	
	if state == "Lottery" then
		
		useMonth = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionText:GetText()
		SelectedMonth = monthValue[useMonth]
		SelectedDay = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionText:GetText()
		useYear = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionText:GetText()
		SelectedYear = yearValue[useYear]
		SelectedHour = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionText:GetText()
		SelectedMinute = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionText:GetText()
		
		SelectedDate = SelectedMonth .. "/" .. SelectedDay .. "/" .. SelectedYear
		DateString = SelectedMonth .. "/" .. SelectedDay .. "/" .. SelectedYear .. " @ " .. SelectedHour .. ":" .. SelectedMinute
		
		NewEventName = GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryNameEditBox:GetText()
		NewStartingGold = GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryStartingGoldEditBox:GetText() .. "." .. GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryStartingSilverEditBox:GetText() .. GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryStartingCopperEditBox:GetText()
		NewMaxTickets = GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryMaxTicketsEditBox:GetText()
		NewTicketPrice = GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryTicketGoldPriceEditBox:GetText() .. "." .. GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryTicketSilverPriceEditBox:GetText() .. GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryTicketCopperPriceEditBox:GetText()
		NewLotterySecondPlace = GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotterySecondPlaceEditBox:GetText()
		NewLotteryGuildCut = GLR_UI.GLR_NewLotteryEventFrame.GLR_NewLotteryGuildCutEditBox:GetText()
		CheckMarkStatus = GLR_UI.GLR_NewLotteryEventFrame.GLR_GuaranteeWinnerCheckButton:GetChecked()
		
		previousJackpot = glrCharacter.Data.Settings.PreviousLottery.Jackpot
		TicketSeries = glrCharacter.Data.Settings.TicketSeries
		
		if previousJackpot > 0 then
			NewStartingGold = tostring(tonumber(NewStartingGold) + previousJackpot)
		end
		
		if tonumber(NewLotteryGuildCut) == 0 then
			NewLotteryGuildCut = "0"
		end
		
		if CheckMarkStatus then
			NewLotterySecondPlace = L["Winner Guaranteed"]
		elseif not CheckMarkStatus and tonumber(NewLotterySecondPlace) == 0 then
			NewLotterySecondPlace = "0"
		end
		
		if TicketSeries >= 9000 then
			glrCharacter.Data.Settings.TicketSeries = 1000
		else
			if TicketSeries >= 8000 then
				glrCharacter.Data.Settings.TicketSeries = 9000
			elseif TicketSeries >= 7000 then
				glrCharacter.Data.Settings.TicketSeries = 8000
			elseif TicketSeries >= 6000 then
				glrCharacter.Data.Settings.TicketSeries = 7000
			elseif TicketSeries >= 5000 then
				glrCharacter.Data.Settings.TicketSeries = 6000
			elseif TicketSeries >= 4000 then
				glrCharacter.Data.Settings.TicketSeries = 5000
			elseif TicketSeries >= 3000 then
				glrCharacter.Data.Settings.TicketSeries = 4000
			elseif TicketSeries >= 2000 then
				glrCharacter.Data.Settings.TicketSeries = 3000
			elseif TicketSeries >= 1000 then
				glrCharacter.Data.Settings.TicketSeries = 2000
			end
		end
		
	elseif state == "Raffle" then
		
		useMonth = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionText:GetText()
		SelectedMonth = monthValue[useMonth]
		SelectedDay = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionText:GetText()
		useYear = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionText:GetText()
		SelectedYear = yearValue[useYear]
		SelectedHour = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionText:GetText()
		SelectedMinute = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionText:GetText()
		
		SelectedDate = SelectedMonth .. "/" .. SelectedDay .. "/" .. SelectedYear
		DateString = SelectedMonth .. "/" .. SelectedDay .. "/" .. SelectedYear .. " @ " .. SelectedHour .. ":" .. SelectedMinute
		
		NewEventName = GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleNameEditBox:GetText()
		NewMaxTickets = GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleMaxTicketsEditBox:GetText()
		NewTicketPrice = GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleTicketGoldPriceEditBox:GetText() .. "." .. GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleTicketSilverPriceEditBox:GetText() .. GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleTicketCopperPriceEditBox:GetText()
		
		if holdRaffleInfo.FirstPrize.ItemLink ~= "" then
			NewRaffleFirstPlace = holdRaffleInfo.FirstPrize.ItemLink
			glrCharacter.Data.Raffle.FirstPrizeData.ItemLink = holdRaffleInfo.FirstPrize.ItemLink
			glrCharacter.Data.Raffle.FirstPrizeData.ItemName = holdRaffleInfo.FirstPrize.ItemName
			First = true
		else
			NewRaffleFirstPlace = false
		end
		if holdRaffleInfo.SecondPrize.ItemLink ~= "" then
			if not First then
				NewRaffleFirstPlace = holdRaffleInfo.SecondPrize.ItemLink
				glrCharacter.Data.Raffle.FirstPrizeData.ItemLink = holdRaffleInfo.SecondPrize.ItemLink
				glrCharacter.Data.Raffle.FirstPrizeData.ItemName = holdRaffleInfo.SecondPrize.ItemName
				First = true
			else
				NewRaffleSecondPlace = holdRaffleInfo.SecondPrize.ItemLink
				glrCharacter.Data.Raffle.SecondPrizeData.ItemLink = holdRaffleInfo.SecondPrize.ItemLink
				glrCharacter.Data.Raffle.SecondPrizeData.ItemName = holdRaffleInfo.SecondPrize.ItemName
				Second = true
			end
		else
			NewRaffleSecondPlace = false
		end
		if holdRaffleInfo.ThirdPrize.ItemLink ~= "" then
			if not First and not Second then
				NewRaffleFirstPlace = holdRaffleInfo.ThirdPrize.ItemLink
				glrCharacter.Data.Raffle.FirstPrizeData.ItemLink = holdRaffleInfo.ThirdPrize.ItemLink
				glrCharacter.Data.Raffle.FirstPrizeData.ItemName = holdRaffleInfo.ThirdPrize.ItemName
			elseif not Second then
				NewRaffleSecondPlace = holdRaffleInfo.ThirdPrize.ItemLink
				glrCharacter.Data.Raffle.SecondPrizeData.ItemLink = holdRaffleInfo.ThirdPrize.ItemLink
				glrCharacter.Data.Raffle.SecondPrizeData.ItemName = holdRaffleInfo.ThirdPrize.ItemName
			else
				NewRaffleThirdPlace = holdRaffleInfo.ThirdPrize.ItemLink
				glrCharacter.Data.Raffle.ThirdPrizeData.ItemLink = holdRaffleInfo.ThirdPrize.ItemLink
				glrCharacter.Data.Raffle.ThirdPrizeData.ItemName = holdRaffleInfo.ThirdPrize.ItemName
			end
		else
			NewRaffleThirdPlace = false
		end
		
		TicketSeries = glrCharacter.Data.Settings.RaffleSeries
		
		if TicketSeries >= 9000 then
			glrCharacter.Data.Settings.RaffleSeries = 1000
		else
			if TicketSeries >= 8000 then
				glrCharacter.Data.Settings.RaffleSeries = 9000
			elseif TicketSeries >= 7000 then
				glrCharacter.Data.Settings.RaffleSeries = 8000
			elseif TicketSeries >= 6000 then
				glrCharacter.Data.Settings.RaffleSeries = 7000
			elseif TicketSeries >= 5000 then
				glrCharacter.Data.Settings.RaffleSeries = 6000
			elseif TicketSeries >= 4000 then
				glrCharacter.Data.Settings.RaffleSeries = 5000
			elseif TicketSeries >= 3000 then
				glrCharacter.Data.Settings.RaffleSeries = 4000
			elseif TicketSeries >= 2000 then
				glrCharacter.Data.Settings.RaffleSeries = 3000
			elseif TicketSeries >= 1000 then
				glrCharacter.Data.Settings.RaffleSeries = 2000
			end
		end
		
	end
	
	if guildName == nil then
		guildName = "GLR - No Guild"
	end
	
	if glrCharacter.Data.Settings.GuildName == nil then
		glrCharacter.Data.Settings.GuildName = guildName
	end
	
	if glrCharacter.Event == nil then
		if state == "Lottery" then
			glrCharacter.Event[state] = { ["EventName"] = NewEventName, ["Date"] = DateString, ["StartingGold"] = NewStartingGold, ["MaxTickets"] = NewMaxTickets, ["TicketPrice"] = NewTicketPrice, ["SecondPlace"] = NewLotterySecondPlace, ["GuildCut"] = NewLotteryGuildCut, ["TicketsSold"] = 0, ["LastTicketBought"] = TicketSeries, ["FirstTicketNumber"] = TicketSeries, ["GiveAwayTickets"] = 0 }
			if glrCharacter.Data.Settings.CurrentlyActiveLottery == nil or not glrCharacter.Data.Settings.CurrentlyActiveLottery then
				glrCharacter.Data.Settings.CurrentlyActiveLottery = true
			end
		else
			glrCharacter.Event[state] = { ["EventName"] = NewEventName, ["Date"] = DateString, ["MaxTickets"] = NewMaxTickets, ["TicketPrice"] = NewTicketPrice, ["FirstPlace"] = NewRaffleFirstPlace, ["SecondPlace"] = NewRaffleSecondPlace, ["ThirdPlace"] = NewRaffleThirdPlace, ["TotalPrizes"] = TotalRafflePrizes, ["TicketsSold"] = 0, ["LastTicketBought"] = TicketSeries, ["FirstTicketNumber"] = TicketSeries, ["GiveAwayTickets"] = 0 }
			if glrCharacter.Data.Settings.CurrentlyActiveRaffle == nil or not glrCharacter.Data.Settings.CurrentlyActiveRaffle then
				glrCharacter.Data.Settings.CurrentlyActiveRaffle = true
			end
		end
	else
		if state == "Lottery" then
			glrCharacter.Event[state] = { ["EventName"] = NewEventName, ["Date"] = DateString, ["StartingGold"] = NewStartingGold, ["MaxTickets"] = NewMaxTickets, ["TicketPrice"] = NewTicketPrice, ["SecondPlace"] = NewLotterySecondPlace, ["GuildCut"] = NewLotteryGuildCut, ["TicketsSold"] = 0, ["LastTicketBought"] = TicketSeries, ["FirstTicketNumber"] = TicketSeries, ["GiveAwayTickets"] = 0 }
			if glrCharacter.Data.Settings.CurrentlyActiveLottery == nil or not glrCharacter.Data.Settings.CurrentlyActiveLottery then
				glrCharacter.Data.Settings.CurrentlyActiveLottery = true
			end
		else
			glrCharacter.Event[state] = { ["EventName"] = NewEventName, ["Date"] = DateString, ["MaxTickets"] = NewMaxTickets, ["TicketPrice"] = NewTicketPrice, ["FirstPlace"] = NewRaffleFirstPlace, ["SecondPlace"] = NewRaffleSecondPlace, ["ThirdPlace"] = NewRaffleThirdPlace, ["TotalPrizes"] = TotalRafflePrizes, ["TicketsSold"] = 0, ["LastTicketBought"] = TicketSeries, ["FirstTicketNumber"] = TicketSeries, ["GiveAwayTickets"] = 0 }
			if glrCharacter.Data.Settings.CurrentlyActiveRaffle == nil or not glrCharacter.Data.Settings.CurrentlyActiveRaffle then
				glrCharacter.Data.Settings.CurrentlyActiveRaffle = true
			end
		end
	end
	
	if glrCharacter[state] == nil then
		glrCharacter[state] = {}
	end
	
	if glrCharacter[state].Entries == nil then
		glrCharacter[state].Entries = {}
		glrCharacter[state].Entries.Names = {}
		glrCharacter[state].Entries.Tickets = {}
		glrCharacter[state].Entries.TicketNumbers = {}
		glrCharacter[state].Entries.TicketRange = {}
	else
		glrCharacter[state].Entries = {}
		glrCharacter[state].Entries.Names = {}
		glrCharacter[state].Entries.Tickets = {}
		glrCharacter[state].Entries.TicketNumbers = {}
		glrCharacter[state].Entries.TicketRange = {}
	end

	local FirstTicket = glrCharacter.Event[state].FirstTicketNumber
	
	GLR_UI.GLR_MainFrame.GLR_TicketNumberRangeBorderLow:SetText(FirstTicket)
	GLR_UI.GLR_MainFrame.GLR_TicketNumberRangeBorderHigh:SetText("")
	
	if glrCharacter[state].TicketPool == nil then
		glrCharacter[state].TicketPool = {}
	else
		glrCharacter[state].TicketPool = {}
	end
	
	if glrCharacter[state].MessageStatus == nil then
		glrCharacter[state].MessageStatus = {}
	else
		glrCharacter[state].MessageStatus = {}
	end
	
	if glrTemp == nil then
		glrTemp = {}
	end
	if glrTemp[state] == nil then
		glrTemp[state] = {}
	else
		glrTemp[state] = {}
	end
	
	if glrTempStatus == nil then
		glrTempStatus = {}
	else
		glrTempStatus = {}
	end
	
	if glrHistory.ActiveEvents == nil then
		glrHistory.ActiveEvents = {}
	end
	
	if glrHistory.ActiveEvents[FullPlayerName] == nil then
		glrHistory.ActiveEvents[FullPlayerName] = true
	else
		glrHistory.ActiveEvents[FullPlayerName] = true
	end
	
	if state == "Lottery" then
		GLR_UI.GLR_NewLotteryEventFrame.GLR_GuaranteeWinnerCheckButton:SetChecked(false)
		if glrHistory.TransferData[FullPlayerName].Data ~= nil then
			glrHistory.TransferData[FullPlayerName].Data.Settings.PreviousLottery = nil
			glrHistory.TransferData[FullPlayerName].Data.Settings.TicketSeries = nil
		end
	else
		GLR_UI.GLR_NewRaffleEventFrame.GLR_AllowInvalidItemCheckButton:SetChecked(false)
		holdRaffleInfo = { ["FirstPrize"] = { ["ItemName"] = "", ["ItemLink"] = "" }, ["SecondPrize"] = { ["ItemName"] = "", ["ItemLink"] = "" }, ["ThirdPrize"] = { ["ItemName"] = "", ["ItemLink"] = "" } }
		if glrHistory.TransferData[FullPlayerName].Data ~= nil then
			glrHistory.TransferData[FullPlayerName].Data.Settings.AllowMultipleRaffleWinners = nil
			glrHistory.TransferData[FullPlayerName].Data.Settings.RaffleSeries = nil
		end
	end
	
	if CreateCalendarEvent then
		GLR_Calendar:CreateAnnouncement(state)
	end
	
	if glrHistory.TransferData[FullPlayerName] ~= nil and glrHistory.TransferData[FullPlayerName].Event ~= nil and glrHistory.TransferData[FullPlayerName].Data ~= nil then
		glrHistory.TransferData[FullPlayerName][state] = nil
		glrHistory.TransferData[FullPlayerName].Event[state] = nil
		glrHistory.TransferData[FullPlayerName].Data.OtherStatus[state] = nil
	end
	
	glrHistory.TransferAvailable[state][FullPlayerName] = false
	
	local LotteryStatus = tostring(glrCharacter.Data.Settings.CurrentlyActiveLottery)
	local RaffleStatus = tostring(glrCharacter.Data.Settings.CurrentlyActiveRaffle)
	C_ChatInfo.SendAddonMessage("GLR_CHECK", "%lottery_" .. LotteryStatus .. "!%raffle_" .. RaffleStatus, "GUILD")
	
	GLR_U:UpdateInfo()
	
end

--------------------------------------------- ---------
---------------- ALERT GUILD ----------------
---------------------------------------------
--------- ALERTS THE PLAYER'S GUILD ---------
---------- ABOUT AN ACTIVE LOTTERY ----------
---------------------------------------------

local AlertCount = 1
local LotteryAlert = false
local RaffleAlert = false
local AlertGuildVariables = {
	[1] = "",		-- Lottery Name
	[2] = "",		-- Raffle Name
	[3] = "",		-- Lottery Date
	[4] = "",		-- Raffle Date
	[5] = 0,		-- Lottery Max Tickets
	[6] = 0,		-- Raffle Max Tickets
	[7] = 0,		-- Lottery Ticket Price
	[8] = 0,		-- Raffle Ticket Price
	[9] = 0,		-- Starting Gold
	[10] = 0,		-- Lottery Tickets
	[11] = 0,		-- Raffle Tickets
	[12] = 0,		-- Lottery Price
	[13] = 0,		-- Jackpot Gold
	[14] = 0,		-- Jackpot Left
	[15] = 0,		-- Guild Cut
	[16] = false,	-- Raffle First
	[17] = false,	-- Raffle Second
	[18] = false	-- Raffle Third
}

local function GetAlertMessage(number, state)
	local message = glrCharacter.Data.Messages.GuildAlerts[state][number]
	if string.find(message, "%%version") then
		message = string.gsub(message, "%%version", GLR_Version)
	end
	if string.find(message, "%%lottery_reply") then
		message = string.gsub(message, "%%lottery_reply", L["Detect Lottery"])
	end
	if string.find(message, "%%raffle_reply") then
		message = string.gsub(message, "%%raffle_reply", L["Detect Raffle"])
	end
	if state == "Lottery" or state == "Both" then
		local round = glrCharacter.Data.Settings.RoundJackpot
		local PreviousWinner = ""
		local PreviousValue = ""
		if string.find(message, "%%previous_winner") or string.find(message, "%%previous_jackpot") then
			if glrCharacter.PreviousEvent.Lottery.Available then
				local doBreak = false
				local PreviousRound = glrCharacter.PreviousEvent.Lottery.Settings.RoundJackpot
				local WinStatus = glrCharacter.PreviousEvent.Lottery.Settings.WonType
				local PreviousJackpot = tostring( ( tonumber(glrCharacter.PreviousEvent.Lottery.Settings.StartingGold) + tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketPrice) * tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketsSold) ) - ( ( tonumber(glrCharacter.PreviousEvent.Lottery.Settings.StartingGold) + tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketPrice) * tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketsSold) ) * ( tonumber(glrCharacter.PreviousEvent.Lottery.Settings.GuildCut) / 100 ) ) )
				if not WinStatus then
					PreviousJackpot = tostring(tonumber(glrCharacter.PreviousEvent.Lottery.Settings.StartingGold) + tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketPrice) * tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketsSold) - (tonumber(glrCharacter.PreviousEvent.Lottery.Settings.StartingGold) + tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketPrice) * tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketsSold) * (tonumber(glrCharacter.PreviousEvent[ExportType].Settings.SecondPlace) / 100)))
				end
				PreviousValue = GetMoneyValue(PreviousJackpot, "Lottery", "Jackpot", PreviousRound, true)
				for i = 1, #glrCharacter.PreviousEvent.Lottery.Data.Entries.Names do
					name = glrCharacter.PreviousEvent.Lottery.Data.Entries.Names[i]
					for j = 1, #glrCharacter.PreviousEvent.Lottery.Data.Entries.TicketNumbers[name] do
						if glrCharacter.PreviousEvent.Lottery.Data.Entries.TicketNumbers[name][j] == glrCharacter.PreviousEvent.Lottery.Data.Winner then
							PreviousWinner = name
							doBreak = true
							break
						end
					end
					if doBreak then break end
				end
				if not doBreak then PreviousWinner = "No Winner!" end
			else
				PreviousWinner = "No Winner!"
				PreviousValue = "0g"
			end
			if string.find(message, "%%previous_winner") then
				message = string.gsub(message, "%%previous_winner", PreviousWinner)
			end
			if string.find(message, "%%previous_jackpot") then
				message = string.gsub(message, "%%previous_jackpot", PreviousValue)
			end
		end
		if string.find(message, "%%lottery_price") then
			local price = glrCharacter.Event.Lottery.TicketPrice
			price = GetMoneyValue(price, "", "", false, false)
			message = string.gsub(message, "%%lottery_price", price)
		end
		if string.find(message, "%%lottery_max") then
			message = string.gsub(message, "%%lottery_max", glrCharacter.Event.Lottery.MaxTickets)
		end
		if string.find(message, "%%lottery_name") then
			message = string.gsub(message, "%%lottery_name", glrCharacter.Event.Lottery.EventName)
		end
		if string.find(message, "%%lottery_date") then
			message = string.gsub(message, "%%lottery_date", glrCharacter.Event.Lottery.Date)
		end
		if string.find(message, "%%lottery_gold") then
			local gold = tostring( ( (tonumber(glrCharacter.Event.Lottery.StartingGold) + tonumber(glrCharacter.Event.Lottery.TicketPrice) * tonumber(glrCharacter.Event.Lottery.TicketsSold) ) - ( ( tonumber(glrCharacter.Event.Lottery.StartingGold) + tonumber(glrCharacter.Event.Lottery.TicketPrice) * tonumber(glrCharacter.Event.Lottery.TicketsSold) ) * ( tonumber(glrCharacter.Event.Lottery.GuildCut) / 100 ) ) ) )
			if gold ~= nil then
				gold = GetMoneyValue(gold, "Lottery", "Jackpot", round, false)
				message = string.gsub(message, "%%lottery_gold", gold)
			end
		end
		if string.find(message, "%%lottery_tickets") then
			local tickets = tostring(glrCharacter.Event.Lottery.TicketsSold)
			if tickets ~= nil then
				message = string.gsub(message, "%%lottery_tickets", tickets)
			end
		end
	end
	if state == "Raffle" or state == "Both" then
		local prizes = glrCharacter.Event.Raffle.FirstPlace
		if glrCharacter.Event.Raffle.SecondPlace ~= false then
			prizes = prizes .. ", " .. glrCharacter.Event.Raffle.SecondPlace
		end
		if glrCharacter.Event.Raffle.ThirdPlace ~= false then
			prizes = prizes .. ", " .. glrCharacter.Event.Raffle.ThirdPlace
		end
		if string.find(message, "%%raffle_prizes") then
			if string.len(string.gsub(message, "%%raffle_prizes", prizes)) <= 255 then
				message = string.gsub(message, "%%raffle_prizes", prizes)
			end
		end
		if string.find(message, "%%raffle_price") then
			local price = glrCharacter.Event.Raffle.TicketPrice
			price = GetMoneyValue(price, "", "", false, false)
			message = string.gsub(message, "%%raffle_price", price)
		end
		if string.find(message, "%%raffle_max") then
			message = string.gsub(message, "%%raffle_max", glrCharacter.Event.Raffle.MaxTickets)
		end
		if string.find(message, "%%raffle_name") then
			message = string.gsub(message, "%%raffle_name", glrCharacter.Event.Raffle.EventName)
		end
		if string.find(message, "%%raffle_date") then
			message = string.gsub(message, "%%raffle_date", glrCharacter.Event.Raffle.Date)
		end
		if string.find(message, "%%raffle_gold") then
			local gold = tostring(glrCharacter.Event.Raffle.TicketsSold * tonumber(glrCharacter.Event.Raffle.TicketPrice))
			if gold ~= nil then
				gold = GetMoneyValue(gold, "", "", false, false)
				message = string.gsub(message, "%%raffle_gold", gold)
			end
		end
		if string.find(message, "%%raffle_tickets") then
			local tickets = tostring(glrCharacter.Event.Raffle.TicketsSold)
			if tickets ~= nil then
				message = string.gsub(message, "%%raffle_tickets", tickets)
			end
		end
	end
	return message
end
local function SendAlertGuildMessages()
	local doBreak = false
	local round = false
	local GoldLeft = ""
	local LotteryTicketPrice = ""
	local RaffleTicketPrice = ""
	if glrCharacter.Data.Settings.CurrentlyActiveLottery then
		round = glrCharacter.Data.Settings.RoundJackpot
		GoldLeft = AlertGuildVariables[14]
		LotteryTicketPrice = AlertGuildVariables[7]
		GoldLeft = GetMoneyValue(GoldLeft, "Lottery", "Jackpot", round, false)
		LotteryTicketPrice = GetMoneyValue(LotteryTicketPrice, "", "", false, false)
	end
	if glrCharacter.Data.Settings.CurrentlyActiveRaffle then
		RaffleTicketPrice = AlertGuildVariables[8]
		RaffleTicketPrice = GetMoneyValue(RaffleTicketPrice, "", "", false, false)
	end
	local LotteryMessages = {
		[1] = "--------------------------------------------------",
		[2] = L["Alert Guild GLR Title"],
		[3] = L["Alert Guild Lottery Scheduled"] .. ": " .. AlertGuildVariables[3],
		[4] = L["Lottery"] .. " " .. L["Alert Guild Event Name"] .. ": " .. AlertGuildVariables[1],
		[5] = L["Alert Guild Ticket Info Part 1"] .. " " .. LotteryTicketPrice .. " " .. L["Alert Guild Ticket Info Part 2"],
		[6] = L["Alert Guild Ticket Info Part 3"] .. " " .. AlertGuildVariables[5] .. " " .. L["Alert Guild Ticket Info Part 4"],
		[7] = L["Alert Guild Tickets Bought"] .. ": " .. GoldLeft,
		[8] = L["Alert Guild Whisper For Lottery Info"],
		[9] = "--------------------------------------------------"
	}
	local RaffleMessages = {
		[1] = "--------------------------------------------------",
		[2] = L["Alert Guild GLR Title"],
		[3] = L["Alert Guild Raffle Scheduled"] .. ": " .. AlertGuildVariables[4],
		[4] = L["Raffle"] .. " " .. L["Alert Guild Event Name"] .. ": " .. AlertGuildVariables[2],
		[5] = L["Alert Guild Ticket Info Part 1"] .. " " .. RaffleTicketPrice .. " " .. L["Alert Guild Ticket Info Part 2"],
		[6] = L["Alert Guild Ticket Info Part 3"]  .. " " .. AlertGuildVariables[6] .. " " .. L["Alert Guild Ticket Info Part 4"],
		[7] = AlertGuildVariables[11] .. " " .. L["Alert Guild Raffle Tickets Bought"],
		[8] = L["Raffle Draw Step 1"] .. ": ",
		[9] = L["Alert Guild Whisper For Raffle Info"],
		[10] = "--------------------------------------------------"
	}
	local BothEventMessages = {
		[1] = "--------------------------------------------------",
		[2] = L["Alert Guild GLR Title"],
		[3] = L["Alert Guild LaR Scheduled"] .. ":",
		[4] = L["Lottery"] .. ": " .. AlertGuildVariables[3] .. ". " .. L["Raffle"] .. ": " .. AlertGuildVariables[4],
		[5] = L["Lottery"] .. " " .. L["Alert Guild Event Name"] .. ": " .. AlertGuildVariables[1] .. ", " .. L["Raffle"] .. " " .. L["Alert Guild Event Name"] .. ": " .. AlertGuildVariables[2],
		[6] = L["Lottery"] .. ": " .. L["Alert Guild Ticket Info Part 1"] .. " " .. LotteryTicketPrice .. " " .. L["Alert Guild Ticket Info Part 2"],
		[7] = L["Lottery"] .. ": " .. L["Alert Guild Ticket Info Part 3"] .. " " .. AlertGuildVariables[5] .. " " .. L["Alert Guild Ticket Info Part 4"],
		[8] = L["Lottery"] .. ": " .. L["Alert Guild Tickets Bought"] .. " " .. GoldLeft,
		[9] = L["Raffle"] .. ": " .. L["Alert Guild Ticket Info Part 1"] .. " " .. RaffleTicketPrice .. " " .. L["Alert Guild Ticket Info Part 2"],
		[10] = L["Raffle"] .. ": " .. L["Alert Guild Ticket Info Part 3"] .. " " .. AlertGuildVariables[6] .. " " .. L["Alert Guild Ticket Info Part 4"],
		[11] = L["Raffle"] .. ": " .. AlertGuildVariables[11] .. " " .. L["Alert Guild Raffle Tickets Bought"],
		[12] = L["Alert Guild Whisper For LaR Info"],
		[13] = "--------------------------------------------------"
	}
	if LotteryAlert and not RaffleAlert then
		if AlertCount <= 9 then
			if glrCharacter.Data.Messages.GuildAlerts.Lottery[8] and AlertCount >= 2 and AlertCount <= 8 then
				local number = AlertCount - 1
				local message = GetAlertMessage(number, "Lottery")
				if message ~= "" then
					SendChatMessage(message, "GUILD")
				end
			elseif glrCharacter.Data.Messages.GuildAlerts.Lottery[8] then
				if AlertCount == 1 or AlertCount == 9 then
					SendChatMessage(LotteryMessages[AlertCount], "GUILD")
				end
			elseif AlertCount <= 9 then
				SendChatMessage(LotteryMessages[AlertCount], "GUILD")
			end
		end
	elseif RaffleAlert and not LotteryAlert then
		if AlertCount <= 10 then
			if glrCharacter.Data.Messages.GuildAlerts.Raffle[9] and AlertCount >= 2 and AlertCount <= 9 then
				local number = AlertCount - 1
				local message = GetAlertMessage(number, "Raffle")
				if message ~= "" then
					SendChatMessage(message, "GUILD")
				end
			elseif glrCharacter.Data.Messages.GuildAlerts.Raffle[9] then
				if AlertCount == 1 or AlertCount == 10 then
					SendChatMessage(RaffleMessages[AlertCount], "GUILD")
				end
			elseif AlertCount <= 10 then
				if AlertCount == 8 then
					local prizes = glrCharacter.Event.Raffle.FirstPlace
					if glrCharacter.Event.Raffle.SecondPlace ~= false then
						prizes = prizes .. ", " .. glrCharacter.Event.Raffle.SecondPlace
					end
					if glrCharacter.Event.Raffle.ThirdPlace ~= false then
						prizes = prizes .. ", " .. glrCharacter.Event.Raffle.ThirdPlace
					end
					RaffleMessages[AlertCount] = RaffleMessages[AlertCount] .. prizes
					SendChatMessage(RaffleMessages[AlertCount], "GUILD")
				else
					SendChatMessage(RaffleMessages[AlertCount], "GUILD")
				end
			end
		end
	elseif LotteryAlert and RaffleAlert then
		if glrCharacter.Data.Messages.GuildAlerts.Both[12] and AlertCount >= 2 and AlertCount <= 12 then
			local number = AlertCount - 1
			local message = GetAlertMessage(number, "Both")
			if message ~= "" then
				SendChatMessage(message, "GUILD")
			end
		elseif glrCharacter.Data.Messages.GuildAlerts.Both[12] then
			if AlertCount == 1 or AlertCount == 13 then
				SendChatMessage(BothEventMessages[AlertCount], "GUILD")
			end
		elseif AlertCount <= 13 then
			SendChatMessage(BothEventMessages[AlertCount], "GUILD")
		end
	end
	AlertCount = AlertCount + 1
	if AlertCount == 17 then
		doBreak = true
	end
	if doBreak then
		DetectPhrases = true
	end
	if AlertCount <= 16 and not doBreak then
		C_Timer.After(0.25, SendAlertGuildMessages)
	end
end

function GLR:AlertGuild()
	
	local dateTime = time()
	local lA = 0
	local tBA = glrCharacter.Data.Settings.TimeBetweenAlerts
	local lotteryStatus = glrCharacter.Data.Settings.CurrentlyActiveLottery
	local raffleStatus = glrCharacter.Data.Settings.CurrentlyActiveRaffle
	AlertCount = 1
	LotteryAlert = false
	RaffleAlert = false
	DetectPhrases = false
	AlertGuildVariables = { [1] = "", [2] = "", [3] = "", [4] = "", [5] = 0, [6] = 0, [7] = 0, [8] = 0, [9] = 0, [10] = 0, [11] = 0, [12] = 0, [13] = 0, [14] = 0, [15] = 0, [16] = false, [17] = false, [18] = false }
	
	if glrCharacter.Data.Settings.LastAlert == nil then
		glrCharacter.Data.Settings.LastAlert = dateTime
	end
	
	if glrCharacter.Data.Settings.LastAlert ~= nil then
		lA = glrCharacter.Data.Settings.LastAlert
	else
		lA = dateTime
	end
	
	local totalTime = lA + tBA
	
	if lotteryStatus or raffleStatus then
		
		if totalTime < dateTime then
			
			if lotteryStatus then
				AlertGuildVariables[1] = glrCharacter.Event.Lottery.EventName
				AlertGuildVariables[3] = glrCharacter.Event.Lottery.Date
				AlertGuildVariables[5] = glrCharacter.Event.Lottery.MaxTickets
				AlertGuildVariables[7] = glrCharacter.Event.Lottery.TicketPrice
				AlertGuildVariables[9] = tonumber(glrCharacter.Event.Lottery.StartingGold)
				AlertGuildVariables[10] = glrCharacter.Event.Lottery.TicketsSold
				AlertGuildVariables[12] = tonumber(glrCharacter.Event.Lottery.TicketPrice)
				AlertGuildVariables[13] = AlertGuildVariables[9] + ( AlertGuildVariables[10] * AlertGuildVariables[12] )
				AlertGuildVariables[15] = (tonumber(glrCharacter.Event.Lottery.GuildCut) / 100) * AlertGuildVariables[13]
				AlertGuildVariables[14] = tostring(AlertGuildVariables[13] - AlertGuildVariables[15])
				LotteryAlert = true
			end
			if raffleStatus then
				AlertGuildVariables[2] = glrCharacter.Event.Raffle.EventName
				AlertGuildVariables[4] = glrCharacter.Event.Raffle.Date
				AlertGuildVariables[6] = glrCharacter.Event.Raffle.MaxTickets
				AlertGuildVariables[8] = glrCharacter.Event.Raffle.TicketPrice
				AlertGuildVariables[11] = glrCharacter.Event.Raffle.TicketsSold
				AlertGuildVariables[16] = glrCharacter.Data.Raffle.FirstPrizeData.ItemName
				if glrCharacter.Event.Raffle.SecondPlace ~= false then
					AlertGuildVariables[17] = glrCharacter.Data.Raffle.SecondPrizeData.ItemName
				end
				if glrCharacter.Event.Raffle.ThirdPlace ~= false then
					AlertGuildVariables[18] = glrCharacter.Data.Raffle.ThirdPrizeData.ItemName
				end
				RaffleAlert = true
			end
			
			glrCharacter.Data.Settings.LastAlert = dateTime
			
			if lotteryStatus and not raffleStatus then
				
				C_Timer.After(0.25, SendAlertGuildMessages)
				
			elseif raffleStatus and not lotteryStatus then
				
				C_Timer.After(0.25, SendAlertGuildMessages)
				
			elseif lotteryStatus and raffleStatus then
				
				C_Timer.After(0.25, SendAlertGuildMessages)
				
			end
			
		else
			
			GLR:Print("|cfff7ff4d" .. L["Alert Guild Time Between Alerts Part 1"] .. tBA .. L["Alert Guild Time Between Alerts Part 2"] .. "|r")
			
		end
		
	else
		
		if not lotteryStatus or not raffleStatus then
			
			if not lotteryStatus and raffleStatus then
				GLR:Print("|cfff7ff4d" .. L["Alert Guild No Lottery Active"] .. "|r")
			elseif not raffleStatus and lotteryStatus then
				GLR:Print("|cfff7ff4d" .. L["Alert Guild No Raffle Active"] .. "|r")
			elseif not lotteryStatus and not raffleStatus then
				GLR:Print("|cfff7ff4d" .. L["Alert Guild No LoR Active"] .. "|r")
			end
			
		end
		
	end
	
end

--------------------------------------------- ---------
------------ ADD PLAYER TO EVENT ------------
---------------------------------------------
--------- ADDS A PLAYER TO THE EVENT --------
---------------------------------------------

function GLR:AddPlayerToEvent(EventType)
	
	local state = EventType
	local faction, _ = UnitFactionGroup("PLAYER")
	local status = glrCharacter.Data.Settings.MultiGuild
	local PlayerNames = GenerateRosterNames()
	local PlayerName = ""
	local PlayerTickets = 0
	local MaxTicket = tonumber(glrCharacter.Event[state].MaxTickets)
	local dateTime = time()
	local guaranteedWinner = false
	local FreeTickets = false
	local continue = false
	local numTotalMembers, _, _ = GetNumGuildMembers()
	
	if state == "Lottery" then
		PlayerName = GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox:GetText()
		PlayerTickets = tonumber(GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerTicketsToLotteryEditBox:GetText())
		FreeTickets = GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddFreeLotteryTicketsCheckButton:GetChecked()
		if glrCharacter.Event[state].SecondPlace == L["Winner Guaranteed"] then
			guaranteedWinner = true
		end
	else
		PlayerName = GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox:GetText()
		PlayerTickets = tonumber(GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerTicketsToRaffleEditBox:GetText())
		FreeTickets = GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddFreeRaffleTicketsCheckButton:GetChecked()
		guaranteedWinner = true
	end
	
	if not status then
		for i = 1, numTotalMembers do
			local name, _, _, level, class, _, _, _, isOnline, _, _, _, _, _, _, _ = GetGuildRosterInfo(i)
			if PlayerName == name then
				if isOnline then
					continue = true
				end
				break
			end
		end
	end
	
	if glrTemp == nil then
		glrTemp = {}
	end
	if glrTemp[state] == nil then
		glrTemp[state] = {}
	end
	if glrTemp[state][PlayerName] == nil then
		glrTemp[state][PlayerName] = {}
	end
	if glrTemp[state][PlayerName].TicketNumbers == nil then
		glrTemp[state][PlayerName].TicketNumbers = {}
	end
	if glrTemp[state][PlayerName]["NumberOfTickets"] == nil then
		glrTemp[state][PlayerName]["NumberOfTickets"] = {}
	end
	if glrCharacter[state] == nil then
		glrCharacter[state] = {}
	end
	if glrCharacter[state].Entries.TicketRange == nil then
		glrCharacter[state].Entries.TicketRange = {}
	end
	if glrCharacter[state].Entries.TicketRange[PlayerName] == nil then
		glrCharacter[state].Entries.TicketRange[PlayerName] = { ["LowestTicketNumber"] = 0, ["HighestTicketNumber"] = 0 }
	end
	if glrTemp[state][PlayerName].TicketRange == nil then
		glrTemp[state][PlayerName].TicketRange = { ["LowestTicketNumber"] = 0, ["HighestTicketNumber"] = 0 }
	end
	
	if PlayerTickets == nil or PlayerName == "" then
		
		if state == "Lottery" then
			if PlayerTickets == nil then
				GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_ExceededParameters:SetText(L["Add Player Must Have Tickets"])
			elseif PlayerName == "" then
				GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_ExceededParameters:SetText(L["Add Player No Name Given"])
			end
		else
			if PlayerTickets == nil then
				GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_ExceededParameters:SetText(L["Add Player Must Have Tickets"])
			elseif PlayerName == "" then
				GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_ExceededParameters:SetText(L["Add Player No Name Given"])
			end
		end
		
	elseif PlayerTickets <= MaxTicket and PlayerTickets > 0 then
		
		if glrCharacter[state].Entries.Tickets[PlayerName] == nil then
			
			glrCharacter[state].Entries.Tickets[PlayerName] = {}
			glrCharacter[state].Entries.Tickets[PlayerName].NumberOfTickets = {}
			glrCharacter[state].Entries.Tickets[PlayerName].NumberOfTickets = PlayerTickets
			
			if FreeTickets then
				glrCharacter[state].Entries.Tickets[PlayerName].Given = PlayerTickets
				glrCharacter[state].Entries.Tickets[PlayerName].Sold = 0
				glrCharacter.Event[state].GiveAwayTickets = glrCharacter.Event[state].GiveAwayTickets + PlayerTickets
			else
				glrCharacter[state].Entries.Tickets[PlayerName].Given = 0
				glrCharacter[state].Entries.Tickets[PlayerName].Sold = PlayerTickets
				glrCharacter.Event[state].TicketsSold = glrCharacter.Event[state].TicketsSold + PlayerTickets
			end
			
			glrTemp[state][PlayerName].NumberOfTickets = PlayerTickets
			
			if state == "Lottery" then
				GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_ExceededParameters:SetText("")
			else
				GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_ExceededParameters:SetText("")
			end
			
			table.insert(glrCharacter[state].Entries.Names, PlayerName)
			
			if glrCharacter[state].Entries.TicketNumbers[PlayerName] == nil then
				
				local TicketNumber = glrCharacter.Event[state].LastTicketBought
				local FirstTicketNumberBought = true
				local LastTicketNumberBought = true
				
				glrCharacter[state].Entries.TicketNumbers[PlayerName] = {}
				
				if glrCharacter[state].TicketPool[1] ~= nil then
					
					for i = 1, PlayerTickets do
						
						if glrCharacter[state].TicketPool[1] ~= nil then
							
							table.insert(glrCharacter[state].Entries.TicketNumbers[PlayerName], glrCharacter[state].TicketPool[1])
							table.insert(glrTemp[state][PlayerName].TicketNumbers, glrCharacter[state].TicketPool[1])
							if FirstTicketNumberBought then
								glrCharacter[state].Entries.TicketRange[PlayerName].LowestTicketNumber = tonumber(glrCharacter[state].TicketPool[1])
								glrTemp[state][PlayerName].TicketRange.LowestTicketNumber = tonumber(glrCharacter[state].TicketPool[1])
								FirstTicketNumberBought = false
							end
							if PlayerTickets == i and LastTicketNumberBought then
								glrCharacter[state].Entries.TicketRange[PlayerName].HighestTicketNumber = tonumber(glrCharacter[state].TicketPool[1])
								glrTemp[state][PlayerName].TicketRange.HighestTicketNumber = tonumber(glrCharacter[state].TicketPool[1])
								LastTicketNumberBought = false
							end
							table.remove(glrCharacter[state].TicketPool, 1)
							
						else
							
							if TicketNumber == 1000 or TicketNumber == 2000 or TicketNumber == 3000 or TicketNumber == 4000 or TicketNumber == 5000 or TicketNumber == 6000 or TicketNumber == 7000 or TicketNumber == 8000 or TicketNumber == 9000 then
								local TicketString = tostring(TicketNumber)
								table.insert(glrCharacter[state].Entries.TicketNumbers[PlayerName], TicketString)
								table.insert(glrTemp[state][PlayerName].TicketNumbers, TicketString)
								if FirstTicketNumberBought then
									glrCharacter[state].Entries.TicketRange[PlayerName].LowestTicketNumber = TicketNumber
									glrTemp[state][PlayerName].TicketRange.LowestTicketNumber = TicketNumber
									FirstTicketNumberBought = false
								end
								if PlayerTickets == i and LastTicketNumberBought then
									glrCharacter[state].Entries.TicketRange[PlayerName].HighestTicketNumber = TicketNumber
									glrTemp[state][PlayerName].TicketRange.HighestTicketNumber = TicketNumber
									LastTicketNumberBought = false
								end
								if guaranteedWinner then
									TicketNumber = TicketNumber + 1
								else
									TicketNumber = TicketNumber + 2
								end
								glrCharacter.Event[state].LastTicketBought = TicketNumber
							else
								local TicketString = tostring(TicketNumber)
								table.insert(glrCharacter[state].Entries.TicketNumbers[PlayerName], TicketString)
								table.insert(glrTemp[state][PlayerName].TicketNumbers, TicketString)
								if FirstTicketNumberBought then
									glrCharacter[state].Entries.TicketRange[PlayerName].LowestTicketNumber = TicketNumber
									glrTemp[state][PlayerName].TicketRange.LowestTicketNumber = TicketNumber
									FirstTicketNumberBought = false
								end
								if PlayerTickets == i and LastTicketNumberBought then
									glrCharacter[state].Entries.TicketRange[PlayerName].HighestTicketNumber = TicketNumber
									glrTemp[state][PlayerName].TicketRange.HighestTicketNumber = TicketNumber
									LastTicketNumberBought = false
								end
								if guaranteedWinner then
									glrCharacter.Event[state].LastTicketBought = TicketNumber + 1
									TicketNumber = TicketNumber + 1
								else
									glrCharacter.Event[state].LastTicketBought = TicketNumber + 2
									TicketNumber = TicketNumber + 2
								end
							end
							
						end
						
					end
					
					if glrCharacter[state].TicketPool[1] ~= nil then
						sort(glrCharacter[state].TicketPool)
					end
					
				else
					
					for i = 1, PlayerTickets do
						
						if TicketNumber == 1000 or TicketNumber == 2000 or TicketNumber == 3000 or TicketNumber == 4000 or TicketNumber == 5000 or TicketNumber == 6000 or TicketNumber == 7000 or TicketNumber == 8000 or TicketNumber == 9000 then
							local TicketString = tostring(TicketNumber)
							table.insert(glrCharacter[state].Entries.TicketNumbers[PlayerName], TicketString)
							table.insert(glrTemp[state][PlayerName].TicketNumbers, TicketString)
							if FirstTicketNumberBought then
								glrCharacter[state].Entries.TicketRange[PlayerName].LowestTicketNumber = TicketNumber
								glrTemp[state][PlayerName].TicketRange.LowestTicketNumber = TicketNumber
								FirstTicketNumberBought = false
							end
							if PlayerTickets == i and LastTicketNumberBought then
								glrCharacter[state].Entries.TicketRange[PlayerName].HighestTicketNumber = TicketNumber
								glrTemp[state][PlayerName].TicketRange.HighestTicketNumber = TicketNumber
								LastTicketNumberBought = false
							end
							if guaranteedWinner then
								TicketNumber = TicketNumber + 1
							else
								TicketNumber = TicketNumber + 2
							end
							glrCharacter.Event[state].LastTicketBought = TicketNumber
						else
							local TicketString = tostring(TicketNumber)
							table.insert(glrCharacter[state].Entries.TicketNumbers[PlayerName], TicketString)
							table.insert(glrTemp[state][PlayerName].TicketNumbers, TicketString)
							if FirstTicketNumberBought then
								glrCharacter[state].Entries.TicketRange[PlayerName].LowestTicketNumber = TicketNumber
								glrTemp[state][PlayerName].TicketRange.LowestTicketNumber = TicketNumber
								FirstTicketNumberBought = false
							end
							if PlayerTickets == i and LastTicketNumberBought then
								glrCharacter[state].Entries.TicketRange[PlayerName].HighestTicketNumber = TicketNumber
								glrTemp[state][PlayerName].TicketRange.HighestTicketNumber = TicketNumber
								LastTicketNumberBought = false
							end
							if guaranteedWinner then
								glrCharacter.Event[state].LastTicketBought = TicketNumber + 1
								TicketNumber = TicketNumber + 1
							else
								glrCharacter.Event[state].LastTicketBought = TicketNumber + 2
								TicketNumber = TicketNumber + 2
							end
						end
						
					end
					
				end
				
				GLR_UI.GLR_MainFrame.GLR_TicketNumberRangeBorderHigh:SetText(TicketNumber)
				
				if state == "Lottery" then
					GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddFreeLotteryTicketsCheckButton:SetChecked(false)
					GLR_UI.GLR_AddPlayerToLotteryFrame:Hide()
				else
					GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddFreeRaffleTicketsCheckButton:SetChecked(false)
					GLR_UI.GLR_AddPlayerToRaffleFrame:Hide()
				end
				
				GLR_U:UpdateInfo()
				
				if glrCharacter[state].MessageStatus == nil then
					glrCharacter[state].MessageStatus = {}
				end
				if glrCharacter[state].MessageStatus[PlayerName] == nil then
					if not FreeTickets then
						glrCharacter[state].MessageStatus[PlayerName] = { ["sentMessage"] = false, ["lastAlert"] = dateTime }
					else
						glrCharacter[state].MessageStatus[PlayerName] = { ["sentMessage"] = true, ["lastAlert"] = dateTime }
					end
				end
				
				local vN = PlayerName
				local targetRealm
				local bypass = false
				local removed = false
				
				if string.find(string.lower(PlayerName), "-") ~= nil then
					targetRealm = string.sub(PlayerName, string.find(PlayerName, "-") + 1)
				else
					bypass = true
				end
				
				if PlayerRealmName == targetRealm and not bypass then
					vN = string.sub(PlayerName, 1, string.find(PlayerName, "-") - 1)
					removed = true
				end
				
				if continue then
					
					GLR:SendPlayerTheirTicketInfo(glrTemp, vN, state)
					
				elseif not continue and status then
					local printed = false
					--With Multi-Guild Events enabled, the mod will only attempt to send a message to the target player if they're part of the same faction.
					for key, val in pairs(glrHistory.GuildRoster[faction]) do
						for i = 1, #glrHistory.GuildRoster[faction][key] do
							local CompareText = string.sub(glrHistory.GuildRoster[faction][key][i], 1, string.find(glrHistory.GuildRoster[faction][key][i], '%[') - 1)
							if removed then
								CompareText = string.sub(CompareText, 1, string.find(CompareText, '-') - 1)
							end
							if CompareText == vN then
								continue = true
								break
							end
						end
						if continue then
							break
						end
					end
					if continue then
						if not glrCharacter[state].MessageStatus[PlayerName]["sentMessage"] then
							local target = GLR_Libs.WhoLib:UserInfo(vN, 
								{
									timeout = 1,
									Online,
									callback = function(target)
										GLR:CheckMultiGuildPlayerStatus(target, glrTemp, vN, state)
									end
								}
							)
						end
					end
					
				elseif not continue and not status then
					
					if glrCharacter.Data.Settings.ToggleChatInfo then
						GLR:Print("|cfff7ff4d" .. PlayerName .. " " .. L["Send Info Player Not Online"] .. "|r")
					end
					
				end
				
			end
			
		else
			if state == "Lottery" then
				GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_ExceededParameters:SetText(L["Add Player They Already Exist"])
			else
				GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_ExceededParameters:SetText(L["Add Player They Already Exist"])
			end
		end
		
	else
		
		if PlayerTickets > MaxTicket then
			if state == "Lottery" then
				GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_ExceededParameters:SetText(L["Add Player Max Tickets Exceeded"])
			else
				GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_ExceededParameters:SetText(L["Add Player Max Tickets Exceeded"])
			end
		else
			if state == "Lottery" then
				GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_ExceededParameters:SetText(L["Add Player Cant Have 0 Tickets"])
			else
				GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_ExceededParameters:SetText(L["Add Player Cant Have 0 Tickets"])
			end
		end
		
	end
	
end

--------------------------------------------- ---------
-------- CHANGE EXISTING PLAYER INFO --------
---------------------------------------------
------------- IF PLAYER EXISTS --------------
------------ CHANGES THEIR INFO -------------
---------------------------------------------

function GLR:ChangePlayerInEventInfo(EventType)
	
	local currentName
	local nameChange
	local ticketString
	local state = EventType
	local MaxTicket = tonumber(glrCharacter.Event[state].MaxTickets)
	local faction, _ = UnitFactionGroup("PLAYER")
	local status = glrCharacter.Data.Settings.MultiGuild
	local PlayerNames = GenerateRosterNames()
	local oldTickets = glrCharacter[state].Entries.Tickets
	local oldTicketNumbers = glrCharacter[state].Entries.TicketNumbers
	local oldTicketRange = glrCharacter[state].Entries.TicketRange
	local glrTempStatus = glrCharacter[state].MessageStatus
	local guaranteedWinner = false
	local continue = false
	local FreeTickets = false
	local FirstTicketNumberBought = true
	local LastTicketNumberBought = true
	local numTotalMembers, _, _ = GetNumGuildMembers()
	
	if state == "Lottery" then
		currentName = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionText:GetText()
		nameChange = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox:GetText()
		ticketString = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerTicketsEditBox:GetText()
		FreeTickets = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_EditFreeLotteryTicketsCheckButton:GetChecked()
		if glrCharacter.Event[state].SecondPlace == L["Winner Guaranteed"] then
			guaranteedWinner = true
		end
	else
		currentName = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionText:GetText()
		nameChange = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox:GetText()
		ticketString = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerTicketsEditBox:GetText()
		FreeTickets = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_EditFreeRaffleTicketsCheckButton:GetChecked()
		guaranteedWinner = true
	end
	
	if currentName == nil or currentName == "" or nameChange == nil or nameChange == "" then return end
	
	local currentTickets = glrCharacter[state].Entries.Tickets[currentName].NumberOfTickets
	local currentSold = glrCharacter[state].Entries.Tickets[currentName].Sold
	local currentGiven = glrCharacter[state].Entries.Tickets[currentName].Given
	local ticketChange = tonumber(ticketString)
	
	if currentGiven == nil then currentGiven = 0 end
	if currentSold == nil then currentSold = glrCharacter[state].Entries.Tickets[currentName].NumberOfTickets end
	
	if glrCharacter[state].Entries.Tickets[currentName].Given == nil then glrCharacter[state].Entries.Tickets[currentName].Given = 0 end
	if glrCharacter[state].Entries.Tickets[currentName].Sold == nil then glrCharacter[state].Entries.Tickets[currentName].Sold = glrCharacter[state].Entries.Tickets[currentName].NumberOfTickets end
	
	if not status then
		for i = 1, numTotalMembers do
			local name, _, _, level, class, _, _, _, isOnline, _, _, _, _, _, _, _ = GetGuildRosterInfo(i)
			if currentName == nameChange and currentName == name then
				if isOnline then
					continue = true
				end
				break
			elseif currentName ~= nameChange and nameChange == name then
				if isOnline then
					continue = true
				end
				break
			end
		end
	end
	
	if currentName ~= L["GLR_Error_No_Entries_Found"] then
		
		if ticketChange ~= nil then
			
			if glrCharacter[state].Entries.Tickets[nameChange] ~= nil and ticketChange > MaxTicket then
				
				if state == "Lottery" then
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_ExceededLotteryTickets:SetText(L["Edit Player Name Exists & Max Tickets Exceeded"])
				else
					GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_ExceededRaffleTickets:SetText(L["Edit Player Name Exists & Max Tickets Exceeded"])
				end
				
			elseif ticketChange <= MaxTicket then
				
				if currentName ~= nameChange then
					
					if glrCharacter[state].Entries.Tickets[nameChange] ~= nil then
						
						if state == "Lottery" then
							GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_ExceededLotteryTickets:SetText(L["Edit Player Name Exists"])
						else
							GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_ExceededRaffleTickets:SetText(L["Edit Player Name Exists"])
						end
						
					else
						
						if ticketChange ~= currentTickets then
							
							if glrTemp == nil then
								glrTemp = {}
							end
							if glrTemp[state] == nil then
								glrTemp[state] = {}
							end
							if glrTemp[state][nameChange] == nil then
								glrTemp[state][nameChange] = {}
							end
							if glrTemp[state][nameChange].NumberOfTickets == nil then
								glrTemp[state][nameChange].NumberOfTickets = {}
							end
							if glrTemp[state][nameChange].TicketNumbers == nil then
								glrTemp[state][nameChange].TicketNumbers = {}
							end
							if glrTemp[state][nameChange].TicketRange == nil then
								glrTemp[state][nameChange].TicketRange = {}
								glrTemp[state][nameChange].TicketRange = { ["LowestTicketNumber"] = 0, ["HighestTicketNumber"] = 0 }
							end
							if glrCharacter[state].Entries.TicketNumbers[nameChange] ~= nil then
								glrTemp[state][nameChange].NumberOfTickets = glrCharacter[state].Entries.Tickets[nameChange].NumberOfTickets
								glrTemp[state][nameChange].TicketNumbers = glrCharacter[state].Entries.TicketNumbers[nameChange]
							elseif glrCharacter[state].Entries.TicketNumbers[currentName] ~= nil then
								glrTemp[state][nameChange].NumberOfTickets = glrCharacter[state].Entries.Tickets[currentName].NumberOfTickets
								glrTemp[state][nameChange].TicketNumbers = glrCharacter[state].Entries.TicketNumbers[currentName]
							end
							if glrCharacter[state].Entries.TicketRange[nameChange] ~= nil then
								glrTemp[state][nameChange].TicketRange.LowestTicketNumber = glrCharacter[state].Entries.TicketRange[nameChange].LowestTicketNumber
								glrTemp[state][nameChange].TicketRange.HighestTicketNumber = glrCharacter[state].Entries.TicketRange[nameChange].HighestTicketNumber
							end
							if glrCharacter[state].Entries.TicketRange[currentName] ~= nil then
								glrTemp[state][nameChange].TicketRange.LowestTicketNumber = glrCharacter[state].Entries.TicketRange[currentName].LowestTicketNumber
								glrTemp[state][nameChange].TicketRange.HighestTicketNumber = glrCharacter[state].Entries.TicketRange[currentName].HighestTicketNumber
							end
							
							
							if ticketChange < currentTickets then
								
								local ticketDifference = currentTickets - ticketChange
								local TicketNumber = glrCharacter.Event[state].LastTicketBought
								local holdTickets = {}
								
								for i = 1, #glrTemp[state][nameChange].TicketNumbers do
									
									local v = glrTemp[state][nameChange].TicketNumbers[i]
									table.insert(holdTickets, v)
									
								end
								
								for i = 1, ticketDifference do
									
									i = currentTickets
									TicketNumber = TicketNumber - 1
									local TicketString = tostring(TicketNumber)
									table.insert(glrCharacter[state].TicketPool, holdTickets[i])
									if ticketDifference == i and LastTicketNumberBought and ticketChange > 0 then
										glrCharacter[state].Entries.TicketRange[currentName].HighestTicketNumber = tonumber(holdTickets[i])
										glrTemp[state][nameChange].TicketRange.HighestTicketNumber = tonumber(holdTickets[i])
										LastTicketNumberBought = false
									end
									if ticketChange == 0 then
										glrCharacter[state].Entries.TicketRange[currentName].LowestTicketNumber = 0
										glrCharacter[state].Entries.TicketRange[currentName].HighestTicketNumber = 0
										glrTemp[state][nameChange].TicketRange.LowestTicketNumber = 0
										glrTemp[state][nameChange].TicketRange.HighestTicketNumber = 0
										LastTicketNumberBought = false
										FirstTicketNumberBought = false
									end
									table.remove(glrCharacter[state].Entries.TicketNumbers[currentName], i)
									table.remove(glrTemp[state][nameChange], i)
									currentTickets = currentTickets - 1
									
								end
								
								holdTickets = nil
								
								sort(glrCharacter[state].TicketPool)
								sort(glrCharacter[state].Entries.TicketNumbers[currentName])
								
								local change = ticketDifference
								
								if currentGiven > 0 then
									for i = 1, ticketDifference do
										glrCharacter[state].Entries.Tickets[currentName].Given = glrCharacter[state].Entries.Tickets[currentName].Given - 1
										glrCharacter.Event[state].GiveAwayTickets = glrCharacter.Event[state].GiveAwayTickets - 1
										change = change - 1
										if glrCharacter.Event[state].GiveAwayTickets == 0 then break end
										if glrCharacter[state].Entries.Tickets[currentName].Given == 0 then break end
									end
								end
								
								if currentSold > 0 then
									if change > 0 then
										for i = 1, change do
											glrCharacter[state].Entries.Tickets[currentName].Sold = glrCharacter[state].Entries.Tickets[currentName].Sold - 1
											glrCharacter.Event[state].TicketsSold = glrCharacter.Event[state].TicketsSold - 1
											if glrCharacter.Event[state].TicketsSold == 0 then break end
											if glrCharacter[state].Entries.Tickets[currentName].Sold == 0 then break end
										end
									end
								end
								
								glrCharacter[state].Entries.Tickets[currentName].NumberOfTickets = ticketChange
								glrTemp[state][nameChange].NumberOfTickets = ticketChange
								
							elseif ticketChange > currentTickets then
								
								local ticketIncrease = ticketChange - currentTickets
								local TicketNumber = glrCharacter.Event[state].LastTicketBought
								local holdTickets = {}
								
								for i = 1, #glrTemp[state][nameChange].TicketNumbers do
									
									local v = glrTemp[state][nameChange].TicketNumbers[i]
									table.insert(holdTickets, v)
									
								end
								
								glrCharacter[state].Entries.TicketNumbers[currentName] = nil
								glrCharacter[state].Entries.TicketNumbers[currentName] = {}
								
								for i = 1, ticketIncrease do
									
									if glrCharacter[state].TicketPool[1] ~= nil then
										
										table.insert(glrCharacter[state].Entries.TicketNumbers[currentName], glrCharacter[state].TicketPool[1])
										table.insert(glrTemp[state][nameChange], glrCharacter[state].TicketPool[1])
										if ticketIncrease == i and LastTicketNumberBought then
											glrCharacter[state].Entries.TicketRange[currentName].HighestTicketNumber = tonumber(glrCharacter[state].TicketPool[1])
											glrTemp[state][nameChange].TicketRange.HighestTicketNumber = tonumber(glrCharacter[state].TicketPool[1])
											LastTicketNumberBought = false
										end
										table.remove(glrCharacter[state].TicketPool, 1)
										
									else
										
										local ts = tostring(TicketNumber)
										table.insert(glrCharacter[state].Entries.TicketNumbers[currentName], ts)
										table.insert(glrTemp[state][nameChange], ts)
										if ticketIncrease == i and LastTicketNumberBought then
											glrCharacter[state].Entries.TicketRange[currentName].HighestTicketNumber = TicketNumber
											glrTemp[state][nameChange].TicketRange.HighestTicketNumber = TicketNumber
											LastTicketNumberBought = false
										end
										if guaranteedWinner then
											glrCharacter.Event[state].LastTicketBought = TicketNumber + 1
											TicketNumber = TicketNumber + 1
										else
											glrCharacter.Event[state].LastTicketBought = TicketNumber + 2
											TicketNumber = TicketNumber + 2
										end
										
									end
									
								end
								
								holdTickets = nil
								
								sort(glrCharacter[state].Entries.TicketNumbers[currentName])
								
								if FreeTickets then
									glrCharacter[state].Entries.Tickets[currentName].Given = glrCharacter[state].Entries.Tickets[currentName].Given + ticketIncrease
									glrCharacter.Event[state].GiveAwayTickets = glrCharacter.Event[state].GiveAwayTickets + ticketIncrease
								else
									glrCharacter[state].Entries.Tickets[currentName].Sold = glrCharacter[state].Entries.Tickets[currentName].Sold + ticketIncrease
									glrCharacter.Event[state].TicketsSold = glrCharacter.Event[state].TicketsSold + ticketIncrease
								end
								
								glrCharacter[state].Entries.Tickets[currentName].NumberOfTickets = ticketChange
								glrTemp[state][nameChange].NumberOfTickets = ticketChange
								
							end
							
						end
						
						local replaceTickets = glrCharacter[state].Entries.Tickets[currentName]
						local replaceTicketNumbers = glrCharacter[state].Entries.TicketNumbers[currentName]
						local replaceTicketRange = glrCharacter[state].Entries.TicketRange[currentName]
						local messageValue = glrCharacter[state].MessageStatus[currentName].sentMessage
						local timeValue = glrCharacter[state].MessageStatus[currentName].lastAlert
						
						glrCharacter[state].Entries.Tickets[nameChange] = {}
						glrCharacter[state].Entries.Tickets[nameChange] = replaceTickets
						
						glrCharacter[state].Entries.TicketNumbers[nameChange] = {}
						glrCharacter[state].Entries.TicketNumbers[nameChange] = replaceTicketNumbers
						
						glrCharacter[state].Entries.TicketRange[nameChange] = {}
						glrCharacter[state].Entries.TicketRange[nameChange] = replaceTicketRange
						
						if ticketChange > 0 then
							if not FreeTickets then
								glrCharacter[state].MessageStatus[nameChange] = { ["sentMessage"] = messageValue, ["lastAlert"] = timeValue }
							else
								glrCharacter[state].MessageStatus[nameChange] = { ["sentMessage"] = true, ["lastAlert"] = timeValue }
							end
						end
						
						for t, v in pairs(oldTicketRange) do
							
							if t ~= currentName and oldTickets[t].NumberOfTickets > 0 then
								
								glrCharacter[state].Entries.TicketRange[t] = {}
								glrCharacter[state].Entries.TicketRange[t] = v
								
							elseif t == currentName or oldTickets[t].NumberOfTickets == 0 then
								
								glrCharacter[state].Entries.TicketRange[t] = nil
								
							end
							
						end
						
						for t, v in pairs(oldTicketNumbers) do
							
							if t ~= currentName and oldTickets[t].NumberOfTickets > 0 then
								
								glrCharacter[state].Entries.TicketNumbers[t] = {}
								glrCharacter[state].Entries.TicketNumbers[t] = v
								
							elseif t == currentName or oldTickets[t].NumberOfTickets == 0 then
								
								glrCharacter[state].Entries.TicketNumbers[t] = nil
								
							end
							
						end
						
						for t, v in pairs(oldTickets) do
							
							if t ~= currentName and oldTickets[t].NumberOfTickets > 0 then
								
								glrCharacter[state].Entries.Tickets[t] = {}
								glrCharacter[state].Entries.Tickets[t] = v
								
							elseif t == currentName or oldTickets[t].NumberOfTickets == 0 then
								
								oldTickets[t] = nil
								
							end
							
						end
						
						for i = 1, #glrCharacter[state].Entries.Names do
							
							local name = glrCharacter[state].Entries.Names[i]
							
							if name == currentName then
								
								table.remove(glrCharacter[state].Entries.Names, i)
								table.insert(glrCharacter[state].Entries.Names, nameChange)
								
							end
							
						end
						
						for t, v in pairs(glrTempStatus) do
							
							local value = glrTempStatus[t]["sentMessage"]
							local tValue = glrTempStatus[t]["lastAlert"]
							
							if t ~= currentName then
								
								glrCharacter[state].MessageStatus[t] = { ["sentMessage"] = value, ["lastAlert"] = tValue }
								
							elseif t == currentName then
								
								glrCharacter[state].MessageStatus[t] = nil
								
							end
							
						end
						
					end
					
					GLR_U:UpdateInfo()
					
					if state == "Lottery" then
						GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_EditFreeLotteryTicketsCheckButton:SetChecked(false)
						GLR_UI.GLR_EditPlayerInLotteryFrame:Hide()
					else
						GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_EditFreeRaffleTicketsCheckButton:SetChecked(false)
						GLR_UI.GLR_EditPlayerInRaffleFrame:Hide()
					end
					
					if glrCharacter[state].MessageStatus.nameChange ~= nil then
						
						local state = "Lottery"
						local targetRealm
						local bypass = false
						local vN = nameChange
						
						if string.find(string.lower(nameChange), "-") ~= nil then
							targetRealm = string.sub(nameChange, string.find(nameChange, "-") + 1)
						else
							bypass = true
						end
						
						if PlayerRealmName == targetRealm and not bypass then
							vN = string.sub(nameChange, 1, string.find(nameChange, "-") - 1)
						end
						
						if continue then
							
							GLR:SendPlayerTheirTicketInfo(glrTemp, vN, state)
							
						elseif not continue and status then
							
							--With Multi-Guild Events enabled, the mod will only attempt to send a message to the target player if they're part of the same faction.
							for key, val in pairs(glrHistory.GuildRoster[faction]) do
								for i = 1, #glrHistory.GuildRoster[faction][key] do
									local CompareText = string.sub(glrHistory.GuildRoster[faction][key][i], 1, string.find(glrHistory.GuildRoster[faction][key][i], '%[') - 1)
									if CompareText == v then
										continue = true
										break
									end
								end
								if continue then
									break
								end
							end
							if continue then
								if not glrCharacter[state].MessageStatus[nameChange]["sentMessage"] then
									local target = GLR_Libs.WhoLib:UserInfo(vN, 
										{
											timeout = 1,
											Online,
											callback = function(target)
												GLR:CheckMultiGuildPlayerStatus(target, glrTemp, vN, state)
											end
										}
									)
								end
							end
							
						elseif not continue and not status then
							
							if glrCharacter.Data.Settings.ToggleChatInfo then
								GLR:Print("|cfff7ff4d" .. nameChange .. " " .. L["Send Info Player Not Online"] .. "|r")
							end
							
						end
						
					end
					
				end
				
				if nameChange == currentName then
					
					if ticketChange ~= currentTickets then
						
						if glrTemp == nil then
							glrTemp = {}
						end
						if glrTemp[state] == nil then
							glrTemp[state] = {}
						end
						if glrTemp[state][currentName] == nil then
							glrTemp[state][currentName] = {}
						end
						if glrTemp[state][currentName].TicketNumbers == nil then
							glrTemp[state][currentName].TicketNumbers = {}
						end
						if glrTemp[state][currentName].NumberOfTickets == nil then
							glrTemp[state][currentName].NumberOfTickets = {}
						end
						if glrTemp[state][currentName]["TicketRange"] == nil then
							glrTemp[state][currentName]["TicketRange"] = {}
							glrTemp[state][currentName]["TicketRange"] = { ["LowestTicketNumber"] = 0, ["HighestTicketNumber"] = 0 }
						else
							glrTemp[state][currentName]["TicketRange"] = {}
							glrTemp[state][currentName]["TicketRange"] = { ["LowestTicketNumber"] = 0, ["HighestTicketNumber"] = 0 }
						end
						if glrCharacter[state].Entries.TicketNumbers[currentName] ~= nil then
							glrTemp[state][currentName] = glrCharacter[state].Entries.TicketNumbers[currentName]
							glrTemp[state][currentName].NumberOfTickets = glrCharacter[state].Entries.Tickets[currentName].NumberOfTickets
							glrTemp[state][currentName].TicketNumbers = glrCharacter[state].Entries.TicketNumbers[currentName]
						end
						
						if ticketChange < currentTickets then
							
							local ticketDifference = currentTickets - ticketChange
							local holdTickets = {}
							
							for i = 1, #glrTemp[state][currentName].TicketNumbers do
								
								local v = glrTemp[state][currentName].TicketNumbers[i]
								table.insert(holdTickets, v)
								
							end
							
							if ticketChange == 0 then
								
								if glrCharacter[state].Entries.Tickets[currentName].Given ~= nil then
									if glrCharacter[state].Entries.Tickets[currentName].Given > 0 then
										local RemoveAmount = glrCharacter[state].Entries.Tickets[currentName].Given
										glrCharacter.Event[state].GiveAwayTickets = glrCharacter.Event[state].GiveAwayTickets - RemoveAmount
									end
								end
								if glrCharacter[state].Entries.Tickets[currentName].Sold ~= nil then
									if glrCharacter[state].Entries.Tickets[currentName].Sold > 0 then
										local RemoveAmount = glrCharacter[state].Entries.Tickets[currentName].Sold
										glrCharacter.Event[state].TicketsSold = glrCharacter.Event[state].TicketsSold - RemoveAmount
									end
								end
								
								glrCharacter[state].Entries.TicketNumbers[currentName] = nil
								glrCharacter[state].Entries.Tickets[currentName] = nil
								glrCharacter[state].Entries.TicketRange[currentName] = nil
								
								for i = 1, #glrCharacter[state].Entries.Names do
									
									local name = glrCharacter[state].Entries.Names[i]
									
									if name == currentName then
										
										table.remove(glrCharacter[state].Entries.Names, i)
										
									end
									
								end
								
								for t, v in pairs(glrTempStatus) do
									
									if t == currentName then
										
										glrCharacter[state].MessageStatus[t] = nil
										
									end
									
								end
								
							else
								
								glrCharacter[state].Entries.TicketNumbers[currentName] = nil
								glrCharacter[state].Entries.TicketNumbers[currentName] = {}
								
								for i = 1, ticketChange do
									
									table.insert(glrCharacter[state].Entries.TicketNumbers[currentName], holdTickets[1])
									if ticketChange == i and LastTicketNumberBought then
										glrCharacter[state].Entries.TicketRange[currentName].HighestTicketNumber = tonumber(holdTickets[1])
										LastTicketNumberBought = false
									end
									table.remove(holdTickets, 1)
									
								end
								
								local change = ticketDifference
								
								if currentGiven > 0 then
									for i = 1, ticketDifference do
										glrCharacter[state].Entries.Tickets[currentName].Given = glrCharacter[state].Entries.Tickets[currentName].Given - 1
										change = change - 1
										if glrCharacter[state].Entries.Tickets[currentName].Given == 0 then
											break
										end
									end
								end
								
								if currentSold > 0 then
									if change > 0 then
										for i = 1, change do
											glrCharacter[state].Entries.Tickets[currentName].Sold = glrCharacter[state].Entries.Tickets[currentName].Sold - 1
											glrCharacter.Event[state].TicketsSold = glrCharacter.Event[state].TicketsSold - 1
											if glrCharacter[state].Entries.Tickets[currentName].Sold == 0 then
												break
											end
										end
									end
								end
								
							end
							
							for i = 1, ticketDifference do
								
								table.insert(glrCharacter[state].TicketPool, holdTickets[1])
								table.remove(holdTickets, 1)
								
							end
							
							holdTickets = nil
							
							sort(glrCharacter[state].TicketPool)
							if ticketChange > 0 then
								sort(glrCharacter[state].Entries.TicketNumbers[currentName])
							end
							
							if ticketChange > 0 then
								glrCharacter[state].Entries.Tickets[currentName].NumberOfTickets = ticketChange
							end
							
							GLR_U:UpdateInfo()
							
							if state == "Lottery" then
								GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_EditFreeLotteryTicketsCheckButton:SetChecked(false)
								GLR_UI.GLR_EditPlayerInLotteryFrame:Hide()
							else
								GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_EditFreeRaffleTicketsCheckButton:SetChecked(false)
								GLR_UI.GLR_EditPlayerInRaffleFrame:Hide()
							end
							
						elseif ticketChange > currentTickets then
							
							local ticketIncrease = ticketChange - currentTickets
							local TicketNumber = glrCharacter.Event[state].LastTicketBought
							local holdTickets = {}
							
							for i = 1, #glrTemp[state][currentName].TicketNumbers do
								
								local v = glrTemp[state][currentName].TicketNumbers[i]
								table.insert(holdTickets, v)
								
							end
							
							glrCharacter[state].Entries.TicketNumbers[currentName] = nil
							glrCharacter[state].Entries.TicketNumbers[currentName] = {}
							
							for i = 1, currentTickets do
								
								table.insert(glrCharacter[state].Entries.TicketNumbers[currentName], holdTickets[1])
								table.remove(holdTickets, 1)
								
							end
							
							sort(glrCharacter[state].Entries.TicketNumbers[currentName])
							
							for i = 1, ticketIncrease do
								
								if glrCharacter[state].TicketPool[1] ~= nil then
									
									table.insert(glrCharacter[state].Entries.TicketNumbers[currentName], glrCharacter[state].TicketPool[1])
									table.insert(glrTemp[state][currentName], glrCharacter[state].TicketPool[1])
									if ticketIncrease == i and LastTicketNumberBought then
										glrCharacter[state].Entries.TicketRange[currentName].HighestTicketNumber = tonumber(glrCharacter[state].TicketPool[1])
										LastTicketNumberBought = false
									end
									table.remove(glrCharacter[state].TicketPool, 1)
									
								else
									
									local ts = tostring(TicketNumber)
									table.insert(glrCharacter[state].Entries.TicketNumbers[currentName], ts)
									table.insert(glrTemp[state][currentName], ts)
									if ticketIncrease == i and LastTicketNumberBought then
										glrCharacter[state].Entries.TicketRange[currentName].HighestTicketNumber = TicketNumber
										LastTicketNumberBought = false
									end
									if guaranteedWinner then
										glrCharacter.Event[state].LastTicketBought = TicketNumber + 1
										TicketNumber = TicketNumber + 1
									else
										glrCharacter.Event[state].LastTicketBought = TicketNumber + 2
										TicketNumber = TicketNumber + 2
									end
									
								end
								
							end
							
							sort(glrCharacter[state].TicketPool)
							sort(glrCharacter[state].Entries.TicketNumbers[currentName])
							
							if FreeTickets then
								glrCharacter[state].Entries.Tickets[currentName].Given = glrCharacter[state].Entries.Tickets[currentName].Given + ticketIncrease
								glrCharacter.Event[state].GiveAwayTickets = glrCharacter.Event[state].GiveAwayTickets + ticketIncrease
							else
								glrCharacter[state].Entries.Tickets[currentName].Sold = glrCharacter[state].Entries.Tickets[currentName].Sold + ticketIncrease
								glrCharacter.Event[state].TicketsSold = glrCharacter.Event[state].TicketsSold + ticketIncrease
							end
							
							glrCharacter[state].Entries.Tickets[currentName].NumberOfTickets = ticketChange
							glrTemp[state][currentName].NumberOfTickets = ticketChange
							
						end
						
						GLR_U:UpdateInfo()
						
						if state == "Lottery" then
							GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_EditFreeLotteryTicketsCheckButton:SetChecked(false)
							GLR_UI.GLR_EditPlayerInLotteryFrame:Hide()
						else
							GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_EditFreeRaffleTicketsCheckButton:SetChecked(false)
							GLR_UI.GLR_EditPlayerInRaffleFrame:Hide()
						end
						
						if glrCharacter[state].MessageStatus[currentName] ~= nil then
							
							local targetRealm
							local bypass = false
							local vN = currentName
							
							if string.find(string.lower(currentName), "-") ~= nil then
								targetRealm = string.sub(currentName, string.find(currentName, "-") + 1)
							else
								bypass = true
							end
							
							if PlayerRealmName == targetRealm and not bypass then
								vN = string.sub(currentName, 1, string.find(currentName, "-") - 1)
							end
							
							if continue then
								
								GLR:SendPlayerTheirTicketInfo(glrTemp, vN, state)
								
							elseif not continue and status then
								
								--With Multi-Guild Events enabled, the mod will only attempt to send a message to the target player if they're part of the same faction.
								for key, val in pairs(glrHistory.GuildRoster[faction]) do
									for i = 1, #glrHistory.GuildRoster[faction][key] do
										local CompareText = string.sub(glrHistory.GuildRoster[faction][key][i], 1, string.find(glrHistory.GuildRoster[faction][key][i], '%[') - 1)
										if CompareText == v then
											continue = true
											break
										end
									end
									if continue then
										break
									end
								end
								if continue then
									if not glrCharacter[state].MessageStatus[currentName].sentMessage then
										local target = GLR_Libs.WhoLib:UserInfo(vN, 
											{
												timeout = 1,
												Online,
												callback = function(target)
													GLR:CheckMultiGuildPlayerStatus(target, glrTemp, vN, state)
												end
											}
										)
									end
								end
								
							elseif not continue and not status then
								
								if glrCharacter.Data.Settings.ToggleChatInfo then
									GLR:Print("|cfff7ff4d" .. currentName .. " " .. L["Send Info Player Not Online"] .. "|r")
								end
								
							end
							
						end
						
					end
					
				end
				
			else
				if state == "Lottery" then
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_ExceededLotteryTickets:SetText(L["Edit Player Max Tickets Exceeded"])
				else
					GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_ExceededRaffleTickets:SetText(L["Edit Player Max Tickets Exceeded"])
				end
			end
			
		else
			if state == "Lottery" then
				GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_ExceededLotteryTickets:SetText(L["Edit Player Ticket Not Numerical"])
			else
				GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_ExceededRaffleTickets:SetText(L["Edit Player Ticket Not Numerical"])
			end
		end
		
	end
	
end

--------------------------------------------- ---------
---------- SEND PLAYER TICKET INFO ----------
---------------------------------------------
--------- CHECKS IF PLAYER IS ONLINE --------
--------- AND IN SAME GUILD AS HOST ---------
---------------------------------------------

function GLR:SendPlayerTheirTicketInfo(glrTemp, vN, state)
	
	local EventDate
	local ticketPrice
	local jackpotGold = ""
	local playerGuild = glrCharacter.Data.Settings.GuildName
	local LargeData = glrCharacter.Data.Settings.SendLargeInfo
	local guildPercent
	local userName = vN
	local ticketsN = 0
	local ticketString
	local dateTime = time()
	local prizeOne = false
	local prizeTwo = false
	local prizeThree = false
	local round = false
	
	if not string.find(userName, "-") then
		userName = strjoin("-", userName, PlayerRealmName)
	end
	
	if state == "Lottery" then
		round = glrCharacter.Data.Settings.RoundJackpot
		EventDate = glrCharacter.Event[state].Date
		ticketPrice = glrCharacter.Event[state].TicketPrice
		local tempJackpotGold = tonumber(glrCharacter.Event[state].StartingGold) + ( glrCharacter.Event[state].TicketsSold * tonumber(glrCharacter.Event[state].TicketPrice) )
		guildPercent = glrCharacter.Event[state].GuildCut
		jackpotGold = tempJackpotGold - ( (tonumber(guildPercent) / 100) * tempJackpotGold )
		jackpotGold = GetMoneyValue(jackpotGold, "Lottery", "Jackpot", round, false)
	else
		EventDate = glrCharacter.Event[state].Date
		ticketPrice = glrCharacter.Event[state].TicketPrice
		if glrCharacter.Event[state].FirstPlace then
			prizeOne = glrCharacter.Event[state].FirstPlace
		end
		if glrCharacter.Event[state].SecondPlace then
			prizeTwo = glrCharacter.Event[state].SecondPlace
		end
		if glrCharacter.Event[state].ThirdPlace then
			prizeThree = glrCharacter.Event[state].ThirdPlace
		end
	end
	
	ticketPrice = GetMoneyValue(ticketPrice, "", "", false, false)
	
	if playerGuild ~= nil then
		
		local maxTickets = 0
		local ticketDiff = 0
		
		if glrCharacter[state].Entries.Tickets[userName] ~= nil then
			ticketsN = glrCharacter[state].Entries.Tickets[userName].NumberOfTickets
		else
			ticketsN = glrTemp[state][userName].NumberOfTickets
		end
		
		if glrCharacter[state].Entries.TicketNumbers[userName] ~= nil then
			ticketString = glrCharacter[state].Entries.TicketNumbers[userName]
		else
			ticketString = glrTemp[state][userName].TicketNumbers
		end
		
		if glrCharacter[state].MessageStatus[userName] == nil then
			glrCharacter[state].MessageStatus[userName] = { ["sentMessage"] = true, ["lastAlert"] = dateTime }
		else
			glrCharacter[state].MessageStatus[userName] = { ["sentMessage"] = true, ["lastAlert"] = dateTime }
		end
		
		maxTickets = tonumber(glrCharacter.Event[state].MaxTickets)
		ticketDiff = maxTickets - ticketsN
		
		SendChatMessage("--------------------------------------------------", "WHISPER", nil, userName)
		SendChatMessage(L["Send Info Title"], "WHISPER", nil, userName)
		
		if state == "Lottery" then
			SendChatMessage(L["Send Info Player Lottery Entered"] .. ": " .. EventDate, "WHISPER", nil, userName)
		else
			SendChatMessage(L["Send Info Player Raffle Entered"] .. ": " .. EventDate, "WHISPER", nil, userName)
		end
		
		if ticketsN < maxTickets then
			if ticketDiff == 1 then
				SendChatMessage(L["Send Info Tickets Purchased Part 1"] .. " " .. ticketsN .. " " .. L["Send Info Tickets Purchased Part 2"] .. " " .. ticketDiff .. " " .. L["Send Info Tickets Purchased Part 3.1"] .. " " .. ticketPrice .. " " .. L["Send Info Tickets Purchased Part 4"], "WHISPER", nil, userName)
			else
				SendChatMessage(L["Send Info Tickets Purchased Part 1"] .. " " .. ticketsN .. " " .. L["Send Info Tickets Purchased Part 2"] .. " " .. ticketDiff .. " " .. L["Send Info Tickets Purchased Part 3"] .. " " .. ticketPrice .. " " .. L["Send Info Tickets Purchased Part 4"], "WHISPER", nil, userName)
			end
		else
			SendChatMessage(L["Send Info Max Tickets Part 1"] .. " " .. ticketsN .. " " .. L["Send Info Max Tickets Part 2"], "WHISPER", nil, userName)
		end
		
		if LargeData then
			
			local purchasedTickets
			local ticketNumbers = ""
			
			purchasedTickets = tostring(glrCharacter[state].Entries.Tickets[userName].NumberOfTickets)
			
			if glrCharacter[state].Entries.TicketNumbers[userName] ~= nil then
				ticketString = glrCharacter[state].Entries.TicketNumbers[userName]
			end
			
			for i = 1, #ticketString do
				ticketNumbers = strjoin(" ", ticketNumbers, ticketString[i])
			end
			
			local length = strlen(ticketNumbers)
			
			if length > 220 then
				
				local currentTime = time()
				local longMsg = true
				local bypass = true
				local endMsg = true
				local done = false
				local ta = {}
				local lt = {}
				local ts = ""
				local nt = 0
				local mnt = 0
				local nm = 0
				local steps = 35
				
				if longMsg then
					SendChatMessage(L["Send Info Long Ticket Message"], "WHISPER", nil, userName)
					longMsg = false
				end
				
				for v in string.gmatch(ticketNumbers, "[^ ]+") do
					table.insert(ta, v)
					nt = nt + 1
					mnt = mnt + 1
				end
				
				if mnt >= 500 then
					bypass = false
				end
				
				for i = 1, #ta do
					
					for j = 1, steps do
						if length > 0 or not done then
							if  nt > 0 then
								ts = strjoin(" ", ts, ta[1])
								table.remove(ta, 1)
								nt = nt - 1
							end
						end
					end
					
					if not done then
						nm = nm + 1
						if not bypass then
							table.insert(lt, ts)
						end
						length = length - strlen(ts)
						steps = length / 5
						if steps > 35 then
							steps = 35
						end
						if nt == 0 then
							done = true
						end
					end
					
					if bypass then
						SendChatMessage(L["Send Info GLR"] .. ":" .. ts, "WHISPER", nil, userName)
					end
					
					--Resets the Ticket Number string so it's not a ever growing string until it breaks the character limit
					ts = ""
					
					if done then
						break
					end
					
				end
				
				if not bypass then
					local ms = 0.2
					nm = nm + 1
					sort(lt)
					for i = 1, nm do
						C_Timer.After(ms, function()
							GLR:SendLargeTicketInfo(lt, userName, nm, state)
						end)
						ms = ms + 0.2
					end
				end
				
				if endMsg and bypass and state == "Lottery" then
					SendChatMessage(L["Send Info Current Jackpot Part 1"] .. " " .. guildPercent .. "%. " .. L["Send Info Current Jackpot Part 2"] .. " " .. jackpotGold, "WHISPER", nil, userName)
					SendChatMessage("--------------------------------------------------", "WHISPER", nil, userName)
					endMsg = false
				elseif endMsg and bypass and state == "Raffle" then
					SendChatMessage(L["Send Info Current Prizes"] .. ":", "WHISPER", nil, userName)
					if prizeOne then
						SendChatMessage(L["Send Info GLR"] .. ": " .. prizeOne, "WHISPER", nil, userName)
					end
					if prizeTwo then
						SendChatMessage(L["Send Info GLR"] .. ": " .. prizeTwo, "WHISPER", nil, userName)
					end
					if prizeThree then
						SendChatMessage(L["Send Info GLR"] .. ": " .. prizeThree, "WHISPER", nil, userName)
					end
					SendChatMessage("--------------------------------------------------", "WHISPER", nil, userName)
					endMsg = false
				end
				
			else
				if tonumber(purchasedTickets) > 0 then
					SendChatMessage(L["Send Info Short Ticket Message"] .. ":" .. ticketNumbers, "WHISPER", nil, userName)
					if state == "Lottery" then
						SendChatMessage(L["Send Info Current Jackpot Part 1"] .. " " .. guildPercent .. "%. " .. L["Send Info Current Jackpot Part 2"] .. " " .. jackpotGold, "WHISPER", nil, userName)
					else
						SendChatMessage(L["Send Info Current Prizes"] .. ":", "WHISPER", nil, userName)
						if prizeOne then
							SendChatMessage(L["Send Info GLR"] .. ": " .. prizeOne, "WHISPER", nil, userName)
						end
						if prizeTwo then
							SendChatMessage(L["Send Info GLR"] .. ": " .. prizeTwo, "WHISPER", nil, userName)
						end
						if prizeThree then
							SendChatMessage(L["Send Info GLR"] .. ": " .. prizeThree, "WHISPER", nil, userName)
						end
					end
					SendChatMessage("--------------------------------------------------", "WHISPER", nil, userName)
				end
			end
			
		else
			local fT
			local lT
			if state == "Lottery" then
				fT = glrCharacter[state].Entries.TicketRange[userName].LowestTicketNumber
				lT = glrCharacter[state].Entries.TicketRange[userName].HighestTicketNumber
				local message_1 = string.gsub(string.gsub(L["Send Info Ticket Number Range"], "%%first", fT), "%%last", lT)
				SendChatMessage(message_1, "WHISPER", nil, userName)
				SendChatMessage(L["Send Info Current Jackpot Part 1"] .. " " .. guildPercent .. "%. " .. L["Send Info Current Jackpot Part 2"] .. " " .. jackpotGold, "WHISPER", nil, userName)
			else
				fT = glrCharacter[state].Entries.TicketRange[userName].LowestTicketNumber
				lT = glrCharacter[state].Entries.TicketRange[userName].HighestTicketNumber
				local message_1 = string.gsub(string.gsub(L["Send Info Ticket Number Range"], "%%first", fT), "%%last", lT)
				SendChatMessage(message_1, "WHISPER", nil, userName)
				SendChatMessage(L["Send Info Current Prizes"] .. ":", "WHISPER", nil, userName)
				if prizeOne then
					SendChatMessage(L["Send Info GLR"] .. ": " .. prizeOne, "WHISPER", nil, userName)
				end
				if prizeTwo then
					SendChatMessage(L["Send Info GLR"] .. ": " .. prizeTwo, "WHISPER", nil, userName)
				end
				if prizeThree then
					SendChatMessage(L["Send Info GLR"] .. ": " .. prizeThree, "WHISPER", nil, userName)
				end
			end
			SendChatMessage("--------------------------------------------------", "WHISPER", nil, userName)
		end
	end
	
end

function GLR:SendLargeTicketInfo(lt, userName, nm, state)
	local jackpotGold
	local guildPercent
	if state == "Lottery" then
		local round = glrCharacter.Data.Settings.RoundJackpot
		local tempJackpotGold = tonumber(glrCharacter.Event[state].StartingGold) + ( glrCharacter.Event[state].TicketsSold * tonumber(glrCharacter.Event[state].TicketPrice) )
		guildPercent = glrCharacter.Event[state].GuildCut
		jackpotGold = tempJackpotGold - ( (tonumber(guildPercent) / 100) * tempJackpotGold )
		jackpotGold = GetMoneyValue(jackpotGold, "Lottery", "Jackpot", round, false)
	end
	local msg = lt[1]
	if msg ~= nil then
		SendChatMessage(L["Send Info GLR"] .. ":" .. msg, "WHISPER", nil, userName)
		table.remove(lt, 1)
	end
	if msg == nil then
		if state == "Lottery" then
			SendChatMessage(L["Send Info Current Jackpot Part 1"] .. " " .. guildPercent .. "%. " .. L["Send Info Current Jackpot Part 2"] .. " " .. jackpotGold, "WHISPER", nil, userName)
		else
			SendChatMessage(L["Send Info Current Prizes"] .. ":", "WHISPER", nil, userName)
			if glrCharacter.Event[state].FirstPlace ~= nil then
				SendChatMessage(L["Send Info GLR"] .. ": " .. glrCharacter.Event[state].FirstPlace, "WHISPER", nil, userName)
			end
			if glrCharacter.Event[state].SecondPlace ~= nil then
				SendChatMessage(L["Send Info GLR"] .. ": " .. glrCharacter.Event[state].SecondPlace, "WHISPER", nil, userName)
			end
			if glrCharacter.Event[state].ThirdPlace ~= nil then
				SendChatMessage(L["Send Info GLR"] .. ": " .. glrCharacter.Event[state].ThirdPlace, "WHISPER", nil, userName)
			end
		end
		SendChatMessage("--------------------------------------------------", "WHISPER", nil, userName)
	end
end

--------------------------------------------- ---------
------- UPDATE PLAYER & TOTAL TICKETS -------
---------------------------------------------
--------- UPDATES DISPLAYED PLAYERS ---------
---------- AND THEIR TOTAL TICKETS ----------
---------------------------------------------

function GLR:UpdatePlayersAndTotalTickets()
	
	local classTable = {}
	local status = glrCharacter.Data.Settings.MultiGuild
	if not status then
		classTable = glrRoster
	else
		classTable = glrMultiGuildRoster
	end
	local playerNamesAndTickets = GLR:GeneratePlayersAndTicketTotalsTable()
	local s = lotteryOrRaffle
	local buffer = 3
	local count = 1
	local count2 = 1
	local scrollHeight = 0
	
	if GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild.PlayersAndTicketsTextFontstrings == nil then
		
		GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild.PlayersAndTicketsTextFontstrings = GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild.PlayersAndTicketsTextFontstrings or {}
		
	elseif GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild.PlayersAndTicketsTextFontstrings ~= nil then
		
		for i = 1, #GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild.PlayersAndTicketsTextFontstrings do
			
			local ClearPlayersText = GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild.PlayersAndTicketsTextFontstrings[count2][1]
			local ClearTicketsText = GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild.PlayersAndTicketsTextFontstrings[count2][2]
			ClearPlayersText:SetText()
			ClearTicketsText:SetText()
			count2 = count2 + 1
			
		end
		
	end
	
	for t, v in pairs(playerNamesAndTickets) do
		
		if not GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild.PlayersAndTicketsTextFontstrings[t] then
			
			GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild.PlayersAndTicketsTextFontstrings[t] = { GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild:CreateFontString("GLR_PlayerNamesText" .. count, "OVERLAY", "GameFontWhiteTiny"), GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild:CreateFontString("GLR_PlayerTicketsText" .. count, "OVERLAY", "GameFontWhiteTiny") }
			
		end
		
		local PlayerNamesText = GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild.PlayersAndTicketsTextFontstrings[count][1]
		local PlayerTicketsText = GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild.PlayersAndTicketsTextFontstrings[count][2]
		local targetName = v
		local bypass = false
		local playerRealm
		if string.find(string.lower(v), "-") ~= nil then
			playerRealm = string.sub(v, string.find(v, "-") + 1)
		else
			bypass = true
		end
		
		if not bypass then
			targetName = string.sub(v, 1, string.find(v, "-") - 1)
		end
		
		PlayerNamesText:SetText(targetName)
		PlayerNamesText:SetFont(GLR_Core.Font, 12)
		PlayerNamesText:SetWordWrap(false)
		
		for i = 1, #classTable do
			
			local isClassFound = false
			local text = classTable[i]
			local subText = string.sub(text, 1, string.find(text, '%[') - 1)
			local CN = string.sub(text, string.find(text, '%[') + 1, string.find(text, '%]') - 1)
			
			if subText == v then
				if ClassColor[CN] ~= nil then
					PlayerNamesText:SetTextColor(ClassColor[CN][1], ClassColor[CN][2], ClassColor[CN][3], 1)
				end
				isClassFound = true
			end
			
			if isClassFound then
				break
			end
		end
		
		if s == "Lottery" then
			PlayerTicketsText:SetText(glrCharacter[s].Entries.Tickets[v].NumberOfTickets)
		else
			PlayerTicketsText:SetText(glrCharacter[s].Entries.Tickets[v].NumberOfTickets)
		end
		PlayerTicketsText:SetFont(GLR_Core.Font, 12)
		PlayerTicketsText:SetWordWrap(false)
		
		local sHeight = ( PlayerNamesText:GetStringHeight() * 1.1 ) + 1.8
		
		if count == 1 then
			
			PlayerNamesText:SetPoint("TOP", GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild, "TOPLEFT", 65, -1)
			PlayerTicketsText:SetPoint("TOP", GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild, "TOPRIGHT", -55, -1)
			scrollHeight = scrollHeight + sHeight + 2
			
		else
			
			PlayerNamesText:SetPoint("TOP", GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild.PlayersAndTicketsTextFontstrings[count - 1][1], "BOTTOM", 0, -buffer)
			PlayerTicketsText:SetPoint("TOP", GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild.PlayersAndTicketsTextFontstrings[count - 1][2], "BOTTOM", 0, -buffer)
			scrollHeight = scrollHeight + sHeight
			
		end
		
		PlayerNamesText:Show()
		PlayerTicketsText:Show()
		
		count = count + 1
		
	end
	
	local scrollMax = ( scrollHeight - 160 )
	
	if scrollMax < 0 then
		
		scrollMax = 0
		
	end
	
	--[[
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu:SetSize(width, 160)
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild:SetSize(width, 160)
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameScrollFrame:SetSize(width, 150)
		
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(0)
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetMinMaxValues(0, scrollMax)
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetScript("OnValueChanged", function(self)
			GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameScrollFrame:SetVerticalScroll(self:GetValue())
		end)
		
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameScrollFrame:EnableMouseWheel(true)
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameScrollFrame:SetScript("OnMouseWheel", function(_, delta)
			
			local current = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:GetValue()
			
			if IsShiftKeyDown() and delta > 0 then
				GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(0)
			elseif IsShiftKeyDown() and delta < 0 then
				GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(scrollMax)
			elseif delta < 0 and current < scrollMax then
				if IsControlKeyDown() then
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(current + 60)
				else
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(current + 20)
				end
			elseif delta > 0 and current > 1 then
				if IsControlKeyDown() then
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(current - 60)
				else
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(current - 20)
				end
			end
			
		end)
	]]
	
	GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameSlider:SetValue(0)
	--GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameSlider:SetValueStep(1)
	--GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameSlider:SetObeyStepOnDrag(true)
	GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameSlider:SetMinMaxValues(0, scrollMax)
	
	--if scrollHeight > 0 then
		GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameChild:SetSize(225, scrollHeight)
		
		GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameSlider:SetScript("OnValueChanged", function(self)
			GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrame:SetVerticalScroll(self:GetValue())
		end)
		
		GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrame:EnableMouseWheel(true)
		GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrame:SetScript("OnMouseWheel", function(_, delta)
			
			local current = GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameSlider:GetValue()
			
			if IsShiftKeyDown() and delta > 0 then
				GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameSlider:SetValue(0)
			elseif IsShiftKeyDown() and delta < 0 then
				GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameSlider:SetValue(scrollMax)
			elseif delta < 0 and current < scrollMax then
				if IsControlKeyDown() then
					GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameSlider:SetValue(current + 60)
				else
					GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameSlider:SetValue(current + 20)
				end
			elseif delta > 0 and current > 1 then
				if IsControlKeyDown() then
					GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameSlider:SetValue(current - 60)
				else
					GLR_UI.GLR_MainFrame.GLR_PlayerNamesScrollFrameSlider:SetValue(current - 20)
				end
			end
			
		end)
		
	--end
	
end

--------------------------------------------- ---------
----------- UPDATE UNUSED TICKETS -----------
---------------------------------------------
-------- UPDATES UNUSED TICKETS FRAME -------
---------------------------------------------

function GLR:UpdateNumberOfUnusedTickets()
	
	local s = glrCharacter.Data.Settings.Status
	local ut = 0
	
	if glrCharacter[s].TicketPool ~= nil then
		for t, v in pairs(glrCharacter[s].TicketPool) do
			ut = ut + 1
		end
	end
	if ut == 0 then
		GLR_UI.GLR_MainFrame.GLR_NumberOfUnusedTicketsRangeBorder:Hide()
	else
		GLR_UI.GLR_MainFrame.GLR_NumberOfUnusedTicketsRangeBorder:Show()
		GLR_UI.GLR_MainFrame.GLR_NumberOfUnusedTicketsRangeBorderAmount:SetText(ut)
	end
	
end

--------------------------------------------- ---------
---------------- GET MONTHS -----------------
---------------------------------------------
------------ RETURNS VALID MONTHS -----------
------------- FOR A NEW LOTTERY -------------
---------------------------------------------

function GLR:GetListOfMonths(arg)
	
	local monthList = {
		L["January"],
		L["February"],
		L["March"],
		L["April"],
		L["May"],
		L["June"],
		L["July"],
		L["August"],
		L["September"],
		L["October"],
		L["November"],
		L["December"]
	}
	local monthValue = {
		[L["January"]] = 1,
		[L["February"]] = 2,
		[L["March"]] = 3,
		[L["April"]] = 4,
		[L["May"]] = 5,
		[L["June"]] = 6,
		[L["July"]] = 7,
		[L["August"]] = 8,
		[L["September"]] = 9,
		[L["October"]] = 10,
		[L["November"]] = 11,
		[L["December"]] = 12
	}
	local currentMonth = tonumber(date("%m"))
	local buffer = 3
	local sbuffer = 3.2
	local nameHeight = 0
	local count = 1
	local currentYear = L["20"] .. date("%y")
	local selectedYear
	
	if arg == "Lottery" then
		selectedYear = GLR_Lottery_ListOfYearsSelectionText:GetText()
	else
		selectedYear = GLR_Raffle_ListOfYearsSelectionText:GetText()
	end
	
	if currentYear ~= selectedYear then
		
		currentMonth = 1
		
	end
	
	GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons or {}
	GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons or {}
	
	if arg == "Lottery" then
		for i = 1, #GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons do
			GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons[i][1]:Hide()
		end
	else
		for i = 1, #GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons do
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons[i][1]:Hide()
		end
	end
	
	for t, v in pairs(monthList) do
		
		if arg == "Lottery" then
			if not GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons[t] then
				local tempButton = CreateFrame("Button", "month" .. count, GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionMenu)
				GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("monthText" .. count, "OVERLAY", "GameFontWhiteTiny") }
			end
		else
			if not GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons[t] then
				local tempButton = CreateFrame("Button", "month" .. count, GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionMenu)
				GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("monthText" .. count, "OVERLAY", "GameFontWhiteTiny") }
			end
		end
		
		local MonthButtons
		local MonthButtonsText
		
		if arg == "Lottery" then
			MonthButtons = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons[count][1]
			MonthButtonsText = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons[count][2]
		else
			MonthButtons = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons[count][1]
			MonthButtonsText = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons[count][2]
		end
		
		for x, y in pairs(monthValue) do
			
			if v == x and y >= currentMonth then
				
				MonthButtons:SetWidth(120)
				MonthButtons:SetHeight(11)
				MonthButtons:SetHighlightTexture("Interface\\Buttons\\UI-Silver-Button-Select")
				MonthButtonsText:SetText(v)
				MonthButtonsText:SetWidth(120)
				MonthButtonsText:SetWordWrap(false)
				MonthButtonsText:SetPoint("CENTER", MonthButtons)
				MonthButtonsText:SetFont(GLR_Core.ButtonFont, 12)
				
				local sHeight = ( MonthButtons:GetHeight() * 1.1 ) + 2.2
				
				if count == 1 then
					
					if arg == "Lottery" then
						MonthButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionMenu, 0, -4)
					else
						MonthButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionMenu, 0, -4)
					end
					
					nameHeight = nameHeight + sHeight + 3
					
				else
					
					if arg == "Lottery" then
						MonthButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
					else
						MonthButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
					end
					
					nameHeight = nameHeight + sHeight
					
				end
				
				MonthButtons:SetScript("OnClick", function(self, button)
					
					if button == "LeftButton" then
						
						local formerText
						
						if arg == "Lottery" then
							formerText = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionText:GetText()
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionText:SetText(MonthButtonsText:GetText())
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionText:SetFont(GLR_Core.ButtonFont, 12)
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionMenu:Hide()
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelection:Show()
						else
							formerText = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionText:GetText()
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionText:SetText(MonthButtonsText:GetText())
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionText:SetFont(GLR_Core.ButtonFont, 12)
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionMenu:Hide()
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelection:Show()
						end
						
					end
					
				end)
				
				MonthButtons:Show()
				
				count = count + 1
				
			end
			
		end
		
	end
	
	if arg == "Lottery" then
		GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionMenu:SetSize(120, nameHeight)
	else
		GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionMenu:SetSize(120, nameHeight)
	end
	
end

--------------------------------------------- ---------
----------------- GET DAYS ------------------
---------------------------------------------
------------- RETURNS VALID DAYS ------------
------------- FOR A NEW LOTTERY -------------
---------------------------------------------

function GLR:GetListOfDays(arg)
	
	local dayList = {
		[L["January"]] = {
			L["01"], -- [1]
			L["02"], -- [2]
			L["03"], -- [3]
			L["04"], -- [4]
			L["05"], -- [5]
			L["06"], -- [6]
			L["07"], -- [7]
			L["08"], -- [8]
			L["09"], -- [9]
			L["10"], -- [10]
			L["11"], -- [11]
			L["12"], -- [12]
			L["13"], -- [13]
			L["14"], -- [14]
			L["15"], -- [15]
			L["16"], -- [16]
			L["17"], -- [17]
			L["18"], -- [18]
			L["19"], -- [19]
			L["20"], -- [20]
			L["21"], -- [21]
			L["22"], -- [22]
			L["23"], -- [23]
			L["24"], -- [24]
			L["25"], -- [25]
			L["26"], -- [26]
			L["27"], -- [27]
			L["28"], -- [28]
			L["29"], -- [29]
			L["30"], -- [30]
			L["31"], -- [31]
		},
		[L["February"]] = {
			L["01"], -- [1]
			L["02"], -- [2]
			L["03"], -- [3]
			L["04"], -- [4]
			L["05"], -- [5]
			L["06"], -- [6]
			L["07"], -- [7]
			L["08"], -- [8]
			L["09"], -- [9]
			L["10"], -- [10]
			L["11"], -- [11]
			L["12"], -- [12]
			L["13"], -- [13]
			L["14"], -- [14]
			L["15"], -- [15]
			L["16"], -- [16]
			L["17"], -- [17]
			L["18"], -- [18]
			L["19"], -- [19]
			L["20"], -- [20]
			L["21"], -- [21]
			L["22"], -- [22]
			L["23"], -- [23]
			L["24"], -- [24]
			L["25"], -- [25]
			L["26"], -- [26]
			L["27"], -- [27]
			L["28"], -- [28]
		},
		[L["March"]] = {
			L["01"], -- [1]
			L["02"], -- [2]
			L["03"], -- [3]
			L["04"], -- [4]
			L["05"], -- [5]
			L["06"], -- [6]
			L["07"], -- [7]
			L["08"], -- [8]
			L["09"], -- [9]
			L["10"], -- [10]
			L["11"], -- [11]
			L["12"], -- [12]
			L["13"], -- [13]
			L["14"], -- [14]
			L["15"], -- [15]
			L["16"], -- [16]
			L["17"], -- [17]
			L["18"], -- [18]
			L["19"], -- [19]
			L["20"], -- [20]
			L["21"], -- [21]
			L["22"], -- [22]
			L["23"], -- [23]
			L["24"], -- [24]
			L["25"], -- [25]
			L["26"], -- [26]
			L["27"], -- [27]
			L["28"], -- [28]
			L["29"], -- [29]
			L["30"], -- [30]
			L["31"], -- [31]
		},
		[L["April"]] = {
			L["01"], -- [1]
			L["02"], -- [2]
			L["03"], -- [3]
			L["04"], -- [4]
			L["05"], -- [5]
			L["06"], -- [6]
			L["07"], -- [7]
			L["08"], -- [8]
			L["09"], -- [9]
			L["10"], -- [10]
			L["11"], -- [11]
			L["12"], -- [12]
			L["13"], -- [13]
			L["14"], -- [14]
			L["15"], -- [15]
			L["16"], -- [16]
			L["17"], -- [17]
			L["18"], -- [18]
			L["19"], -- [19]
			L["20"], -- [20]
			L["21"], -- [21]
			L["22"], -- [22]
			L["23"], -- [23]
			L["24"], -- [24]
			L["25"], -- [25]
			L["26"], -- [26]
			L["27"], -- [27]
			L["28"], -- [28]
			L["29"], -- [29]
			L["30"], -- [30]
		},
		[L["May"]] = {
			L["01"], -- [1]
			L["02"], -- [2]
			L["03"], -- [3]
			L["04"], -- [4]
			L["05"], -- [5]
			L["06"], -- [6]
			L["07"], -- [7]
			L["08"], -- [8]
			L["09"], -- [9]
			L["10"], -- [10]
			L["11"], -- [11]
			L["12"], -- [12]
			L["13"], -- [13]
			L["14"], -- [14]
			L["15"], -- [15]
			L["16"], -- [16]
			L["17"], -- [17]
			L["18"], -- [18]
			L["19"], -- [19]
			L["20"], -- [20]
			L["21"], -- [21]
			L["22"], -- [22]
			L["23"], -- [23]
			L["24"], -- [24]
			L["25"], -- [25]
			L["26"], -- [26]
			L["27"], -- [27]
			L["28"], -- [28]
			L["29"], -- [29]
			L["30"], -- [30]
			L["31"], -- [31]
		},
		[L["June"]] = {
			L["01"], -- [1]
			L["02"], -- [2]
			L["03"], -- [3]
			L["04"], -- [4]
			L["05"], -- [5]
			L["06"], -- [6]
			L["07"], -- [7]
			L["08"], -- [8]
			L["09"], -- [9]
			L["10"], -- [10]
			L["11"], -- [11]
			L["12"], -- [12]
			L["13"], -- [13]
			L["14"], -- [14]
			L["15"], -- [15]
			L["16"], -- [16]
			L["17"], -- [17]
			L["18"], -- [18]
			L["19"], -- [19]
			L["20"], -- [20]
			L["21"], -- [21]
			L["22"], -- [22]
			L["23"], -- [23]
			L["24"], -- [24]
			L["25"], -- [25]
			L["26"], -- [26]
			L["27"], -- [27]
			L["28"], -- [28]
			L["29"], -- [29]
			L["30"], -- [30]
		},
		[L["July"]] = {
			L["01"], -- [1]
			L["02"], -- [2]
			L["03"], -- [3]
			L["04"], -- [4]
			L["05"], -- [5]
			L["06"], -- [6]
			L["07"], -- [7]
			L["08"], -- [8]
			L["09"], -- [9]
			L["10"], -- [10]
			L["11"], -- [11]
			L["12"], -- [12]
			L["13"], -- [13]
			L["14"], -- [14]
			L["15"], -- [15]
			L["16"], -- [16]
			L["17"], -- [17]
			L["18"], -- [18]
			L["19"], -- [19]
			L["20"], -- [20]
			L["21"], -- [21]
			L["22"], -- [22]
			L["23"], -- [23]
			L["24"], -- [24]
			L["25"], -- [25]
			L["26"], -- [26]
			L["27"], -- [27]
			L["28"], -- [28]
			L["29"], -- [29]
			L["30"], -- [30]
			L["31"], -- [31]
		},
		[L["August"]] = {
			L["01"], -- [1]
			L["02"], -- [2]
			L["03"], -- [3]
			L["04"], -- [4]
			L["05"], -- [5]
			L["06"], -- [6]
			L["07"], -- [7]
			L["08"], -- [8]
			L["09"], -- [9]
			L["10"], -- [10]
			L["11"], -- [11]
			L["12"], -- [12]
			L["13"], -- [13]
			L["14"], -- [14]
			L["15"], -- [15]
			L["16"], -- [16]
			L["17"], -- [17]
			L["18"], -- [18]
			L["19"], -- [19]
			L["20"], -- [20]
			L["21"], -- [21]
			L["22"], -- [22]
			L["23"], -- [23]
			L["24"], -- [24]
			L["25"], -- [25]
			L["26"], -- [26]
			L["27"], -- [27]
			L["28"], -- [28]
			L["29"], -- [29]
			L["30"], -- [30]
			L["31"], -- [31]
		},
		[L["September"]] = {
			L["01"], -- [1]
			L["02"], -- [2]
			L["03"], -- [3]
			L["04"], -- [4]
			L["05"], -- [5]
			L["06"], -- [6]
			L["07"], -- [7]
			L["08"], -- [8]
			L["09"], -- [9]
			L["10"], -- [10]
			L["11"], -- [11]
			L["12"], -- [12]
			L["13"], -- [13]
			L["14"], -- [14]
			L["15"], -- [15]
			L["16"], -- [16]
			L["17"], -- [17]
			L["18"], -- [18]
			L["19"], -- [19]
			L["20"], -- [20]
			L["21"], -- [21]
			L["22"], -- [22]
			L["23"], -- [23]
			L["24"], -- [24]
			L["25"], -- [25]
			L["26"], -- [26]
			L["27"], -- [27]
			L["28"], -- [28]
			L["29"], -- [29]
			L["30"], -- [30]
		},
		[L["October"]] = {
			L["01"], -- [1]
			L["02"], -- [2]
			L["03"], -- [3]
			L["04"], -- [4]
			L["05"], -- [5]
			L["06"], -- [6]
			L["07"], -- [7]
			L["08"], -- [8]
			L["09"], -- [9]
			L["10"], -- [10]
			L["11"], -- [11]
			L["12"], -- [12]
			L["13"], -- [13]
			L["14"], -- [14]
			L["15"], -- [15]
			L["16"], -- [16]
			L["17"], -- [17]
			L["18"], -- [18]
			L["19"], -- [19]
			L["20"], -- [20]
			L["21"], -- [21]
			L["22"], -- [22]
			L["23"], -- [23]
			L["24"], -- [24]
			L["25"], -- [25]
			L["26"], -- [26]
			L["27"], -- [27]
			L["28"], -- [28]
			L["29"], -- [29]
			L["30"], -- [30]
			L["31"], -- [31]
		},
		[L["November"]] = {
			L["01"], -- [1]
			L["02"], -- [2]
			L["03"], -- [3]
			L["04"], -- [4]
			L["05"], -- [5]
			L["06"], -- [6]
			L["07"], -- [7]
			L["08"], -- [8]
			L["09"], -- [9]
			L["10"], -- [10]
			L["11"], -- [11]
			L["12"], -- [12]
			L["13"], -- [13]
			L["14"], -- [14]
			L["15"], -- [15]
			L["16"], -- [16]
			L["17"], -- [17]
			L["18"], -- [18]
			L["19"], -- [19]
			L["20"], -- [20]
			L["21"], -- [21]
			L["22"], -- [22]
			L["23"], -- [23]
			L["24"], -- [24]
			L["25"], -- [25]
			L["26"], -- [26]
			L["27"], -- [27]
			L["28"], -- [28]
			L["29"], -- [29]
			L["30"], -- [30]
		},
		[L["December"]] = {
			L["01"], -- [1]
			L["02"], -- [2]
			L["03"], -- [3]
			L["04"], -- [4]
			L["05"], -- [5]
			L["06"], -- [6]
			L["07"], -- [7]
			L["08"], -- [8]
			L["09"], -- [9]
			L["10"], -- [10]
			L["11"], -- [11]
			L["12"], -- [12]
			L["13"], -- [13]
			L["14"], -- [14]
			L["15"], -- [15]
			L["16"], -- [16]
			L["17"], -- [17]
			L["18"], -- [18]
			L["19"], -- [19]
			L["20"], -- [20]
			L["21"], -- [21]
			L["22"], -- [22]
			L["23"], -- [23]
			L["24"], -- [24]
			L["25"], -- [25]
			L["26"], -- [26]
			L["27"], -- [27]
			L["28"], -- [28]
			L["29"], -- [29]
			L["30"], -- [30]
			L["31"], -- [31]
		},
	}
	local numberOfMonth = {
		[1] = L["January"],
		[2] = L["February"],
		[3] = L["March"],
		[4] = L["April"],
		[5] = L["May"],
		[6] = L["June"],
		[7] = L["July"],
		[8] = L["August"],
		[9] = L["September"],
		[10] = L["October"],
		[11] = L["November"],
		[12] = L["December"]
	}
	local buffer = 3
	local sbuffer = 3.2
	local nameHeight = 0
	local currentMonth = tonumber(date("%m"))
	local currentDay = tonumber(date("%d"))
	local currentYear = L["20"] .. date("%y")
	local count = 1
	local useMonth = numberOfMonth[currentMonth]
	local useCurrentDay = true
	local selectedMonth
	local selectedYear
	
	if arg == "Lottery" then
		selectedMonth = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionText:GetText()
		selectedYear = GLR_Lottery_ListOfYearsSelectionText:GetText()
	else
		selectedMonth = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionText:GetText()
		selectedYear = GLR_Raffle_ListOfYearsSelectionText:GetText()
	end
	
	if selectedMonth ~= useMonth or selectedYear ~= currentYear then
		
		useMonth = selectedMonth
		useCurrentDay = false
		
	end
	
	GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionMenu.Buttons = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionMenu.Buttons or {}
	GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionMenu.Buttons = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionMenu.Buttons or {}
	
	if arg == "Lottery" then
		for i = 1, #GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionMenu.Buttons do
			GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionMenu.Buttons[i][1]:Hide()
		end
	else
		for i = 1, #GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionMenu.Buttons do
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionMenu.Buttons[i][1]:Hide()
		end
	end
	
	for t, v in pairs(dayList[useMonth]) do
		
		if arg == "Lottery" then
			if not GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionMenu.Buttons[t] then
				local tempButton = CreateFrame("Button", "day" .. count, GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionMenu)
				GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("dayText" .. count, "OVERLAY", "GameFontWhiteTiny") }
			end
		else
			if not GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionMenu.Buttons[t] then
				local tempButton = CreateFrame("Button", "day" .. count, GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionMenu)
				GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("dayText" .. count, "OVERLAY", "GameFontWhiteTiny") }
			end
		end
		
		local n = tonumber(v)		
		local DayButtons
		local DayButtonsText
		
		if arg == "Lottery" then
			DayButtons = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionMenu.Buttons[count][1]
			DayButtonsText = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionMenu.Buttons[count][2]
		else
			DayButtons = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionMenu.Buttons[count][1]
			DayButtonsText = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionMenu.Buttons[count][2]
		end
		
		if n >= currentDay or not useCurrentDay then
			
			DayButtons:SetWidth(70)
			DayButtons:SetHeight(11)
			DayButtons:SetHighlightTexture("Interface\\Buttons\\UI-Silver-Button-Select")
			DayButtonsText:SetText(v)
			DayButtonsText:SetWidth(70)
			DayButtonsText:SetWordWrap(false)
			DayButtonsText:SetPoint("CENTER", DayButtons)
			DayButtonsText:SetFont(GLR_Core.ButtonFont, 12)
			
			local sHeight = ( DayButtons:GetHeight() * 1.1 ) + 2.2
			
			if count == 1 then
				
				if arg == "Lottery" then
					DayButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionMenu, 0, -4)
				else
					DayButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionMenu, 0, -4)
				end
				
				nameHeight = nameHeight + sHeight + 3
				
			else
				
				if arg == "Lottery" then
					DayButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
				else
					DayButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
				end
				
				nameHeight = nameHeight + sHeight
				
			end
			
			DayButtons:SetScript("OnClick", function(self, button)
				
				if button == "LeftButton" then
					
					local formerText
					if arg == "Lottery" then
						formerText = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionText:GetText()
						GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionText:SetText(DayButtonsText:GetText())
						GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionText:SetFont(GLR_Core.ButtonFont, 12)
						GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionMenu:Hide()
						GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelection:Show()
					else
						formerText = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionText:GetText()
						GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionText:SetText(DayButtonsText:GetText())
						GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionText:SetFont(GLR_Core.ButtonFont, 12)
						GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionMenu:Hide()
						GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelection:Show()
					end
					
				end
				
			end)
			
			DayButtons:Show()
			
			count = count + 1
			
		end
		
	end
	
	if arg == "Lottery" then
		GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionMenu:SetSize(70, nameHeight)
	else
		GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionMenu:SetSize(70, nameHeight)
	end
	
end

--------------------------------------------- ---------
----------------- GET YEARS -----------------
---------------------------------------------
------------ RETURNS VALID YEARS ------------
------------- FOR A NEW LOTTERY -------------
---------------------------------------------

function GLR:GetListOfYears(arg)
	
	local yearList = {
		L["2018"], -- [1]
		L["2019"], -- [2]
	}
	local buffer = 3
	local sbuffer = 3.2
	local nameHeight = 0
	local count = 1
	
	GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionMenu.Buttons = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionMenu.Buttons or {}
	GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionMenu.Buttons = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionMenu.Buttons or {}
	
	if arg == "Lottery" then
		for i = 1, #GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionMenu.Buttons do
			GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionMenu.Buttons[i][1]:Hide()
		end
	else
		for i = 1, #GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionMenu.Buttons do
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionMenu.Buttons[i][1]:Hide()
		end
	end
	
	for t, v in pairs(yearList) do
		
		if arg == "Lottery" then
			if not GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionMenu.Buttons[t] then
				local tempButton = CreateFrame("Button", "year" .. count, GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionMenu)
				GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("yearText" .. count, "OVERLAY", "GameFontWhiteTiny") }
			end
		else
			if not GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionMenu.Buttons[t] then
				local tempButton = CreateFrame("Button", "year" .. count, GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionMenu)
				GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("yearText" .. count, "OVERLAY", "GameFontWhiteTiny") }
			end
		end
		
		local YearButtons
		local YearButtonsText
		
		if arg == "Lottery" then
			YearButtons = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionMenu.Buttons[count][1]
			YearButtonsText = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionMenu.Buttons[count][2]
		else
			YearButtons = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionMenu.Buttons[count][1]
			YearButtonsText = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionMenu.Buttons[count][2]
		end
		
		YearButtons:SetWidth(100)
		YearButtons:SetHeight(11)
		YearButtons:SetHighlightTexture("Interface\\Buttons\\UI-Silver-Button-Select")
		YearButtonsText:SetText(v)
		YearButtonsText:SetWidth(100)
		YearButtonsText:SetWordWrap(false)
		YearButtonsText:SetPoint("CENTER", YearButtons)
		YearButtonsText:SetFont(GLR_Core.ButtonFont, 12)
		
		local sHeight = ( YearButtons:GetHeight() * 1.1 ) + 2.2
		
		if count == 1 then
			
			if arg == "Lottery" then
				YearButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionMenu, 0, -4)
			else
				YearButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionMenu, 0, -4)
			end
			
			nameHeight = nameHeight + sHeight + 3
			
		else
			
			if arg == "Lottery" then
				YearButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
			else
				YearButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
			end
			
			nameHeight = nameHeight + sHeight
			
		end
		
		YearButtons:SetScript("OnClick", function(self, button)
			
			if button == "LeftButton" then
				
				local formerText
				if arg == "Lottery" then
					formerText = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionText:GetText()
					GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionText:SetText(YearButtonsText:GetText())
					GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionText:SetFont(GLR_Core.ButtonFont, 12)
					GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionMenu:Hide()
					GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelection:Show()
				else
					formerText = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionText:GetText()
					GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionText:SetText(YearButtonsText:GetText())
					GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionText:SetFont(GLR_Core.ButtonFont, 12)
					GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionMenu:Hide()
					GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelection:Show()
				end
				
			end
			
		end)
		
		YearButtons:Show()
		
		count = count + 1
		
	end
	
	if arg == "Lottery" then
		GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionMenu:SetSize(100, nameHeight)
	else
		GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionMenu:SetSize(100, nameHeight)
	end
	
end

--------------------------------------------- ---------
---------------- GET HOURS -----------------
---------------------------------------------
------------ RETURNS VALID HOURS ------------
------------- FOR A NEW LOTTERY -------------
---------------------------------------------

function GLR:GetListOfHours(arg)
	
	local hourList = {
		L["00"], -- [1]
		L["01"], -- [2]
		L["02"], -- [3]
		L["04"], -- [4]
		L["05"], -- [5]
		L["06"], -- [6]
		L["07"], -- [7]
		L["08"], -- [8]
		L["09"], -- [9]
		L["10"], -- [10]
		L["11"], -- [11]
		L["12"], -- [12]
		L["13"], -- [13]
		L["14"], -- [14]
		L["15"], -- [15]
		L["16"], -- [16]
		L["17"], -- [17]
		L["18"], -- [18]
		L["19"], -- [19]
		L["20"], -- [20]
		L["21"], -- [21]
		L["22"], -- [22]
		L["23"], -- [23]
	}
	local currentHour = tonumber(date("%H"))
	local currentMinute = tonumber(date("%M"))
	local currentDate = date("%m/%d/%y")
	local selectedMonth = GLR:MonthToString(arg)
	local selectedDay
	local selectedYear = GLR:YearToString(arg)
	local useCurrentHour = true
	local buffer = 3
	local sbuffer = 3.2
	local nameHeight = 0
	local count = 1
	
	if arg == "Lottery" then
		selectedDay = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionText:GetText()
	else
		selectedDay = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionText:GetText()
	end
	
	local selectedDate = selectedMonth .. "/" .. selectedDay .. "/" .. selectedYear
	
	if currentDate ~= selectedDate then
		
		useCurrentHour = false
		
	end
	
	if currentMinute >= 45 then
		
		currentHour = currentHour + 1
		
	end
	
	GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionMenu.Buttons = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionMenu.Buttons or {}
	GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionMenu.Buttons = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionMenu.Buttons or {}
	
	if arg == "Lottery" then
		for i = 1, #GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionMenu.Buttons do
			GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionMenu.Buttons[i][1]:Hide()
		end
	else
		for i = 1, #GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionMenu.Buttons do
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionMenu.Buttons[i][1]:Hide()
		end
	end
	
	for t, v in pairs(hourList) do
		
		if arg == "Lottery" then
			if not GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionMenu.Buttons[t] then
				local tempButton = CreateFrame("Button", "hour" .. count, GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionMenu)
				GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("hourText" .. count, "OVERLAY", "GameFontWhiteTiny") }
			end
		else
			if not GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionMenu.Buttons[t] then
				local tempButton = CreateFrame("Button", "hour" .. count, GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionMenu)
				GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("hourText" .. count, "OVERLAY", "GameFontWhiteTiny") }
			end
		end
		
		local hour = tonumber(v)
		local HourButtons
		local HourButtonsText
		
		if arg == "Lottery" then
			HourButtons = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionMenu.Buttons[count][1]
			HourButtonsText = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionMenu.Buttons[count][2]
		else
			HourButtons = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionMenu.Buttons[count][1]
			HourButtonsText = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionMenu.Buttons[count][2]
		end
		
		if hour >= currentHour or not useCurrentHour then
			
			HourButtons:SetWidth(70)
			HourButtons:SetHeight(11)
			HourButtons:SetHighlightTexture("Interface\\Buttons\\UI-Silver-Button-Select")
			HourButtonsText:SetText(v)
			HourButtonsText:SetWidth(70)
			HourButtonsText:SetWordWrap(false)
			HourButtonsText:SetPoint("CENTER", HourButtons)
			HourButtonsText:SetFont(GLR_Core.ButtonFont, 12)
			
			local sHeight = ( HourButtons:GetHeight() * 1.1 ) + 2.2
			
			if count == 1 then
				
				if arg == "Lottery" then
					HourButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionMenu, 0, -4)
				else
					HourButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionMenu, 0, -4)
				end
				
				nameHeight = nameHeight + sHeight + 3
				
			else
				
				if arg == "Lottery" then
					HourButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
				else
					HourButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
				end
				
				nameHeight = nameHeight + sHeight
				
			end
			
			HourButtons:SetScript("OnClick", function(self, button)
				
				if button == "LeftButton" then
					
					local formerText
					if arg == "Lottery" then
						formerText = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionText:GetText()
						GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionText:SetText(HourButtonsText:GetText())
						GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionText:SetFont(GLR_Core.ButtonFont, 12)
						GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionMenu:Hide()
						GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelection:Show()
					else
						formerText = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionText:GetText()
						GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionText:SetText(HourButtonsText:GetText())
						GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionText:SetFont(GLR_Core.ButtonFont, 12)
						GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionMenu:Hide()
						GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelection:Show()
					end
					
				end
				
			end)
			
			HourButtons:Show()
			
			count = count + 1
			
		end
		
	end
	
	if arg == "Lottery" then
		GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionMenu:SetSize(75, nameHeight)
	else
		GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionMenu:SetSize(75, nameHeight)
	end
	
end

--------------------------------------------- ---------
---------------- GET MINUTES ----------------
---------------------------------------------
----------- RETURNS VALID MINUTES -----------
------------- FOR A NEW LOTTERY -------------
---------------------------------------------

function GLR:GetListOfMinutes(arg)
	
	local minuteList = {
		L["00"], -- [1]
		L["15"], -- [2]
		L["30"], -- [3]
		L["45"], -- [4]
	}
	local currentMinute = tonumber(date("%M"))
	local currentHour = date("%H")
	local currentDate = date("%m/%d/%y")
	local selectedMonth = GLR:MonthToString(arg)
	local selectedYear = GLR:YearToString(arg)
	local selectedDay
	local selectedHour
	local useCurrentMinute = true
	local buffer = 3
	local nameHeight = 0
	local count = 1
	
	if arg == "Lottery" then
		selectedDay = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfDaysSelectionText:GetText()
		selectedHour = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfHoursSelectionText:GetText()
	else
		selectedDay = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfDaysSelectionText:GetText()
		selectedHour = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfHoursSelectionText:GetText()
	end
	
	local selectedDate = selectedMonth .. "/" .. selectedDay .. "/" .. selectedYear
	
	if selectedDate ~= currentDate or selectedHour ~= currentHour then
		
		useCurrentMinute = false
		
	end
	
	GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons or {}
	GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons or {}
	
	if arg == "Lottery" then
		for i = 1, #GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons do
			GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[i][1]:Hide()
		end
	else
		for i = 1, #GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons do
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[i][1]:Hide()
		end
	end
	
	for t, v in pairs(minuteList) do
		
		if arg == "Lottery" then
			if not GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[t] then
				local tempButton = CreateFrame("Button", "minute" .. count, GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu)
				GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("minuteText" .. count, "OVERLAY", "GameFontWhiteTiny") }
			end
		else
			if not GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[t] then
				local tempButton = CreateFrame("Button", "minute" .. count, GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu)
				GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("minuteText" .. count, "OVERLAY", "GameFontWhiteTiny") }
			end
		end
		
		local MinuteButtons
		local MinuteButtonsText
		local minute = tonumber(v)
		
		if arg == "Lottery" then
			MinuteButtons = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[count][1]
			MinuteButtonsText = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[count][2]
		else
			MinuteButtons = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[count][1]
			MinuteButtonsText = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[count][2]
		end
		
		if minute < 15 then
			minute = 0
		end
		
		if minute >= currentMinute or not useCurrentMinute then
			
			if currentMinute >= 45 or not useCurrentMinute then
				
				if minute == 0 then
					v = L["00"]
				end
				
				MinuteButtons:SetWidth(70)
				MinuteButtons:SetHeight(11)
				MinuteButtons:SetHighlightTexture("Interface\\Buttons\\UI-Silver-Button-Select")
				MinuteButtonsText:SetText(v)
				MinuteButtonsText:SetWidth(70)
				MinuteButtonsText:SetWordWrap(false)
				MinuteButtonsText:SetPoint("CENTER", MinuteButtons)
				MinuteButtonsText:SetFont(GLR_Core.ButtonFont, 12)
				
				local sHeight = ( MinuteButtons:GetHeight() * 1.1 ) + 2.2
				
				if count == 1 then
					
					if arg == "Lottery" then
						MinuteButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu, 0, -4)
					else
						MinuteButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu, 0, -4)
					end
					
					nameHeight = nameHeight + sHeight + 3
					
				else
					
					if arg == "Lottery" then
						MinuteButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
					else
						MinuteButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
					end
					
					nameHeight = nameHeight + sHeight
					
				end
				
				MinuteButtons:SetScript("OnClick", function(self, button)
					
					if button == "LeftButton" then
						
						local formerText
						if arg == "Lottery" then
							formerText = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionText:GetText()
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionText:SetText(MinuteButtonsText:GetText())
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionText:SetFont(GLR_Core.ButtonFont, 12)
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu:Hide()
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelection:Show()
						else
							formerText = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionText:GetText()
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionText:SetText(MinuteButtonsText:GetText())
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionText:SetFont(GLR_Core.ButtonFont, 12)
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu:Hide()
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelection:Show()
						end
						
					end
					
				end)
				
				MinuteButtons:Show()
				
				count = count + 1
				
			elseif minute >= currentMinute and useCurrentMinute then
				
				MinuteButtons:SetWidth(70)
				MinuteButtons:SetHeight(11)
				MinuteButtons:SetHighlightTexture("Interface\\Buttons\\UI-Silver-Button-Select")
				MinuteButtonsText:SetText(v)
				MinuteButtonsText:SetWidth(70)
				MinuteButtonsText:SetWordWrap(false)
				MinuteButtonsText:SetPoint("CENTER", MinuteButtons)
				MinuteButtonsText:SetFont(GLR_Core.ButtonFont, 12)
				
				local sHeight = ( MinuteButtons:GetHeight() * 1.1 ) + 2.2
				
				if count == 1 then
					
					if arg == "Lottery" then
						MinuteButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu, 0, -4)
					else
						MinuteButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu, 0, -4)
					end
					
					nameHeight = nameHeight + sHeight + 3
					
				else
					
					if arg == "Lottery" then
						MinuteButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
					else
						MinuteButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
					end
					
					nameHeight = nameHeight + sHeight
					
				end
				
				MinuteButtons:SetScript("OnClick", function(self, button)
					
					if button == "LeftButton" then
						
						local formerText
						if arg == "Lottery" then
							formerText = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionText:GetText()
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionText:SetText(MinuteButtonsText:GetText())
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionText:SetFont(GLR_Core.ButtonFont, 12)
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu:Hide()
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelection:Show()
						else
							formerText = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionText:GetText()
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionText:SetText(MinuteButtonsText:GetText())
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionText:SetFont(GLR_Core.ButtonFont, 12)
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu:Hide()
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelection:Show()
						end
						
					end
					
				end)
				
				MinuteButtons:Show()
				
				count = count + 1
				
			elseif currentMinute >= 45 and useCurrentMinute then
				
				if selectedHour == currentHour then
					break
				end
				
				MinuteButtons:SetWidth(70)
				MinuteButtons:SetHeight(11)
				MinuteButtons:SetHighlightTexture("Interface\\Buttons\\UI-Silver-Button-Select")
				MinuteButtonsText:SetText("45")
				MinuteButtonsText:SetWidth(70)
				MinuteButtonsText:SetWordWrap(false)
				MinuteButtonsText:SetPoint("CENTER", MinuteButtons)
				MinuteButtonsText:SetFont(GLR_Core.ButtonFont, 12)
				
				local sHeight = ( MinuteButtons:GetHeight() * 1.1 ) + 2.2
				
				if count == 1 then
					
					if arg == "Lottery" then
						MinuteButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu, 0, -4)
					else
						MinuteButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu, 0, -4)
					end
					
					nameHeight = nameHeight + sHeight + 3
					
				else
					
					if arg == "Lottery" then
						MinuteButtons:SetPoint("TOP", GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
					else
						MinuteButtons:SetPoint("TOP", GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
					end
					
					nameHeight = nameHeight + sHeight
					
				end
				
				MinuteButtons:SetScript("OnClick", function(self, button)
					
					if button == "LeftButton" then
						
						local formerText
						if arg == "Lottery" then
							formerText = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionText:GetText()
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionText:SetText(MinuteButtonsText:GetText())
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionText:SetFont(GLR_Core.ButtonFont, 12)
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu:Hide()
							GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelection:Show()
						else
							formerText = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionText:GetText()
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionText:SetText(MinuteButtonsText:GetText())
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionText:SetFont(GLR_Core.ButtonFont, 12)
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu:Hide()
							GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelection:Show()
						end
						
					end
					
				end)
				
				MinuteButtons:Show()
				
				count = count + 1
				
			end
			
		end
		
	end
	
	if arg == "Lottery" then
		GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMinutesSelectionMenu:SetSize(75, nameHeight)
	else
		GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMinutesSelectionMenu:SetSize(75, nameHeight)
	end
	
end


function GLR:GetListOfPlayersToEdit(EventType)
	
	local status = glrCharacter.Data.Settings.MultiGuild
	if not status then --Determines whether to search just your guild (if not a Multi-Guild Event) for player names to Edit, or the Multi-Guild Roster (if Multi-Guild Event).
		GLR_U:UpdateRosterTable()
	else
		GLR_U:PopulateMultiGuildTable()
	end
	local nameList = GLR:GetListOfEntries()
	local state = EventType
	local buffer = 3
	local sbuffer = 3.2
	local nameHeight = 0
	local count = 1
	local width = 240
	local height = 160
	local scrollHeight = 0
	local classTable = {}
	
	if not status then
		classTable = glrRoster
	else
		classTable = glrMultiGuildRoster
	end
	
	if GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild.Buttons == nil then
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild.Buttons = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild.Buttons or {}
	end
	if GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameChild.Buttons == nil then
		GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameChild.Buttons = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameChild.Buttons or {}
	end
	
	if state == "Lottery" then
		for i = 1, #GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild.Buttons do
			GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild.Buttons[i][1]:Hide()
		end
	else
		for i = 1, #GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameChild.Buttons do
			GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameChild.Buttons[i][1]:Hide()
		end
	end
	
	for t, v in pairs(nameList) do
		
		if state == "Lottery" then
			if not GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild.Buttons[t] then
				local tempButton = CreateFrame("Button", "name" .. count, GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild)
				GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild.Buttons[t] = { tempButton, tempButton:CreateFontString("nameText" .. count, "OVERLAY", "GameFontWhiteTiny") }
			end
		else
			if not GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameChild.Buttons[t] then
				local tempButton = CreateFrame("Button", "name" .. count, GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameChild)
				GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameChild.Buttons[t] = { tempButton, tempButton:CreateFontString("nameText" .. count, "OVERLAY", "GameFontWhiteTiny") }
			end
		end
		
		local NameButtons
		local NameButtonsText
		
		if state == "Lottery" then
			NameButtons = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild.Buttons[count][1]
			NameButtonsText = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild.Buttons[count][2]
		else
			NameButtons = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameChild.Buttons[count][1]
			NameButtonsText = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameChild.Buttons[count][2]
		end
		
		NameButtons:SetHeight(11)
		NameButtons:SetWidth(125)
		NameButtons:SetHighlightTexture("Interface\\Buttons\\UI-Silver-Button-Select")
		NameButtonsText:SetText(v)
		NameButtonsText:SetWordWrap(false)
		NameButtonsText:SetPoint("CENTER", NameButtons)
		NameButtonsText:SetFont(GLR_Core.ButtonFont, 12)
		
		local isClassFound = false
		local sWidth = NameButtonsText:GetWidth()
		local sHeight = ( NameButtons:GetHeight() * 1.1 ) + 1.91
		
		NameButtonsText:SetWidth(sWidth)
		NameButtons:SetWidth(sWidth)
		
		for i = 1, #classTable do
			
			local text = classTable[i]
			local subText = string.sub(text, 1, string.find(text, '%[') - 1)
			local CN = string.sub(text, string.find(text, '%[') + 1, string.find(text, '%]') - 1)
			
			if subText == v then
				if ClassColor[CN] ~= nil then
					NameButtonsText:SetTextColor(ClassColor[CN][1], ClassColor[CN][2], ClassColor[CN][3], 1)
				end
				isClassFound = true
			end
			
			if isClassFound then
				break
			end
		end
		
		if count == 1 then
			
			if state == "Lottery" then
				NameButtons:SetPoint("TOP", GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild, "TOP", 0, -2)
			else
				NameButtons:SetPoint("TOP", GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameChild, "TOP", 0, -2)
			end
			
			nameHeight = nameHeight + sHeight + 2
			
		else
			
			if state == "Lottery" then
				NameButtons:SetPoint("TOP", GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
			else
				NameButtons:SetPoint("TOP", GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameChild.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
			end
			
			nameHeight = nameHeight + sHeight
			
		end
		
		NameButtons:SetScript("OnClick", function(self, button)
			
			if button == "LeftButton" then
				
				local formerText
				if state == "Lottery" then
					formerText = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionText:GetText()
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionText:SetText(NameButtonsText:GetText())
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionText:SetWidth(115)
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionText:SetWordWrap(false)
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionText:SetFont(GLR_Core.ButtonFont, 12)
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu:Hide()
					for i = 1, #classTable do
						
						local isClassFound = false
						local text = classTable[i]
						local subText = string.sub(text, 1, string.find(text, '%[') - 1)
						local CN = string.sub(text, string.find(text, '%[') + 1, string.find(text, '%]') - 1)
						
						if subText == GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionText:GetText() then
							if ClassColor[CN] ~= nil then
								GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionText:SetTextColor(ClassColor[CN][1], ClassColor[CN][2], ClassColor[CN][3], 1)
								GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox:SetTextColor(ClassColor[CN][1], ClassColor[CN][2], ClassColor[CN][3], 1)
							end
							isClassFound = true
						end
						
						if isClassFound then
							break
						end
					end
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelection:Show()
				else
					formerText = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionText:GetText()
					GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionText:SetText(NameButtonsText:GetText())
					GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionText:SetWidth(115)
					GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionText:SetWordWrap(false)
					GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionText:SetFont(GLR_Core.ButtonFont, 12)
					GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu:Hide()
					for i = 1, #classTable do
						
						local isClassFound = false
						local text = classTable[i]
						local subText = string.sub(text, 1, string.find(text, '%[') - 1)
						local CN = string.sub(text, string.find(text, '%[') + 1, string.find(text, '%]') - 1)
						
						if subText == GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionText:GetText() then
							if ClassColor[CN] ~= nil then
								GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionText:SetTextColor(ClassColor[CN][1], ClassColor[CN][2], ClassColor[CN][3], 1)
								GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox:SetTextColor(ClassColor[CN][1], ClassColor[CN][2], ClassColor[CN][3], 1)
							end
							isClassFound = true
						end
						
						if isClassFound then
							break
						end
					end
					GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelection:Show()
				end
				
			end
			
		end)
		
		if nameHeight <= 150 and scrollHeight <= 149 then
			scrollHeight = 150
		elseif nameHeight > 160 then
			scrollHeight = nameHeight
		end
		
		if (sWidth + 40) >= width and (sWidth + 40) >= 240 then
			width = sWidth + 100
		end
		
		NameButtons:Show()
		NameButtons:Hide()
		NameButtons:Show()
		
		count = count + 1
		
	end
	
	local scrollMax = ( scrollHeight - 155 )
	
	if scrollMax <= 0 then
		
		scrollMax = 0
		
	end
	
	if state == "Lottery" then
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu:SetSize(width, 160)
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameChild:SetSize(width, 160)
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameScrollFrame:SetSize(width, 150)
		
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(0)
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetMinMaxValues(0, scrollMax)
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetScript("OnValueChanged", function(self)
			GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameScrollFrame:SetVerticalScroll(self:GetValue())
		end)
		
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameScrollFrame:EnableMouseWheel(true)
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameScrollFrame:SetScript("OnMouseWheel", function(_, delta)
			
			local current = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:GetValue()
			
			if IsShiftKeyDown() and delta > 0 then
				GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(0)
			elseif IsShiftKeyDown() and delta < 0 then
				GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(scrollMax)
			elseif delta < 0 and current < scrollMax then
				if IsControlKeyDown() then
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(current + 60)
				else
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(current + 20)
				end
			elseif delta > 0 and current > 1 then
				if IsControlKeyDown() then
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(current - 60)
				else
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionMenu.GLR_EditLotteryNameFrameSlider:SetValue(current - 20)
				end
			end
			
		end)
		
	else
		
		GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu:SetSize(width, 160)
		GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameChild:SetSize(width, 160)
		GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameScrollFrame:SetSize(width, 150)
		
		GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameSlider:SetValue(0)
		GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameSlider:SetMinMaxValues(0, scrollMax)
		GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameSlider:SetScript("OnValueChanged", function(self)
			GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameScrollFrame:SetVerticalScroll(self:GetValue())
		end)
		GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameScrollFrame:EnableMouseWheel(true)
		GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameScrollFrame:SetScript("OnMouseWheel", function(_, delta)
			
			local current = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameSlider:GetValue()
			
			if IsShiftKeyDown() and delta > 0 then
				GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameSlider:SetValue(0)
			elseif IsShiftKeyDown() and delta < 0 then
				GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameSlider:SetValue(scrollMax)
			elseif delta < 0 and current < scrollMax then
				if IsControlKeyDown() then
					GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameSlider:SetValue(current + 60)
				else
					GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameSlider:SetValue(current + 20)
				end
			elseif delta > 0 and current > 1 then
				if IsControlKeyDown() then
					GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameSlider:SetValue(current - 60)
				else
					GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionMenu.GLR_EditRaffleNameFrameSlider:SetValue(current - 20)
				end
			end
			
		end)
		
	end
	
end

function GLR:SetPlayerToEditInEvent(EventType)
	
	local state = EventType
	local ticket = 0
	local name
	
	if state == "Lottery" then
		name = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectPlayerSelectionText:GetText()
	else
		name = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectPlayerSelectionText:GetText()
	end
	
	if name ~= L["GLR_Error_No_Entries_Found"] then
		ticket = glrCharacter[state].Entries.Tickets[name]["NumberOfTickets"]
	end
	
	local tickets = tostring(ticket)
	
	if state == "Lottery" then
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox:SetText(name)
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox:SetCursorPosition(0)
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerTicketsEditBox:SetText(tickets)
		GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerTicketsEditBox:SetCursorPosition(0)
	else
		GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox:SetText(name)
		GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox:SetCursorPosition(0)
		GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerTicketsEditBox:SetText(tickets)
		GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerTicketsEditBox:SetCursorPosition(0)
	end
	
end

function GLR:GetListOfEntries()
	
	local ListOfEntries = {}
	local s = lotteryOrRaffle
	local count = 0
	
	if glrCharacter ~= nil then
		if glrCharacter[s] ~= nil then
			if glrCharacter[s].Entries ~= nil then
				for i = 1, #glrCharacter[s].Entries.Names do
					table.insert(ListOfEntries, glrCharacter[s].Entries.Names[i])
					count = count + 1
				end
			end
		end
	end
	
	if count == 0 then
		table.insert(ListOfEntries, L["GLR_Error_No_Entries_Found"])
	end
	
	sort(ListOfEntries)
	return ListOfEntries
	
end

function GLR:MonthToString(arg)
	
	local selectedMonth
	if arg == "Lottery" then
		selectedMonth = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionText:GetText()
	else
		selectedMonth = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionText:GetText()
	end
	local monthValue = {
		["January"] = "01",
		["February"] = "02",
		["March"] = "03",
		["April"] = "04",
		["May"] = "05",
		["June"] = "06",
		["July"] = "07",
		["August"] = "08",
		["September"] = "09",
		["October"] = "10",
		["November"] = "11",
		["December"] = "12"
	}
	
	return monthValue[selectedMonth]
	
end

function GLR:YearToString(arg)
	
	local selectedYear
	if arg == "Lottery" then
		selectedYear = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfYearsSelectionText:GetText()
	else
		selectedYear = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfYearsSelectionText:GetText()
	end
	local yearValue = {
		["2018"] = "18",
		["2019"] = "19"
	}
	
	return yearValue[selectedYear]
	
end

function GLR:GetCurrentMonth()
	
	local monthList = {
		L["January"],
		L["February"],
		L["March"],
		L["April"],
		L["May"],
		L["June"],
		L["July"],
		L["August"],
		L["September"],
		L["October"],
		L["November"],
		L["December"]
	}
	local monthValue = {
		[L["January"]] = 1,
		[L["February"]] = 2,
		[L["March"]] = 3,
		[L["April"]] = 4,
		[L["May"]] = 5,
		[L["June"]] = 6,
		[L["July"]] = 7,
		[L["August"]] = 8,
		[L["September"]] = 9,
		[L["October"]] = 10,
		[L["November"]] = 11,
		[L["December"]] = 12
	}
	local month = "Month"
	local currentMonth = tonumber(date("%m"))
	
	for t, v in pairs(monthList) do
		for x, y in pairs(monthValue) do
			if v == x and y == currentMonth then
				month = v
				return month
			end
		end
	end
	
end

function GLR:GetCurrentDay()
	
	local Day = date("%d")
	local monthDays = {
		[L["January"]] = 31,
		[L["February"]] = 28,
		[L["March"]] = 31,
		[L["April"]] = 30,
		[L["May"]] = 31,
		[L["June"]] = 30,
		[L["July"]] = 31,
		[L["August"]] = 31,
		[L["September"]] = 30,
		[L["October"]] = 31,
		[L["November"]] = 30,
		[L["December"]] = 31
	}
	--[[
	local currentHour = tonumber(date("%H"))
	local currentMinute = tonumber(date("%M"))
	local state = ""
	local SelectedMonth = ""
	local Lottery = GLR_UI.GLR_NewLotteryEventFrame:IsVisible()
	local Raffle = GLR_UI.GLR_NewRaffleEventFrame:IsVisible()
	local Month = GLR:GetCurrentMonth()
	
	
	if Lottery then
		state = "Lottery"
		SelectedMonth = GLR_UI.GLR_NewLotteryEventFrame.GLR_ListOfMonthsSelectionText:GetText()
	elseif Raffle then
		state = "Raffle"
		SelectedMonth = GLR_UI.GLR_NewRaffleEventFrame.GLR_ListOfMonthsSelectionText:GetText()
	else
		state = "None"
		SelectedMonth = GLR:GetCurrentMonth()
	end
	
	
	
	Will have to spend some time working on this logic as it will also require checking current month for valid number of days
	if currentHour > 23 then
		if currentMinute >= 45 then
			
		else
			return currentDay
		end
	else
		return currentDay
	end
	--]]
	
	return Day
	
end

function GLR:GetCurrentYear()
	
	local currentYear = L["20"] .. date("%y")
	return currentYear
	
end

function GLR:GetCurrentHour()
	
	local currentHour = tonumber(date("%H"))
	local currentMinute = tonumber(date("%M"))
	
	if currentMinute < 45 then
		if currentHour < 10 then
			currentHour = L["0"] .. L[tostring(currentHour)]
			return L[currentHour]
		else
			return L[tostring(currentHour)]
		end
	else
		if currentHour < 10 then
			currentHour = currentHour + 1
			if currentHour < 10 then
				currentHour = L["0"] .. L[tostring(currentHour)]
				return L[currentHour]
			else
				currentHour = L[tostring(currentHour)]
				return L[currentHour]
			end
		else
			if currentHour == 23 then
				return L["00"]
			else
				currentHour = currentHour + 1
				return L[tostring(currentHour)]
			end
		end
	end
	
end

function GLR:GetCurrentMinute()
	
	local currentMinute = tonumber(date("%M"))
	local minuteList = {
		15, -- [1]
		30, -- [2]
		45, -- [3]
	}
	
	for i = 1, #minuteList do
		if currentMinute <= minuteList[i] then
			return L[tostring(minuteList[i])]
		elseif currentMinute >= 45 then
			return L["00"]
		end
	end
	
end

function GLR:GeneratePlayersAndTicketTotalsTable()
	
	local playerNameTable = {}
	local s = lotteryOrRaffle
	
	if s == "Lottery" then
		if glrCharacter ~= nil then
			if glrCharacter[s] ~= nil then
				if glrCharacter[s].Entries ~= nil then
					if glrCharacter[s].Entries.Names ~= nil then
						for i = 1, #glrCharacter[s].Entries.Names do
							table.insert(playerNameTable, glrCharacter[s].Entries.Names[i])
						end
						sort(playerNameTable)
						return playerNameTable
					else
						return playerNameTable
					end
				else
					return playerNameTable
				end
			else
				return playerNameTable
			end
		else
			return playerNameTable
		end
	else
		if glrCharacter ~= nil then
			if glrCharacter[s] ~= nil then
				if glrCharacter[s].Entries ~= nil then
					if glrCharacter[s].Entries.Names ~= nil then
						for i = 1, #glrCharacter[s].Entries.Names do
							table.insert(playerNameTable, glrCharacter[s].Entries.Names[i])
						end
						sort(playerNameTable)
						return playerNameTable
					else
						return playerNameTable
					end
				else
					return playerNameTable
				end
			else
				return playerNameTable
			end
		else
			return playerNameTable
		end
	end
	
end

function GLR:CHAT_MSG_GUILD(event, msg, sender)
	
	local text = string.lower(msg)
	local continue = true
	local check = false
	local doBreak = false
	
	if text ~= nil then
		if string.find(text, L["Detect Lottery"]) or text == string.lower(L["Lottery"]) or text == "lottery" then
			text = L["Detect Lottery"]
		elseif string.find(text, L["Detect Raffle"]) or text == string.lower(L["Raffle"]) or text == "raffle" then
			text = L["Detect Raffle"]
		end
	end
	
	for i = 1, #GLR_AddOnMessageTable.HasMod do
		local name = string.sub(GLR_AddOnMessageTable.HasMod[i], 1, string.find(GLR_AddOnMessageTable.HasMod[i], '%!') - 1)
		if name ~= FullPlayerName then
			check = true
			break
		end
	end
	
	if check then
		for t, v in pairs(GLR_AddOnMessageTable.ActiveEvents) do
			for i = 1, #GLR_AddOnMessageTable.ActiveEvents[t] do
				local name = GLR_AddOnMessageTable.ActiveEvents[t][i]
				if t == "Lottery" and text == L["Detect Lottery"] or t == "Lottery" and text == L["Detect Other Lottery"] then
					if name == FullPlayerName then
						doBreak = true
						break
					elseif name ~= FullPlayerName then
						continue = false
						doBreak = true
						break
					end
				elseif t == "Raffle" and text == L["Detect Raffle"] or t == "Raffle" and text == L["Detect Other Raffle"] then
					if name == FullPlayerName then
						doBreak = true
						break
					elseif name ~= FullPlayerName then
						continue = false
						doBreak = true
						break
					end
				end
			end
			if doBreak then
				break
			end
		end
	end
	
	if event == "CHAT_MSG_GUILD" and text ~= nil and sender ~= nil and continue and DetectOtherPhrases then
		if string.find(text, L["Detect Other Lottery"]) or string.find(text, L["Detect Other Raffle"]) then
			local target
			local state
			if string.find(text, L["Detect Other Lottery"]) then
				if string.find(text, " ") then	
					target = string.sub(msg, string.find(msg, " ") + 1)
				elseif text == L["Detect Other Lottery"] then
					target = ""
				end
				state = "Lottery"
			elseif string.find(text, L["Detect Other Raffle"]) then
				if string.find(text, " ") then	
					target = string.sub(msg, string.find(msg, " ") + 1)
				elseif text == L["Detect Other Raffle"] then
					target = ""
				end
				state = "Raffle"
			end
			if target ~= nil then
				DetectOtherPhrases = false
				SendRequestedInfo(sender, target, state)
			end
		end
	end
	
	if event == "CHAT_MSG_GUILD" and text == L["Detect Lottery"] and DetectPhrases and continue then
		
		local user = sender
		local targetRealm
		local bypass = false
		local state = "Lottery"
		
		if string.find(string.lower(sender), "-") ~= nil then
			targetRealm = string.sub(sender, string.find(sender, "-") + 1)
		else
			bypass = true
		end
		
		if PlayerRealmName == targetRealm and not bypass then
			user = string.sub(sender, 1, string.find(sender, "-") - 1)
		end
		
		GLR:SendPlayerTicketInfo(state, user)
		
	end
	
	if event == "CHAT_MSG_GUILD" and text == L["Detect Raffle"] and DetectPhrases and continue then
		
		local user = sender
		local targetRealm
		local bypass = false
		local state = "Raffle"
		
		if string.find(string.lower(sender), "-") ~= nil then
			targetRealm = string.sub(sender, string.find(sender, "-") + 1)
		else
			bypass = true
		end
		
		if PlayerRealmName == targetRealm and not bypass then
			user = string.sub(sender, 1, string.find(sender, "-") - 1)
		end
		
		GLR:SendPlayerTicketInfo(state, user)
		
	end
	
end

function GLR:CHAT_MSG_WHISPER(event, msg, sender)
	
	local text = string.lower(msg)
	local continue = false
	local guildName, _, _, _ = GetGuildInfo("PLAYER")
	local status = glrCharacter.Data.Settings.MultiGuild
	
	if text ~= nil then
		if string.find(text, L["Detect Lottery"]) or text == string.lower(L["Lottery"]) then
			text = L["Detect Lottery"]
		elseif string.find(text, L["Detect Raffle"]) or text == string.lower(L["Raffle"]) then
			text = L["Detect Raffle"]
		end
	end
	
	if glrRosterTotal == 0 and guildName ~= nil then
		if not status then
			GLR_U:UpdateRosterTable()
		else
			GLR_U:PopulateMultiGuildTable()
		end
	end
	
	if event == "CHAT_MSG_WHISPER" and text ~= nil and sender ~= nil and DetectOtherPhrases then
		if string.find(text, L["Detect Other Lottery"]) or string.find(text, L["Detect Other Raffle"]) then
			local target
			local state
			if string.find(text, L["Detect Other Lottery"]) then
				if string.find(text, " ") then	
					target = string.sub(msg, string.find(msg, " ") + 1)
				elseif text == L["Detect Other Lottery"] then
					target = ""
				end
				state = "Lottery"
			elseif string.find(text, L["Detect Other Raffle"]) then
				if string.find(text, " ") then	
					target = string.sub(msg, string.find(msg, " ") + 1)
				elseif text == L["Detect Other Raffle"] then
					target = ""
				end
				state = "Raffle"
			end
			if target ~= nil then
				DetectOtherPhrases = false
				SendRequestedInfo(sender, target, state)
			end
		end
	end
	
	if event == "CHAT_MSG_WHISPER" and text == L["Detect Lottery"] and guildName ~= nil and DetectPhrases then
		
		local user = sender
		local targetRealm
		local bypass = false
		local state = "Lottery"
		local TestTargetName = ""
		if not string.find(user, "-") then
			TestTargetName = strjoin("-", user, PlayerRealmName)
		end
		
		if not status then
			for i = 1, #glrRoster do
				local TestTarget = string.sub(glrRoster[i], 1, string.find(glrRoster[i], '%[') - 1)
				if TestTargetName ~= "" then
					if TestTargetName == TestTarget then
						continue = true
						break
					end
				else
					if user == TestTarget then
						continue = true
						break
					end
				end
			end
		else
			for i = 1, #glrMultiGuildRoster do
				local TestTarget = string.sub(glrMultiGuildRoster[i], 1, string.find(glrMultiGuildRoster[i], '%[') - 1)
				if TestTargetName ~= "" then
					if TestTargetName == TestTarget then
						continue = true
						break
					end
				else
					if user == TestTarget then
						continue = true
						break
					end
				end
			end
		end
		
		if string.find(string.lower(sender), "-") ~= nil then
			targetRealm = string.sub(sender, string.find(sender, "-") + 1)
		else
			bypass = true
		end
		
		if PlayerRealmName == targetRealm and not bypass then
			user = string.sub(sender, 1, string.find(sender, "-") - 1)
		end
		
		if continue then
			GLR:SendPlayerTicketInfo(state, user)
		end
		
	end
	
	if event == "CHAT_MSG_WHISPER" and text == L["Detect Raffle"] and guildName ~= nil and DetectPhrases then
		
		local user = sender
		local targetRealm
		local bypass = false
		local state = "Raffle"
		
		if not status then
			for i = 1, #glrRoster do
				local TestTargetName = ""
				local TestTarget = string.sub(glrRoster[i], 1, string.find(glrRoster[i], '%[') - 1)
				if not string.find(user, "-") then
					TestTargetName = strjoin("-", user, PlayerRealmName)
				end
				if TestTargetName ~= "" then
					if TestTargetName == TestTarget then
						continue = true
						break
					end
				else
					if user == TestTarget then
						continue = true
						break
					end
				end
			end
		else
			for i = 1, #glrMultiGuildRoster do
				local TestTargetName = ""
				local TestTarget = string.sub(glrMultiGuildRoster[i], 1, string.find(glrMultiGuildRoster[i], '%[') - 1)
				if not string.find(user, "-") then
					TestTargetName = strjoin("-", user, PlayerRealmName)
				end
				if TestTargetName ~= "" then
					if TestTargetName == TestTarget then
						continue = true
						break
					end
				else
					if user == TestTarget then
						continue = true
						break
					end
				end
			end
		end
		
		if string.find(string.lower(sender), "-") ~= nil then
			targetRealm = string.sub(sender, string.find(sender, "-") + 1)
		else
			bypass = true
		end
		
		if PlayerRealmName == targetRealm and not bypass then
			user = string.sub(sender, 1, string.find(sender, "-") - 1)
		end
		
		if continue then
			GLR:SendPlayerTicketInfo(state, user)
		end
		
	end
	
end

function GLR:SendPlayerTicketInfo(state, user)
	
	local userName = user
	local targetedName = user
	local playerGuild = glrCharacter.Data.Settings.GuildName
	local addonEnabled = false
	local timeBetweenAlerts = glrCharacter.Data.Settings.TimeBetweenAlerts
	local lotteryStatus = glrCharacter.Data.Settings["CurrentlyActiveLottery"]
	local raffleStatus = glrCharacter.Data.Settings["CurrentlyActiveRaffle"]
	local LargeData = glrCharacter.Data.Settings.SendLargeInfo
	local dateTime = time()
	local lastAlert = 0
	local totalTime = 0
	local status = false
	local prizeOne = false
	local prizeTwo = false
	local prizeThree = false
	
	if glrCharacter.Data.Settings ~= nil then
		if glrCharacter.Data.Settings.enabled ~= nil then
			addonEnabled = glrCharacter.Data.Settings.enabled
		end
	end
	
	if not string.find(targetedName, "-") then
		userName = strjoin("-", userName, PlayerRealmName)
	end
	
	if glrCharacter[state] ~= nil then
		if glrCharacter[state].MessageStatus ~= nil then
			if glrCharacter[state].MessageStatus[userName] ~= nil then
				lastAlert = glrCharacter[state].MessageStatus[userName].lastAlert + timeBetweenAlerts
				totalTime = dateTime + timeBetweenAlerts
			else
				glrCharacter[state].MessageStatus[userName] = { ["sentMessage"] = false, ["lastAlert"] = dateTime }
			end
		else
			glrCharacter[state].MessageStatus = {}
			glrCharacter[state].MessageStatus[userName] = { ["sentMessage"] = false, ["lastAlert"] = dateTime }
		end
	end
	
	if state == "Lottery" then
		if glrCharacter.Event[state] ~= nil then
			status = lotteryStatus
		end
	else
		if glrCharacter.Event[state] ~= nil then
			if glrCharacter.Event[state].FirstPlace then
				prizeOne = glrCharacter.Event[state].FirstPlace
			end
			if glrCharacter.Event[state].SecondPlace then
				prizeTwo = glrCharacter.Event[state].SecondPlace
			end
			if glrCharacter.Event[state].ThirdPlace then
				prizeThree = glrCharacter.Event[state].ThirdPlace
			end
			status = raffleStatus
		end
	end
	
	if addonEnabled then
		
		if dateTime > lastAlert then
			
			if status then
				
				local startingGold
				local ticketSold
				local price
				local jackpotGold
				local guildPercent
				local continue = false
				
				if state == "Lottery" then
					startingGold = tonumber(glrCharacter.Event[state].StartingGold)
					ticketSold = glrCharacter.Event[state].TicketsSold
					price = tonumber(glrCharacter.Event[state].TicketPrice)
					local tempJackpotGold = startingGold + ( ticketSold * price )
					local round = glrCharacter.Data.Settings.RoundJackpot
					guildPercent = glrCharacter.Event[state].GuildCut
					jackpotGold = tostring(tempJackpotGold - ( (tonumber(guildPercent) / 100) * tempJackpotGold ))
					jackpotGold = GetMoneyValue(jackpotGold, "Lottery", "Jackpot", round, false)
					if glrCharacter[state].Entries.Tickets[userName] ~= nil then
						continue = true
					end
				else
					ticketSold = glrCharacter.Event[state].TicketsSold
					price = tonumber(glrCharacter.Event[state].TicketPrice)
					if glrCharacter[state].Entries.Tickets[userName] ~= nil then
						continue = true
					end
				end
				
				if continue then
					
					local eventName
					local eventDate
					local purchasedTickets
					local maxTickets
					local tickets
					local ticketNumbers = ""
					
					if glrCharacter[state].MessageStatus.userName ~= nil then
						glrCharacter[state].MessageStatus.userName = { ["sentMessage"] = true, ["lastAlert"] = dateTime }
					end
					
					eventName = glrCharacter.Event[state].EventName
					eventDate = glrCharacter.Event[state].Date
					purchasedTickets = tostring(glrCharacter[state].Entries.Tickets[userName].NumberOfTickets)
					maxTickets = glrCharacter.Event[state].MaxTickets
					tickets = glrCharacter[state].Entries.TicketNumbers[userName]
					
					SendChatMessage("--------------------------------------------------", "WHISPER", nil, userName)
					SendChatMessage(L["Send Info Title"], "WHISPER", nil, userName)
					SendChatMessage(L["Send Info Event Info 1"] .. ": " .. eventName .. " " .. L["Send Info Event Info 2"] .. " " .. eventDate, "WHISPER", nil, userName)
					
					if tonumber(purchasedTickets) > 0 then
						
						SendChatMessage(L["Send Info Tickets Purchased First Msg 1"] .. " " .. purchasedTickets .. " " .. L["Send Info Tickets Purchased First Msg 2"] .. " " .. maxTickets .. " " .. L["Send Info Tickets Purchased First Msg 3"], "WHISPER", nil, userName)
						
					end
					
					if LargeData then
						
						for i = 1, #tickets do
							
							ticketNumbers = strjoin(" ", ticketNumbers, tickets[i])
							
						end
						
						local length = strlen(ticketNumbers)
						
						if length > 220 then
							
							local currentTime = time()
							local longMsg = true
							local bypass = true
							local endMsg = true
							local done = false
							local ta = {}
							local lt = {}
							local ts = ""
							local nt = 0
							local mnt = 0
							local nm = 0
							local steps = 35
							
							if longMsg then
								
								SendChatMessage(L["Send Info Long Ticket Message"], "WHISPER", nil, userName)
								longMsg = false
								
							end
							
							for v in string.gmatch(ticketNumbers, "[^ ]+") do
								table.insert(ta, v)
								nt = nt + 1
								mnt = mnt + 1
							end
							
							if mnt >= 500 then
								bypass = false
							end
							
							for i = 1, #ta do
								
								for j = 1, steps do
									if length > 0 or not done then
										if  nt > 0 then
											ts = strjoin(" ", ts, ta[1])
											table.remove(ta, 1)
											nt = nt - 1
										end
									end
								end
								
								if not done then
									nm = nm + 1
									table.insert(lt, ts)
									length = length - strlen(ts)
									steps = length / 5
									if steps > 35 then
										steps = 35
									end
									if nt == 0 then
										done = true
									end
								end
								
								if bypass then
									SendChatMessage(ts, "WHISPER", nil, userName)
								end
								
								--Resets the Ticket Number string so it's not a ever growing string until it breaks the character limit
								ts = ""
								
								if done then
									break
								end
								
							end
							
							if not bypass then
								
								local ms = 0.2
								nm = nm + 1
								sort(lt)
								
								for i = 1, nm do
									C_Timer.After(ms, function()
										GLR:SendLargeTicketInfo(lt, userName, nm, state)
									end)
									ms = ms + 0.2
								end
								
							end
							
							if endMsg and bypass and state == "Lottery" then
								
								SendChatMessage(L["Send Info Current Jackpot Part 1"] .. " " .. guildPercent .. "%. " .. L["Send Info Current Jackpot Part 2"] .. " " .. jackpotGold, "WHISPER", nil, userName)
								SendChatMessage("--------------------------------------------------", "WHISPER", nil, userName)
								endMsg = false
								
							elseif endMsg and bypass and state == "Raffle" then
								
								SendChatMessage(L["Send Info Current Prizes"] .. ":", "WHISPER", nil, userName)
								
								if prizeOne then
									SendChatMessage(L["Send Info GLR"] .. ": " .. prizeOne, "WHISPER", nil, userName)
								end
								if prizeTwo then
									SendChatMessage(L["Send Info GLR"] .. ": " .. prizeTwo, "WHISPER", nil, userName)
								end
								if prizeThree then
									SendChatMessage(L["Send Info GLR"] .. ": " .. prizeThree, "WHISPER", nil, userName)
								end
								
								SendChatMessage("--------------------------------------------------", "WHISPER", nil, userName)
								endMsg = false
								
							end
							
						else
							
							if tonumber(purchasedTickets) > 0 then
								
								SendChatMessage(L["Send Info Short Ticket Message"] .. ":" .. ticketNumbers, "WHISPER", nil, userName)
								if state == "Lottery" then
									SendChatMessage(L["Send Info Current Jackpot Part 1"] .. " " .. guildPercent .. "%. " .. L["Send Info Current Jackpot Part 2"] .. " " .. jackpotGold, "WHISPER", nil, userName)
								end
								
							end
							
						end
						
					else
						
						local fT = glrCharacter[state].Entries.TicketRange[userName].LowestTicketNumber
						local lT = glrCharacter[state].Entries.TicketRange[userName].HighestTicketNumber
						local message_1 = string.gsub(string.gsub(L["Send Info Ticket Number Range"], "%%first", fT), "%%last", lT)
						SendChatMessage(message_1, "WHISPER", nil, userName)
						
					end
					
					if glrCharacter[state].Entries.Tickets[userName].NumberOfTickets < tonumber(maxTickets) then
						
						local ticketDifference = tonumber(maxTickets) - glrCharacter[state].Entries.Tickets[userName].NumberOfTickets
						local ticketPrice = glrCharacter.Event[state].TicketPrice
						ticketPrice = GetMoneyValue(ticketPrice, "", "", false, false)
						
						SendChatMessage(L["Send Info Can Purchase Tickets Part 1"] .. " " .. ticketDifference .. " " .. L["Send Info Can Purchase Tickets Part 2"] .. " " .. ticketPrice .. " " .. L["Send Info Can Purchase Tickets Part 3"], "WHISPER", nil, userName)
						
					end
					
					if state == "Lottery" then
						
						SendChatMessage(L["Send Info Current Jackpot Part 1"] .. " " .. guildPercent .. "%. " .. L["Send Info Current Jackpot Part 2"] .. " " .. jackpotGold, "WHISPER", nil, userName)
						
					else
						
						SendChatMessage(L["Send Info Current Prizes"] .. ":", "WHISPER", nil, userName)
						if prizeOne then
							SendChatMessage(L["Send Info GLR"] .. ": " .. prizeOne, "WHISPER", nil, userName)
						end
						if prizeTwo then
							SendChatMessage(L["Send Info GLR"] .. ": " .. prizeTwo, "WHISPER", nil, userName)
						end
						if prizeThree then
							SendChatMessage(L["Send Info GLR"] .. ": " .. prizeThree, "WHISPER", nil, userName)
						end
						
					end
					
					SendChatMessage("--------------------------------------------------", "WHISPER", nil, userName)
					
				elseif not continue then
					
					local eventName = glrCharacter.Event[state].EventName
					local eventDate = glrCharacter.Event[state].Date
					local maxTickets = glrCharacter.Event[state].MaxTickets
					local ticketPrice = glrCharacter.Event[state].TicketPrice
					ticketPrice = GetMoneyValue(ticketPrice, "", "", false, false)
					
					if glrCharacter[state].Entries.Tickets[userName] == nil then
						SendChatMessage("--------------------------------------------------", "WHISPER", nil, userName)
						SendChatMessage(L["Send Info Title"], "WHISPER", nil, userName)
						SendChatMessage(L["Send Info Event Info 1"] .. ": " .. eventName .. " " .. L["Send Info Event Info 2"] .. " " .. eventDate, "WHISPER", nil, userName)
						SendChatMessage(L["Send Info No Tickets Purchased Part 1"] .. " " .. userName .. ". " .. L["Send Info No Tickets Purchased Part 2"], "WHISPER", nil, userName)
						SendChatMessage(L["Send Info Can Purchase Tickets Part 1"] .. " " .. maxTickets .. " " .. L["Send Info Can Purchase Tickets Part 2"] .. " " .. ticketPrice .. " " .. L["Send Info Can Purchase Tickets Part 3"], "WHISPER", nil, userName)
					end
					
					if state == "Lottery" then
						
						if glrCharacter[state].Entries.Tickets[userName] == nil then
							
							SendChatMessage(L["Send Info Reply Lottery"], "WHISPER", nil, userName)
							SendChatMessage(L["Send Info Current Jackpot Part 1"] .. " " .. guildPercent .. "%. " .. L["Send Info Current Jackpot Part 2"] .. " " .. jackpotGold, "WHISPER", nil, userName)
							SendChatMessage("--------------------------------------------------", "WHISPER", nil, userName)
							
						end
						
					else
						
						if glrCharacter[state].Entries.Tickets[userName] == nil then
							
							SendChatMessage(L["Send Info Reply Raffle"], "WHISPER", nil, userName)
							SendChatMessage(L["Send Info Current Prizes"] .. ":", "WHISPER", nil, userName)
							if prizeOne then
								SendChatMessage(L["Send Info GLR"] .. ": " .. prizeOne, "WHISPER", nil, userName)
							end
							if prizeTwo then
								SendChatMessage(L["Send Info GLR"] .. ": " .. prizeTwo, "WHISPER", nil, userName)
							end
							if prizeThree then
								SendChatMessage(L["Send Info GLR"] .. ": " .. prizeThree, "WHISPER", nil, userName)
							end
							SendChatMessage("--------------------------------------------------", "WHISPER", nil, userName)
							
						end
						
					end
					
				end
				
			else
				if state == "Lottery" then
					SendChatMessage(L["Send Info No Active Lottery"], "WHISPER", nil, userName)
				else
					SendChatMessage(L["Send Info No Active Raffle"], "WHISPER", nil, userName)
				end
			end
			
			if glrCharacter[state].MessageStatus == nil then
				glrCharacter[state].MessageStatus = {}
				glrCharacter[state].MessageStatus[userName] = { ["sentMessage"] = false, ["lastAlert"] = dateTime }
			end
			
		else
			SendChatMessage(L["Send Info Must Wait 1"] .. " " .. timeBetweenAlerts .. " " .. L["Send Info Must Wait 2"], "WHISPER", nil, userName)
		end
		
	elseif not addonEnabled then
		SendChatMessage(L["Send Info GLR Disabled"], "WHISPER", nil, userName)
	end
	
end

local function GLR_ChatEdit_InsertLink(text)
	
	if text and GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:HasFocus() then
		GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:SetText(text)
		GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:SetCursorPosition(0)
		return true
	end
	
	if text and GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:HasFocus() then
		GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:SetText(text)
		GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:SetCursorPosition(0)
		return true
	end
	
	if text and GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:HasFocus() then
		GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:SetText(text)
		GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:SetCursorPosition(0)
		return true
	end
	
	if text and GLR_UI.GLR_MainFrame.GLR_DebugEditBox:HasFocus() then
		GLR_UI.GLR_MainFrame.GLR_DebugEditBox:SetText(text)
		GLR_UI.GLR_MainFrame.GLR_DebugEditBox:SetCursorPosition(0)
		return true
	end
	
end

local function IsItemSoulbound(tooltip)
	local use = 0
	local ItemText = ""
	local continue = false
	local GLR_ItemStatus = true
	local ItemOkay = true
	local textLeft = tooltip.textLeft
	if GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:HasFocus() then
		ItemText = GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:GetText()
		use = 1
	elseif GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:HasFocus() then
		ItemText = GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:GetText()
		use = 2
	elseif GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:HasFocus() then
		ItemText = GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:GetText()
		use = 3
	end
	if not textLeft then
		textLeft = setmetatable({}, { __index = function(t, i)
			local tooltipName = tooltip:GetName()
			local line = _G[tooltipName .. "TextLeft" .. i]
			t[i] = line
			return line
		end })
		tooltip.textLeft = textLeft
	end
	for j = 2, tooltip:NumLines() do
		local text = textLeft[j]:GetText()
		if tonumber(text) ~= nil then
			local ItemName = select(1, GetItemInfo(text))
			local bindType = select(14, GetItemInfo(text))
			if ItemText ~= "" then
				if string.find(ItemText, ItemName) and bindType ~= 1 then
					continue = true
					ItemOkay = false
					break
				elseif string.find(ItemText, ItemName) and bindType == 1 then
					GLR_ItemStatus = false
					ItemOkay = false
					break
				end
			end
		else
			if text == "Soulbound" then
				continue = true
				ItemOkay = false
				break
			elseif text == "Blizzard Account Bound" then
				GLR_ItemStatus = false
				ItemOkay = false
				break
			end
		end
	end
	for j = 2, tooltip:NumLines() do
		local text = textLeft[j]:GetText()
		if continue or not GLR_ItemStatus or ItemOkay then
			if text then
				if (text == ITEM_SOULBOUND) or (text == ITEM_BIND_QUEST) or not GLR_ItemStatus then
					if use == 1 then
						GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:SetText("")
					elseif use == 2 then
						GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:SetText("")
					elseif use == 3 then
						GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:SetText("")
					end
					return
				elseif ItemOkay and ItemText ~= "" then
					if use == 1 then
						GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:ClearFocus()
					elseif use == 2 then
						GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:ClearFocus()
					elseif use == 3 then
						GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:ClearFocus()
					end
					return
				end
			end
		end
	end
end

local function CheckItemTooltip()
	local itemTooltips = {
		"GameTooltip",
		"ItemRefTooltip",
		"ItemRefShoppingTooltip1",
		"ItemRefShoppingTooltip2",
		"ItemRefShoppingTooltip3",
		"ShoppingTooltip1",
		"ShoppingTooltip2",
		"ShoppingTooltip3",
		"WorldMapCompareTooltip1",
		"WorldMapCompareTooltip2",
		"WorldMapCompareTooltip3",
	}
	for i, tooltip in pairs(itemTooltips) do
		tooltip = _G[tooltip]
		if tooltip then
			tooltip:HookScript("OnTooltipSetItem", IsItemSoulbound)
			itemTooltips[i] = nil
		end
	end
	if not next(itemTooltips) then
		GLR:UnregisterEvent(event)
		GLR:SetScript("OnEvent", nil)
	end
end

function GLR:RaffleEditBoxTextChanged(arg)
	
	local checkBox = arg
	CheckItemTooltip()
	
	if checkBox == "First" then
		if GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:GetText() ~= nil and GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:GetText() ~= "" then
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmRaffleItemOneButton:Show()
		end
		if GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:GetText() == "" then
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmRaffleItemOneButton:Hide()
		end
	end
	
	if checkBox == "Second" then
		if GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:GetText() ~= nil and GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:GetText() ~= "" then
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmRaffleItemTwoButton:Show()
		end
		if GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:GetText() == "" then
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmRaffleItemTwoButton:Hide()
		end
	end
	
	if checkBox == "Third" then
		if GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:GetText() ~= nil and GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:GetText() ~= "" then
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmRaffleItemThreeButton:Show()
		end
		if GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:GetText() == "" then
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmRaffleItemThreeButton:Hide()
		end
	end
end

function GLR:ConfirmValidItem(arg)
	
	local text
	local use = 0
	local allowInvalid = GLR_UI.GLR_NewRaffleEventFrame.GLR_AllowInvalidItemCheckButton:GetChecked()
	
	if arg == "First" then
		text = GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:GetText()
		use = 1
	elseif arg == "Second" then
		text = GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:GetText()
		use = 2
	elseif arg == "Third" then
		text = GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:GetText()
		use = 3
	end
	
	local itemName, itemLink = GetItemInfo(text)
	
	if itemLink == nil and allowInvalid then
		itemLink = text
	end
	
	if itemName == nil and allowInvalid then
		local itemText = text
		local nameText
		local doTask
		local c = 0
		for v in string.gmatch(itemText, '%[') do
			doTask = "left"
			c = c + 1
		end
		for v in string.gmatch(itemText, '%]') do
			if doTask == "left" then
				doTask = "both"
			else
				doTask = "right"
			end
			c = c + 1
		end
		if c >= 1 then
			if doTask == "both" then
				nameText = string.sub(text, string.find(itemText, '%[') + 1, string.find(itemText, '%]') - 1)
			elseif doTask == "left" then
				nameText = string.sub(text, string.find(itemText, '%[') + 1)
			elseif doTask == "right" then
				nameText = string.sub(text, 1, string.find(itemText, '%]') - 1)
			end
		else
			nameText = itemText
		end
		itemName = nameText
	end
	
	if itemName then
		if use == 1 then
			holdRaffleInfo.FirstPrize.ItemName = itemName
		elseif use == 2 then
			holdRaffleInfo.SecondPrize.ItemName = itemName
		elseif use == 3 then
			holdRaffleInfo.ThirdPrize.ItemName = itemName
		end
	end
	
	if itemLink then
		if use == 1 then
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmRaffleItemOneButton:Hide()
			GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:SetText(itemLink)
			GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:ClearFocus()
			holdRaffleInfo.FirstPrize.ItemLink = itemLink
		elseif use == 2 then
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmRaffleItemTwoButton:Hide()
			GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:SetText(itemLink)
			GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:ClearFocus()
			holdRaffleInfo.SecondPrize.ItemLink = itemLink
		elseif use == 3 then
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmRaffleItemThreeButton:Hide()
			GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:SetText(itemLink)
			GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:ClearFocus()
			holdRaffleInfo.ThirdPrize.ItemLink = itemLink
		end
		GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText("")
	else
		if use == 1 then
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmRaffleItemOneButton:Hide()
			GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:SetText("")
			GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleFirstPlaceEditBox:ClearFocus()
		elseif use == 2 then
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmRaffleItemTwoButton:Hide()
			GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:SetText("")
			GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleSecondPlaceEditBox:ClearFocus()
		elseif use == 3 then
			GLR_UI.GLR_NewRaffleEventFrame.GLR_ConfirmRaffleItemThreeButton:Hide()
			GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:SetText("")
			GLR_UI.GLR_NewRaffleEventFrame.GLR_NewRaffleThirdPlaceEditBox:ClearFocus()
		end
		GLR_UI.GLR_NewRaffleEventFrame.GLR_InvalidOption:SetText(L["GLR Invalid Raffle Item"])
	end
	
end

function GLR:ViewPlayerTickets(arg)
	
	local t = {}
	local tableTickets = {}
	local ticketString = ""
	local tableStrings = {}
	local state = arg
	local c = 0
	local count = 1
	local count2 = 1
	local amount = 0
	local gold = 0
	local buffer = 3
	local scrollWidth = 172
	local scrollHeight = 0
	local name = L["GLR_Error_No_Entries_Found"]
	local value = 0
	
	if glrCharacter[state].Entries.Names ~= nil then
		for k, v in pairs(glrCharacter[state].Entries.Names) do
			table.insert(t, v)
			c = c + 1
		end
	end
	
	if state == "Lottery" then
		value = GLR_SelectLotteryPlayer
	else
		value = GLR_SelectRafflePlayer
	end
	
	sort(t)
	
	if c >= 1 and value >= 1 then
		
		name = t[value]
		local n = 0
		local s = 0
		
		amount = glrCharacter[state].Entries.Tickets[name].NumberOfTickets
		gold = tostring(tonumber(glrCharacter.Event[state].TicketPrice) * glrCharacter[state].Entries.Tickets[name].NumberOfTickets)
		
		for i = 1, amount do
			table.insert(tableTickets, glrCharacter[state].Entries.TicketNumbers[name][i])
			n = n + 1
		end
		
		for i = 1, #tableTickets do
			
			ticketString = strjoin(" ", ticketString, tableTickets[i])
			n = n - 1
			s = s + 1
			
			if s == 5 then
				table.insert(tableStrings, ticketString)
				ticketString = ""
				s = 0
			end
			
			if s ~= 5 and n == 0 and ticketString ~= "" then
				table.insert(tableStrings, ticketString)
				ticketString = ""
			end
			
		end
		
	end
	
	if name ~= L["GLR_Error_No_Entries_Found"] then
		
		local GetGold = GetMoneyValue(gold, state, false, false, false)
		local UserName = string.sub(name, 1, string.find(name, "%-") - 1)
		local User = string.gsub(L["Ticket Info Player Name"], "%%User", UserName)
		local AmountPurchased = string.gsub(L["Ticket Info Player Tickets"], "%%amount", amount)
		local GoldValue = string.gsub(L["Ticket Info Gold Value"], "%%money", GetGold)
		
		GLR_UI.GLR_ViewPlayerTicketInfoFramePlayerName:SetText(User)
		GLR_UI.GLR_ViewPlayerTicketInfoFramePlayerTickets:SetText(AmountPurchased)
		GLR_UI.GLR_ViewPlayerTicketInfoFrameGoldValue:SetText(GoldValue)
		
		if GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameChild.PlayerTicketsTextFontstrings == nil then
			
			GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameChild.PlayerTicketsTextFontstrings = GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameChild.PlayerTicketsTextFontstrings or {}
			
		elseif GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameChild.PlayerTicketsTextFontstrings ~= nil then
			
			for i = 1, #GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameChild.PlayerTicketsTextFontstrings do
				
				local ClearText = GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameChild.PlayerTicketsTextFontstrings[count2][1]
				ClearText:SetText()
				count2 = count2 + 1
				
			end
			
		end
		
		for t, v in pairs(tableStrings) do
			
			if not GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameChild.PlayerTicketsTextFontstrings[t] then
				
				GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameChild.PlayerTicketsTextFontstrings[t] = { GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameChild:CreateFontString("GLR_PlayerNamesText" .. count, "OVERLAY", "GameFontWhiteTiny") }
				
			end
			
			local PlayerTickets = GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameChild.PlayerTicketsTextFontstrings[count][1]
			
			PlayerTickets:SetText(v)
			PlayerTickets:SetFont(GLR_Core.Font, 12)
			PlayerTickets:SetWordWrap(false)
			
			local sHeight = ( PlayerTickets:GetStringHeight() * 1.1 ) + 1.8
			
			if count == 1 then
				
				PlayerTickets:SetPoint("TOP", GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameChild, "TOP", 0, -1)
				scrollHeight = scrollHeight + sHeight + 2
				
			else
				
				PlayerTickets:SetPoint("TOP", GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameChild.PlayerTicketsTextFontstrings[count - 1][1], "BOTTOM", 0, -buffer)
				scrollHeight = scrollHeight + sHeight
				
			end
			
			PlayerTickets:Show()
			
			count = count + 1
			
		end
		
		GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameChild:SetSize(scrollWidth, scrollHeight)
		
		local scrollMax = ( scrollHeight - 93 )
		
		if scrollMax < 0 then
			
			scrollMax = 0
			
		end
		
		GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameSlider:SetValue(0)
		GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameSlider:SetMinMaxValues(0, scrollMax)
		GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameSlider:SetScript("OnValueChanged", function(self)
			GLR_UI.GLR_ViewPlayerTicketInfoScrollFrame:SetVerticalScroll(self:GetValue())
		end)
		
		GLR_UI.GLR_ViewPlayerTicketInfoScrollFrame:EnableMouseWheel(true)
		GLR_UI.GLR_ViewPlayerTicketInfoScrollFrame:SetScript("OnMouseWheel", function(_, delta)
			
			local current = GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameSlider:GetValue()
			
			if IsShiftKeyDown() and delta > 0 then
				GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameSlider:SetValue(0)
			elseif IsShiftKeyDown() and delta < 0 then
				GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameSlider:SetValue(scrollMax)
			elseif delta < 0 and current < scrollMax then
				if IsControlKeyDown() then
					GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameSlider:SetValue(current + 60)
				else
					GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameSlider:SetValue(current + 20)
				end
			elseif delta > 0 and current > 1 then
				if IsControlKeyDown() then
					GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameSlider:SetValue(current - 60)
				else
					GLR_UI.GLR_ViewPlayerTicketInfoScrollFrameSlider:SetValue(current - 20)
				end
			end
			
		end)
		
		--Quick and dirty way to get font strings to show completely
		GLR_UI.GLR_ViewPlayerTicketInfoFrame:Show()
		GLR_UI.GLR_ViewPlayerTicketInfoFrame:Hide()
		GLR_UI.GLR_ViewPlayerTicketInfoFrame:Show()
		
	end
	
end

function GLR:SelectPlayerNameForEntry(arg)
	
	local playerNames = GenerateRosterNames()
	local enteredText
	local enteredTable = {}
	local classTable = {}
	local status = glrCharacter.Data.Settings.MultiGuild
	if not status then
		classTable = glrRoster
	else
		classTable = glrMultiGuildRoster
	end
	local buffer = 3
	local count = 1
	local count2 = 1
	local n = 0
	local scrollHeight = 4
	local pHeight = 4
	local scrollWidth = 115
	local enteredOnce = false
	local state = arg
	
	if state == "Lottery" then
		if GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu.Buttons == nil then
			GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu.Buttons = GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu.Buttons or {}
		elseif GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu.Buttons ~= nil then
			for i = 1, #GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu.Buttons do
				local ClearText = GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu.Buttons[count2][1]
				ClearText:SetText()
				count2 = count2 + 1
			end
		end
		enteredText = GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox:GetText()
	else
		if GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu.Buttons == nil then
			GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu.Buttons = GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu.Buttons or {}
		elseif GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu.Buttons ~= nil then
			for i = 1, #GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu.Buttons do
				local ClearText = GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu.Buttons[count2][1]
				ClearText:SetText()
				count2 = count2 + 1
			end
		end
		enteredText = GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox:GetText()
	end
	
	if enteredText ~= "" then
		
		for i = 1, #playerNames do
			
			local text = string.sub(playerNames[i], 1, string.find(playerNames[i], '%.') - 1)
			
			if string.lower(enteredText) == string.lower(string.sub(text, 1, #enteredText)) then
				table.insert(enteredTable, text)
			end
		end
		
		if #enteredTable == 0 then
			for i = 1, #playerNames do
				
				local text = string.sub(playerNames[i], 1, string.find(playerNames[i], '%.') - 1)
				
				if string.find(string.lower(text), string.lower(enteredText)) ~= nil then
					table.insert(enteredTable, text)
				end
			end
		end
		
		if state == "Lottery" then
			for i = 1, #GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu.Buttons do
				GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu.Buttons[i][1]:Hide()
			end
		else
			for i = 1, #GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu.Buttons do
				GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu.Buttons[i][1]:Hide()
			end
		end
		
		for t, v in pairs(enteredTable) do
			
			local isClassFound = false
			local PlayerNamesButton
			local PlayerNamesText
			
			if state == "Lottery" then
				if not GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu.Buttons[t] then
					local tempButton = CreateFrame("Button", "name" .. count, GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu)
					GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("nameText" .. count, "OVERLAY", "GameFontWhiteTiny") }
				end
				PlayerNamesButton = GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu.Buttons[count][1]
				PlayerNamesText = GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu.Buttons[count][2]
			else
				if not GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu.Buttons[t] then
					local tempButton = CreateFrame("Button", "name" .. count, GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu)
					GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("nameText" .. count, "OVERLAY", "GameFontWhiteTiny") }
				end
				PlayerNamesButton = GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu.Buttons[count][1]
				PlayerNamesText = GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu.Buttons[count][2]
			end
			
			PlayerNamesText:SetText(v)
			PlayerNamesText:SetPoint("CENTER", PlayerNamesButton)
			PlayerNamesText:SetFont(GLR_Core.ButtonFont, 12)
			PlayerNamesText:SetWordWrap(false)
			
			local sWidth = PlayerNamesText:GetWidth()
			
			PlayerNamesButton:SetWidth(sWidth)
			PlayerNamesButton:SetHeight(11)
			PlayerNamesButton:SetHighlightTexture("Interface\\Buttons\\UI-Silver-Button-Select")
			
			for i = 1, #classTable do
				
				local text = classTable[i]
				local subText = string.sub(text, 1, string.find(text, '%[') - 1)
				local CN = string.sub(text, string.find(text, '%[') + 1, string.find(text, '%]') - 1)
				
				if subText == v then
					if ClassColor[CN] ~= nil then
						PlayerNamesText:SetTextColor(ClassColor[CN][1], ClassColor[CN][2], ClassColor[CN][3], 1)
					end
					isClassFound = true
				end
				
				if isClassFound then
					break
				end
			end
			
			local sHeight = floor(PlayerNamesText:GetStringHeight()) + 1
			pHeight = sHeight + floor(PlayerNamesText:GetStringHeight()) + 1
			
			if count == 1 then
				if state == "Lottery" then
					PlayerNamesButton:SetPoint("TOP", GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu, "TOP", 0, -5)
				else
					PlayerNamesButton:SetPoint("TOP", GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu, "TOP", 0, -5)
				end
				scrollHeight = scrollHeight + sHeight
			else
				if state == "Lottery" then
					PlayerNamesButton:SetPoint("TOP", GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
				else
					PlayerNamesButton:SetPoint("TOP", GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
				end
				scrollHeight = scrollHeight + sHeight
			end
			
			if (sWidth + 20) > scrollWidth and (sWidth + 20) >= 115 then
				scrollWidth = sWidth + 30
			end
			
			if state == "Lottery" then
				PlayerNamesButton:SetScript("OnClick", function(self, button)
					if button == "LeftButton" then
						GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu:Hide()
						GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox:SetText(PlayerNamesText:GetText())
						GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox:SetCursorPosition(0)
						GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox:ClearFocus()
						for i = 1, #classTable do
							
							local isClassFound = false
							local text = classTable[i]
							local subText = string.sub(text, 1, string.find(text, '%[') - 1)
							local CN = string.sub(text, string.find(text, '%[') + 1, string.find(text, '%]') - 1)
							
							if subText == GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox:GetText() then
								if ClassColor[CN] ~= nil then
									GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox:SetTextColor(ClassColor[CN][1], ClassColor[CN][2], ClassColor[CN][3], 1)
								end
								isClassFound = true
							end
							
							if isClassFound then
								break
							end
						end
						GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerTicketsToLotteryEditBox:SetFocus()
					end
				end)
			else
				PlayerNamesButton:SetScript("OnClick", function(self, button)
					if button == "LeftButton" then
						GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu:Hide()
						GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox:SetText(PlayerNamesText:GetText())
						GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox:SetCursorPosition(0)
						GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox:ClearFocus()
						for i = 1, #classTable do
							
							local isClassFound = false
							local text = classTable[i]
							local subText = string.sub(text, 1, string.find(text, '%[') - 1)
							local CN = string.sub(text, string.find(text, '%[') + 1, string.find(text, '%]') - 1)
							
							if subText == GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox:GetText() then
								if ClassColor[CN] ~= nil then
									GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox:SetTextColor(ClassColor[CN][1], ClassColor[CN][2], ClassColor[CN][3], 1)
								end
								isClassFound = true
							end
							
							if isClassFound then
								break
							end
						end
						GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerTicketsToRaffleEditBox:SetFocus()
					end
				end)
			end
			
			PlayerNamesButton:Show()
			
			count = count + 1
			n = n + 1
			
		end
		
		scrollHeight = scrollHeight * 1.1
		
		if n > 0 then
			if state == "Lottery" then
				GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu:SetSize(scrollWidth, scrollHeight)
				GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu:Show()
				GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_ExceededParameters:SetText("")
			else
				GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu:SetSize(scrollWidth, scrollHeight)
				GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu:Show()
				GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_ExceededParameters:SetText("")
			end
		elseif n == 0 then
			if state == "Lottery" then
				GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_ExceededParameters:SetText(L["No Player Found"])
				GLR_UI.GLR_AddPlayerToLotteryFrame.GLR_AddPlayerNameToLotteryEditBox.GLR_AddPlayerNameToLotterySelectionMenu:Hide()
			else
				GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_ExceededParameters:SetText(L["No Player Found"])
				GLR_UI.GLR_AddPlayerToRaffleFrame.GLR_AddPlayerNameToRaffleEditBox.GLR_AddPlayerNameToRaffleSelectionMenu:Hide()
			end
		end
	end
end

function GLR:SelectPlayerNameToEdit(arg)
	
	local playerNames = GenerateRosterNames()
	local enteredText
	local enteredTable = {}
	local classTable = {}
	local status = glrCharacter.Data.Settings.MultiGuild
	if not status then
		classTable = glrRoster
	else
		classTable = glrMultiGuildRoster
	end
	local buffer = 3
	local count = 1
	local count2 = 1
	local n = 0
	local scrollHeight = 0
	local scrollWidth = 125
	local enteredOnce = false
	local state = arg
	
	if state == "Lottery" then
		if GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu.Buttons == nil then
			GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu.Buttons = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu.Buttons or {}
		elseif GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu.Buttons ~= nil then
			for i = 1, #GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu.Buttons do
				local ClearText = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu.Buttons[count2][1]
				ClearText:SetText()
				count2 = count2 + 1
			end
		end
		enteredText = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox:GetText()
	else
		if GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu.Buttons == nil then
			GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu.Buttons = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu.Buttons or {}
		elseif GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu.Buttons ~= nil then
			for i = 1, #GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu.Buttons do
				local ClearText = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu.Buttons[count2][1]
				ClearText:SetText()
				count2 = count2 + 1
			end
		end
		enteredText = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox:GetText()
	end
	
	if enteredText ~= "" then
		
		for i = 1, #playerNames do
			
			local text = string.sub(playerNames[i], 1, string.find(playerNames[i], '%.') - 1)
			
			if string.lower(enteredText) == string.lower(string.sub(playerNames[i], 1, #enteredText)) then
				table.insert(enteredTable, text)
			end
		end
		
		if #enteredTable == 0 then
			for i = 1, #playerNames do
				
				local text = string.sub(playerNames[i], 1, string.find(playerNames[i], '%.') - 1)
				
				if string.find(string.lower(playerNames[i]), string.lower(enteredText)) ~= nil then
					table.insert(enteredTable, text)
				end
			end
		end
		
		if state == "Lottery" then
			for i = 1, #GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu.Buttons do
				GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu.Buttons[i][1]:Hide()
			end
		else
			for i = 1, #GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu.Buttons do
				GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu.Buttons[i][1]:Hide()
			end
		end
		
		for t, v in pairs(enteredTable) do
			
			local isClassFound = false
			local PlayerNamesButton
			local PlayerNamesText
			
			if state == "Lottery" then
				if not GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu.Buttons[t] then
					local tempButton = CreateFrame("Button", "name" .. count, GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu)
					GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("nameText" .. count, "OVERLAY", "GameFontWhiteTiny") }
				end
				PlayerNamesButton = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu.Buttons[count][1]
				PlayerNamesText = GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu.Buttons[count][2]
			else
				if not GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu.Buttons[t] then
					local tempButton = CreateFrame("Button", "name" .. count, GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu)
					GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu.Buttons[t] = { tempButton, tempButton:CreateFontString("nameText" .. count, "OVERLAY", "GameFontWhiteTiny") }
				end
				PlayerNamesButton = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu.Buttons[count][1]
				PlayerNamesText = GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu.Buttons[count][2]
			end
			
			PlayerNamesText:SetText(v)
			PlayerNamesText:SetPoint("CENTER", PlayerNamesButton)
			PlayerNamesText:SetFont(GLR_Core.ButtonFont, 12)
			PlayerNamesText:SetWordWrap(false)
			
			local sWidth = PlayerNamesText:GetWidth()
			
			PlayerNamesButton:SetWidth(sWidth)
			PlayerNamesButton:SetHeight(11)
			PlayerNamesButton:SetHighlightTexture("Interface\\Buttons\\UI-Silver-Button-Select")
			
			for i = 1, #classTable do
				
				local text = classTable[i]
				local subText = string.sub(text, 1, string.find(text, '%[') - 1)
				local CN = string.sub(text, string.find(text, '%[') + 1, string.find(text, '%]') - 1)
				
				if subText == v then
					PlayerNamesText:SetTextColor(ClassColor[CN][1], ClassColor[CN][2], ClassColor[CN][3], 1)
					isClassFound = true
				end
				
				if isClassFound then
					break
				end
			end
			
			local sHeight = ( PlayerNamesText:GetStringHeight() * 1.1 ) + 1.8
			
			if count == 1 then
				if state == "Lottery" then
					PlayerNamesButton:SetPoint("TOP", GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu, "TOP", 0, -4)
				else
					PlayerNamesButton:SetPoint("TOP", GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu, "TOP", 0, -4)
				end
				scrollHeight = scrollHeight + sHeight + 2
			else
				if state == "Lottery" then
					PlayerNamesButton:SetPoint("TOP", GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
				else
					PlayerNamesButton:SetPoint("TOP", GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu.Buttons[count - 1][1], "BOTTOM", 0, -buffer)
				end
				scrollHeight = scrollHeight + sHeight
			end
			
			if sWidth > scrollWidth and sWidth >= 125 then
				scrollWidth = sWidth + 20
			end
			
			if state == "Lottery" then
				PlayerNamesButton:SetScript("OnClick", function(self, button)
					if button == "LeftButton" then
						GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu:Hide()
						GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox:SetText(PlayerNamesText:GetText())
						GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox:SetCursorPosition(0)
						for i = 1, #classTable do
							
							local isClassFound = false
							local text = classTable[i]
							local subText = string.sub(text, 1, string.find(text, '%[') - 1)
							local CN = string.sub(text, string.find(text, '%[') + 1, string.find(text, '%]') - 1)
							
							if subText == GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox:GetText() then
								if ClassColor[CN] ~= nil then
									GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox:SetTextColor(ClassColor[CN][1], ClassColor[CN][2], ClassColor[CN][3], 1)
								end
								isClassFound = true
							end
							
							if isClassFound then
								break
							end
						end
						GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox:ClearFocus()
					end
				end)
			else
				PlayerNamesButton:SetScript("OnClick", function(self, button)
					if button == "LeftButton" then
						GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu:Hide()
						GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox:SetText(PlayerNamesText:GetText())
						GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox:SetCursorPosition(0)
						for i = 1, #classTable do
							
							local isClassFound = false
							local text = classTable[i]
							local subText = string.sub(text, 1, string.find(text, '%[') - 1)
							local CN = string.sub(text, string.find(text, '%[') + 1, string.find(text, '%]') - 1)
							
							if subText == GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox:GetText() then
								if ClassColor[CN] ~= nil then
									GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox:SetTextColor(ClassColor[CN][1], ClassColor[CN][2], ClassColor[CN][3], 1)
								end
								isClassFound = true
							end
							
							if isClassFound then
								break
							end
						end
						GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox:ClearFocus()
					end
				end)
			end
			
			PlayerNamesButton:Show()
			
			count = count + 1
			n = n + 1
			
		end
		
		if n > 0 then
			if state == "Lottery" then
				GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu:SetSize(scrollWidth, scrollHeight)
				GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu:Show()
				GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_ExceededLotteryTickets:SetText("")
			else
				GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu:SetSize(scrollWidth, scrollHeight)
				GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu:Show()
				GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_ExceededRaffleTickets:SetText("")
			end
		elseif n == 0 then
			if state == "Lottery" then
				GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_ExceededLotteryTickets:SetText(L["No Player Found"])
				GLR_UI.GLR_EditPlayerInLotteryFrame.GLR_SelectedPlayerEditBox.GLR_EditPlayerNameInLotterySelectionMenu:Hide()
			else
				GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_ExceededRaffleTickets:SetText(L["No Player Found"])
				GLR_UI.GLR_EditPlayerInRaffleFrame.GLR_SelectedRafflePlayerEditBox.GLR_EditPlayerNameInRaffleSelectionMenu:Hide()
			end
		end
	end
end

---------------------------------------------
------------- ADDON ACTIVATION --------------
---------------------------------------------
----- RUNS WHEN THE MOD IS FULLY LOADED -----
---------------------------------------------

GLR.Activation = function(_, event, addon)
	
	if event == "ADDON_LOADED" and addon == "GuildLotteryRaffle" and not isAddOnLoaded then
		
		GLR:RegisterEvent("CHAT_MSG_WHISPER")
		GLR:RegisterEvent("CHAT_MSG_GUILD")
		GLR:RegisterEvent("PLAYER_LOGOUT")
		GLR:RegisterEvent("PLAYER_LOGIN")
		C_ChatInfo.RegisterAddonMessagePrefix("GLR_LOGIN")
		C_ChatInfo.RegisterAddonMessagePrefix("GLR_CHECK")
		C_ChatInfo.RegisterAddonMessagePrefix("GLR_HASMOD")
		C_ChatInfo.RegisterAddonMessagePrefix("GLR_LOGOUT")
		C_ChatInfo.RegisterAddonMessagePrefix("GLR_DEBUG")
		hooksecurefunc("ChatEdit_InsertLink", GLR_ChatEdit_InsertLink)
		
		if glrHistory == nil then
			glrHistory = {}
		end
		if glrHistory.TransferData == nil then
			glrHistory.TransferData = {}
		end
		if glrHistory.TransferData[FullPlayerName] == nil then
			glrHistory.TransferData[FullPlayerName] = {}
		else
			local continue = true
			for t, v in pairs(glrHistory.TransferData) do
				if t == FullPlayerName then
					continue = false
					break
				end
			end
			if continue then
				glrHistory.TransferData[FullPlayerName] = {}
			end
		end
		if glrHistory.TransferStatus == nil then
			glrHistory.TransferStatus = {}
			glrHistory.TransferStatus.Lottery = {}
			glrHistory.TransferStatus.Raffle = {}
		end
		if glrHistory.TransferStatus.Lottery[FullPlayerName] == nil then
			glrHistory.TransferStatus.Lottery[FullPlayerName] = false
		elseif glrHistory.TransferStatus.Lottery[FullPlayerName] then
			
		end
		if glrHistory.TransferStatus.Raffle[FullPlayerName] == nil then
			glrHistory.TransferStatus.Raffle[FullPlayerName] = false
		elseif glrHistory.TransferStatus.Raffle[FullPlayerName] then
			
		end
		if glrHistory.TransferAvailable == nil then
			glrHistory.TransferAvailable = {}
			glrHistory.TransferAvailable.Lottery = {}
			glrHistory.TransferAvailable.Raffle = {}
		end
		if glrHistory.TransferAvailable.Lottery[FullPlayerName] == nil then
			glrHistory.TransferAvailable.Lottery[FullPlayerName] = false
		end
		if glrHistory.TransferAvailable.Raffle[FullPlayerName] == nil then
			glrHistory.TransferAvailable.Raffle[FullPlayerName] = false
		end
		if glrCharacter == nil then
			glrCharacter = {}
		end
		if glrCharacter.Data == nil then
			glrCharacter.Data = {}
		end
		if glrHistory.Version == nil then
			glrHistory.Version = GLR_Version
		elseif glrHistory.Version ~= nil and GLR_Version ~= nil then
			if glrHistory.Version ~= GLR_Version then
				glrHistory.Version = GLR_Version
				NewUpdate()
			end
		end
		if glrHistory.Updated == nil then
			glrHistory.Updated = time()
		else
			glrHistory.Updated = time()
		end
		if glrCharacter.Updated == nil then
			glrCharacter.Updated = time()
		else
			glrCharacter.Updated = time()
		end
		if glrCharacter.Data.Version == nil and GLR_Version ~= nil then
			glrCharacter.Data.Version = GLR_Version
		elseif glrCharacter.Data.Version ~= nil and GLR_Version ~= nil then
			if glrCharacter.Data.Version ~= GLR_Version then
				glrCharacter.Data.Version = GLR_Version
			end
		end
		if glrCharacter.Data.Raffle == nil then
			glrCharacter.Data.Raffle = {}
		end
		if glrCharacter.Data.Raffle.FirstPrizeData == nil then
			glrCharacter.Data.Raffle.FirstPrizeData = {}
		end
		if glrCharacter.Data.Raffle.SecondPrizeData == nil then
			glrCharacter.Data.Raffle.SecondPrizeData = {}
		end
		if glrCharacter.Data.Raffle.ThirdPrizeData == nil then
			glrCharacter.Data.Raffle.ThirdPrizeData = {}
		end
		if glrCharacter.Data.Raffle.FirstPrizeData.ItemName == nil then
			glrCharacter.Data.Raffle.FirstPrizeData.ItemName = {}
		end
		if glrCharacter.Data.Raffle.SecondPrizeData.ItemName == nil then
			glrCharacter.Data.Raffle.SecondPrizeData.ItemName = {}
		end
		if glrCharacter.Data.Raffle.ThirdPrizeData.ItemName == nil then
			glrCharacter.Data.Raffle.ThirdPrizeData.ItemName = {}
		end
		if glrCharacter.Data.Raffle.FirstPrizeData.ItemLink == nil then
			glrCharacter.Data.Raffle.FirstPrizeData.ItemLink = {}
		end
		if glrCharacter.Data.Raffle.SecondPrizeData.ItemLink == nil then
			glrCharacter.Data.Raffle.SecondPrizeData.ItemLink = {}
		end
		if glrCharacter.Data.Raffle.ThirdPrizeData.ItemLink == nil then
			glrCharacter.Data.Raffle.ThirdPrizeData.ItemLink = {}
		end
		if glrCharacter.Data.Defaults == nil then
			glrCharacter.Data.Defaults = {}
		end
		if glrCharacter.Data.Defaults.GuildCut == nil then
			glrCharacter.Data.Defaults.GuildCut = "0"
		end
		if glrCharacter.Data.Defaults.SecondCut == nil then
			glrCharacter.Data.Defaults.SecondCut = "0"
		end
		if glrCharacter.Data.Defaults.LotteryMaxTickets == nil then
			glrCharacter.Data.Defaults.LotteryMaxTickets = "0"
		end
		if glrCharacter.Data.Defaults.LotteryMaxTickets == nil then
			glrCharacter.Data.Defaults.LotteryMaxTickets = "0"
		end
		if glrCharacter.Data.Defaults.RaffleMaxTickets == nil then
			glrCharacter.Data.Defaults.RaffleMaxTickets = "0"
		end
		if glrCharacter.Data.Defaults.StartingGold == nil then
			glrCharacter.Data.Defaults.StartingGold = "0"
		end
		if glrCharacter.Data.Defaults.LotteryDate == nil then
			glrCharacter.Data.Defaults.LotteryDate = ""
		end
		if glrCharacter.Data.Defaults.TicketPrice == nil then
			glrCharacter.Data.Defaults.TicketPrice = "0"
		end
		if glrCharacter.Data.Defaults.LotteryJackpot == nil then
			glrCharacter.Data.Defaults.LotteryJackpot = "0"
		end
		if glrCharacter.Data.Defaults.LotteryName == nil then
			glrCharacter.Data.Defaults.LotteryName = "No Lottery Active"
		end
		if glrCharacter.Data.Defaults.RaffleName == nil then
			glrCharacter.Data.Defaults.RaffleName = "No Raffle Active"
		end
		if glrCharacter.Data.Settings == nil then
			glrCharacter.Data.Settings = {}
		end
		if glrCharacter.Data.Settings.enabled == nil then
			glrCharacter.Data.Settings.enabled = true
		end
		if glrCharacter.Data.Settings.mini_map == nil then
			glrCharacter.Data.Settings.mini_map = true
		end
		if glrCharacter.Data.Settings.invalid_item == nil then
			glrCharacter.Data.Settings.invalid_item = false
		end
		if glrCharacter.Data.Settings.MinimapXOffset == nil then
			glrCharacter.Data.Settings.MinimapXOffset = -75
		end
		if glrCharacter.Data.Settings.MinimapYOffset == nil then
			glrCharacter.Data.Settings.MinimapYOffset = -50
		end
		if glrCharacter.Data.Settings.TimeBetweenAlerts == nil then
			glrCharacter.Data.Settings.TimeBetweenAlerts = 60
		end
		if glrCharacter.Data.Settings.CurrentlyActiveLottery == nil then
			glrCharacter.Data.Settings.CurrentlyActiveLottery = false
		end
		if glrCharacter.Data.Settings.CurrentlyActiveRaffle == nil then
			glrCharacter.Data.Settings.CurrentlyActiveRaffle = false
		end
		if glrCharacter.Data.Settings.TicketSeries == nil then
			glrCharacter.Data.Settings.TicketSeries = 1000
		end
		if glrCharacter.Data.Settings.RaffleSeries == nil then
			glrCharacter.Data.Settings.RaffleSeries = 1000
		end
		if glrCharacter.Data.Settings.ToggleEscape == nil then
			glrCharacter.Data.Settings.ToggleEscape = true
		end
		if glrCharacter.Data.Settings.ToggleChatInfo == nil then
			glrCharacter.Data.Settings.ToggleChatInfo = false
		end
		if glrCharacter.Data.Settings.SendLargeInfo == nil then
			glrCharacter.Data.Settings.SendLargeInfo = false
		end
		if glrCharacter.Data.Settings.Status == nil then
			glrCharacter.Data.Settings.Status = "Lottery"
		end
		if glrCharacter.Data.Settings.LastAlert == nil then
			glrCharacter.Data.Settings.LastAlert = 0
		end
		if glrCharacter.Data.Settings.UserName == nil then
			glrCharacter.Data.Settings.UserName = ""
		end
		if glrCharacter.Data.Settings.GuildName == nil then
			glrCharacter.Data.Settings.GuildName = ""
		end
		if glrCharacter.Data.Settings.MultiGuild == nil then
			glrCharacter.Data.Settings.MultiGuild = false
		end
		if glrCharacter.Data.Settings.CrossFactionEvents == nil then
			glrCharacter.Data.Settings.CrossFactionEvents = false
		end
		if glrCharacter.Data.Settings.AllowMultipleRaffleWinners == nil then
			glrCharacter.Data.Settings.AllowMultipleRaffleWinners = false
		end
		if glrCharacter.Data.Settings.CreateCalendarEvents == nil then
			glrCharacter.Data.Settings.CreateCalendarEvents = false
		end
		if glrCharacter.Data.Settings.RaffleMultiGuild ~= nil then
			glrCharacter.Data.Settings.RaffleMultiGuild = nil
		end
		if glrCharacter.Data.Settings.DisableLoginMessages == nil then
			glrCharacter.Data.Settings.DisableLoginMessages = false
		end
		if glrCharacter.Data.Settings.AdvancedTicketDraw == nil then
			glrCharacter.Data.Settings.AdvancedTicketDraw = false
		end
		if glrCharacter.Data.Settings.PreviousLottery == nil then
			glrCharacter.Data.Settings.PreviousLottery = {}
		end
		if glrCharacter.Data.Settings.PreviousLottery.Jackpot == nil then
			glrCharacter.Data.Settings.PreviousLottery.Jackpot = 0
		end
		if glrCharacter.Data.Settings.PreviousLottery.TicketsSold == nil then
			glrCharacter.Data.Settings.PreviousLottery.TicketsSold = 0
		end
		if glrCharacter.Data.Settings.PreviousLottery.TicketsSold == nil then
			glrCharacter.Data.Settings.PreviousLottery.TicketsSold = 0
		end
		if glrCharacter.Data.Settings.PreviousLottery.TicketPrice == nil then
			glrCharacter.Data.Settings.PreviousLottery.TicketPrice = 0
		end
		if glrCharacter.Data.Settings.InverseAnnounce == nil then
			glrCharacter.Data.Settings.InverseAnnounce = false
		end
		if glrCharacter.Data.Settings.RoundJackpot == nil then
			glrCharacter.Data.Settings.RoundJackpot = false
		end
		if glrCharacter.Data.Settings.Profile == nil then
			glrCharacter.Data.Settings.Profile = {}
		end
		if glrCharacter.Data.Settings.NoGuildCut == nil then
			glrCharacter.Data.Settings.NoGuildCut = false
		end
		if glrCharacter.Data.Settings.Profile.Lottery == nil then
			glrCharacter.Data.Settings.Profile.Lottery = { ["StartingGold"] = "0", ["MaxTickets"] = "0", ["TicketPrice"] = "0", ["SecondPlace"] = "0", ["GuildCut"] = "0", ["Guaranteed"] = false }
		end
		if glrCharacter.Data.Settings.Profile.Raffle == nil then
			glrCharacter.Data.Settings.Profile.Raffle = { ["MaxTickets"] = "0", ["TicketPrice"] = "0", ["InvalidItems"] = false }
		end
		if glrCharacter.Data.Messages == nil then
			glrCharacter.Data.Messages = {}
		end
		if glrCharacter.Data.Messages.GuildAlerts == nil then
			glrCharacter.Data.Messages.GuildAlerts = {}
		end
		if glrCharacter.Data.Messages.GuildAlerts.Lottery == nil then
			glrCharacter.Data.Messages.GuildAlerts.Lottery = {}
			glrCharacter.Data.Messages.GuildAlerts.Lottery = { [1] = L["GLR Title with Version"] .. "%version", [2] = L["Alert Guild Lottery Scheduled"] .. ": %lottery_date", [3] = L["Lottery"] .. " " .. L["Alert Guild Event Name"] .. ": %lottery_name", [4] = L["Alert Guild Ticket Info Part 1"] .. " %lottery_price " .. L["Alert Guild Ticket Info Part 2"], [5] = L["Alert Guild Ticket Info Part 3"] .. " %lottery_max " .. L["Alert Guild Ticket Info Part 4"], [6] = L["Alert Guild Tickets Bought"] .. ": %lottery_gold", [7] = L["Alert Guild Whisper For Lottery Info"], [8] = false }
		else
			if string.find(glrCharacter.Data.Messages.GuildAlerts.Lottery[1], L["GLR Title with Version"]) then
				local text = string.sub(glrCharacter.Data.Messages.GuildAlerts.Lottery[1], string.find(glrCharacter.Data.Messages.GuildAlerts.Lottery[1], 'v') + 1)
				if string.find(text, "3.0.6") then
					glrCharacter.Data.Messages.GuildAlerts.Lottery[1] = L["GLR Title with Version"] .. "%version"
				end
				if string.find(text, "3.0.61") then
					glrCharacter.Data.Messages.GuildAlerts.Lottery[1] = L["GLR Title with Version"] .. "%version"
				end
			end
		end
		if glrCharacter.Data.Messages.GuildAlerts.Raffle == nil then
			glrCharacter.Data.Messages.GuildAlerts.Raffle = {}
			glrCharacter.Data.Messages.GuildAlerts.Raffle = { [1] = L["GLR Title with Version"] .. "%version", [2] = L["Alert Guild Raffle Scheduled"] .. ": %raffle_date", [3] = L["Raffle"] .. " " .. L["Alert Guild Event Name"] .. ": %raffle_name", [4] = L["Alert Guild Ticket Info Part 1"] .. " %raffle_price " .. L["Alert Guild Ticket Info Part 2"], [5] = L["Alert Guild Ticket Info Part 3"]  .. " %raffle_max " .. L["Alert Guild Ticket Info Part 4"], [6] = "%raffle_gold " .. L["Alert Guild Raffle Tickets Bought"], [7] = L["Raffle Draw Step 1"] .. ": %raffle_prizes", [8] = L["Alert Guild Whisper For Raffle Info"], [9] = false }
		else
			if string.find(glrCharacter.Data.Messages.GuildAlerts.Raffle[1], L["GLR Title with Version"]) then
				local text = string.sub(glrCharacter.Data.Messages.GuildAlerts.Raffle[1], string.find(glrCharacter.Data.Messages.GuildAlerts.Raffle[1], 'v') + 1)
				if string.find(text, "3.0.6") then
					glrCharacter.Data.Messages.GuildAlerts.Raffle[1] = L["GLR Title with Version"] .. "%version"
				end
				if string.find(text, "3.0.61") then
					glrCharacter.Data.Messages.GuildAlerts.Raffle[1] = L["GLR Title with Version"] .. "%version"
				end
			end
			if glrCharacter.Data.Messages.GuildAlerts.Raffle[8] == false then
				glrCharacter.Data.Messages.GuildAlerts.Raffle[7] = L["Raffle Draw Step 1"] .. ": %raffle_prizes"
				glrCharacter.Data.Messages.GuildAlerts.Raffle[8] = L["Alert Guild Whisper For Raffle Info"]
				glrCharacter.Data.Messages.GuildAlerts.Raffle[9] = false
			end
		end
		if glrCharacter.Data.Messages.GuildAlerts.Both == nil then
			glrCharacter.Data.Messages.GuildAlerts.Both = {}
			glrCharacter.Data.Messages.GuildAlerts.Both = { [1] = L["GLR Title with Version"] .. "%version", [2] = L["Alert Guild LaR Scheduled"] .. ":", [3] = L["Lottery"] .. ": %lottery_date, " .. L["Raffle"] .. ": %raffle_date", [4] = L["Lottery"] .. " " .. L["Alert Guild Event Name"] .. ": %lottery_name, " .. L["Raffle"] .. " " .. L["Alert Guild Event Name"] .. ": %raffle_name.", [5] = L["Lottery"] .. ": " .. L["Alert Guild Ticket Info Part 1"] .. " %lottery_price " .. L["Alert Guild Ticket Info Part 2"], [6] = L["Lottery"] .. ": " .. L["Alert Guild Ticket Info Part 3"] .. " %lottery_max " .. L["Alert Guild Ticket Info Part 4"], [7] = L["Lottery"] .. ": " .. L["Alert Guild Tickets Bought"] .. " %lottery_gold", [8] = L["Raffle"] .. ": " .. L["Alert Guild Ticket Info Part 1"] .. " %raffle_price " .. L["Alert Guild Ticket Info Part 2"], [9] = L["Raffle"] .. ": " .. L["Alert Guild Ticket Info Part 3"] .. " %raffle_max " .. L["Alert Guild Ticket Info Part 4"], [10] = L["Raffle"] .. ": %raffle_gold " .. L["Alert Guild Raffle Tickets Bought"], [11] = L["Alert Guild Whisper For LaR Info"], [12] = false }
		else
			if string.find(glrCharacter.Data.Messages.GuildAlerts.Both[1], L["GLR Title with Version"]) then
				local text = string.sub(glrCharacter.Data.Messages.GuildAlerts.Both[1], string.find(glrCharacter.Data.Messages.GuildAlerts.Both[1], 'v') + 1)
				if string.find(text, "3.0.6") then
					glrCharacter.Data.Messages.GuildAlerts.Both[1] = L["GLR Title with Version"] .. "%version"
				end
				if string.find(text, "3.0.61") then
					glrCharacter.Data.Messages.GuildAlerts.Both[1] = L["GLR Title with Version"] .. "%version"
				end
			end
		end
		if glrCharacter.Data.OtherStatus == nil then
			glrCharacter.Data.OtherStatus = {}
		end
		if glrCharacter.Data.OtherStatus.Lottery == nil then
			glrCharacter.Data.OtherStatus.Lottery = {}
		end
		if glrCharacter.Data.OtherStatus.Raffle == nil then
			glrCharacter.Data.OtherStatus.Raffle = {}
		end
		if glrCharacter.Lottery == nil then
			glrCharacter.Lottery = {}
		end
		if glrCharacter.Raffle == nil then
			glrCharacter.Raffle = {}
		end
		if glrCharacter.Event == nil then
			glrCharacter.Event = {}
		end
		if glrCharacter.Event.Lottery == nil then
			glrCharacter.Event.Lottery = {}
		end
		if glrCharacter.Event.Raffle == nil then
			glrCharacter.Event.Raffle = {}
		end
		if glrCharacter.Lottery.TicketPool == nil then
			glrCharacter.Lottery.TicketPool = {}
		end
		if glrCharacter.Raffle.TicketPool == nil then
			glrCharacter.Raffle.TicketPool = {}
		end
		if glrCharacter.Lottery.MessageStatus == nil then
			glrCharacter.Lottery.MessageStatus = {}
		end
		if glrCharacter.Raffle.MessageStatus == nil then
			glrCharacter.Raffle.MessageStatus = {}
		end
		if glrCharacter.Lottery.Entries == nil then
			glrCharacter.Lottery.Entries = {}
		end
		if glrCharacter.Lottery.Entries.TicketNumbers == nil then
			glrCharacter.Lottery.Entries.TicketNumbers = {}
		end
		if glrCharacter.Lottery.Entries.TicketRange == nil then
			glrCharacter.Lottery.Entries.TicketRange = {}
		end
		if glrCharacter.Lottery.Entries.Tickets == nil then
			glrCharacter.Lottery.Entries.Tickets = {}
		end
		if glrCharacter.Lottery.Entries.Names == nil then
			glrCharacter.Lottery.Entries.Names = {}
		end
		if glrCharacter.Raffle.Entries == nil then
			glrCharacter.Raffle.Entries = {}
		end
		if glrCharacter.Raffle.Entries.TicketNumbers == nil then
			glrCharacter.Raffle.Entries.TicketNumbers = {}
		end
		if glrCharacter.Raffle.Entries.TicketRange == nil then
			glrCharacter.Raffle.Entries.TicketRange = {}
		end
		if glrCharacter.Raffle.Entries.Tickets == nil then
			glrCharacter.Raffle.Entries.Tickets = {}
		end
		if glrCharacter.Raffle.Entries.Names == nil then
			glrCharacter.Raffle.Entries.Names = {}
		end
		if glrCharacter.PreviousEvent == nil then
			glrCharacter.PreviousEvent = {}
		end
		if glrCharacter.PreviousEvent.Lottery == nil then
			glrCharacter.PreviousEvent.Lottery = {}
		end
		if glrCharacter.PreviousEvent.Lottery.Available == nil then
			glrCharacter.PreviousEvent.Lottery.Available = false
		end
		if glrCharacter.PreviousEvent.Lottery.Data == nil then
			glrCharacter.PreviousEvent.Lottery.Data = {}
		end
		if glrCharacter.PreviousEvent.Lottery.Settings == nil then
			glrCharacter.PreviousEvent.Lottery.Settings = {}
		end
		if glrCharacter.PreviousEvent.Raffle == nil then
			glrCharacter.PreviousEvent.Raffle = {}
		end
		if glrCharacter.PreviousEvent.Raffle.Available == nil then
			glrCharacter.PreviousEvent.Raffle.Available = false
		end
		if glrCharacter.PreviousEvent.Raffle.Data == nil then
			glrCharacter.PreviousEvent.Raffle.Data = {}
		end
		if glrCharacter.PreviousEvent.Raffle.Settings == nil then
			glrCharacter.PreviousEvent.Raffle.Settings = {}
		end
		if glrCharacter.PreviousEvent.Lottery.Settings.WonType == nil then
			glrCharacter.PreviousEvent.Lottery.Settings.WonType = true
		end
		if glrCharacter.PreviousEvent.Lottery.Settings.RoundJackpot == nil then
			glrCharacter.PreviousEvent.Lottery.Settings.RoundJackpot = false
		end
		if glrCharacter.PreviousEvent.Lottery.Settings.NoGuildCut == nil then
			glrCharacter.PreviousEvent.Lottery.Settings.NoGuildCut = false
		end
		if glrEvents ~= nil or glrRaffleData ~= nil or glrProfile ~= nil or glrLotteryEntries ~= nil or glrRaffleEntries ~= nil or glrTicketPool ~= nil or glrMessageStatus ~= nil then
			GLR_TransferTables()
		end
		
		GLR_U:UpdateMinimapIcon()
		GLR_U:ToggleEscapeKey()
		
		local message = string.gsub(L["GLR AddOn Loaded Msg"], "%%version", GLR_Version)
		glrChat:AddMessage("|cfff7ff4d" .. message .. ".|r")
		
		isAddOnLoaded = true
		
	end
	
end

Initalizeation:RegisterEvent("ADDON_LOADED")
Initalizeation:SetScript("OnEvent", GLR.Activation)

function GLR:RunDebug()
	local count = 0
	local multi = glrCharacter.Data.Settings.MultiGuild
	local numTotalMembers, _, _ = GetNumGuildMembers()
	local status = glrCharacter.Data.Settings.enabled
	if multi == nil then
		print("|cffffdf00Begin Guild Lottery & Raffle Debug Information...|r")
		print("Multi Status nil")
		print("|cffffdf00...End Debug Information|r")
		return
	end
	if status == nil then
		print("|cffffdf00Begin Guild Lottery & Raffle Debug Information...|r")
		print("AddOn Status nil")
		print("|cffffdf00...End Debug Information|r")
		return
	end
	if multi then
		for i = 1, #glrMultiGuildRoster do
			count = count + 1
		end
	else
		for i = 1, #glrRoster do
			count = count + 1
		end
	end
	print("|cffffdf00Begin Guild Lottery & Raffle Debug Information...|r")
	print("AddOn State: |cffffdf00" .. tostring(status) .. "|r")
	print("Player: |cffffdf00" .. PlayerName .. "|r Realm Name: |cffffdf00" .. PlayerRealmName .. "|r Full Name: |cffffdf00" .. FullPlayerName .. "|r")
	print("Potential Entries: (|cffffdf00" .. count .. "|r) Guild Total: (|cffffdf00" .. numTotalMembers .. "|r) MultiGuild Status: |cffffdf00" .. tostring(multi) .. "|r")
	print("Locale: (|cffffdf00" .. GetLocale() .. "|r) Lottery Phrase: |cffffdf00" .. L["Detect Lottery"] .. "|r Raffle Phrase: |cffffdf00" .. L["Detect Raffle"] .. "|r")
	print("AddOn Version: |cffff0000" .. GLR_Version .. "|r Version String: |cffff0000" .. GLR_VersionString .. "|r")
	print("|cffffdf00...End Debug Information|r")
end

function GLR:Success()
	GLR:Print("Success")
end

local function GLR_Round(num, Decimals)
	local mod = 10 ^ (Decimals or 0)
	return math.floor(num * mod + 0.5) / mod
end

local CursorPrinted = false
local function GetCursor()
	local infoType, info1, info2 = GetCursorInfo()
	
	if infoType ~= nil then
		if not CursorPrinted then
			if info1 ~= nil then
				print("Type: '" .. infoType .. "' Info: '" .. info1 .. "'")
				local itemName, itemLink = GetItemInfo(info1)
				if itemName ~= nil and itemLink ~= nil then
					print("Name: '" .. itemName .. "' Link: '" .. itemLink .. "'")
				else
					print("Info1 Nil")
				end
			end
			if info2 ~= nil then
				print("Type: '" .. infoType .. "' Info: '" .. info2 .. "'")
				local itemName, itemLink = GetItemInfo(info2)
				if itemName ~= nil and itemLink ~= nil then
					print("Name: '" .. itemName .. "' Link: '" .. itemLink .. "'")
				else
					print("Info2 Nil")
				end
			end
			if info1 == nil and info2 == nil then
				print("Both Infos Nil")
			end
			CursorPrinted = true
		end
	else
		if not CursorPrinted then
			C_Timer.After(1, GetCursor)
		end
	end
	
end

local low = 1
local high = 0
local MaxCount = 0
local BuildCount = 0
local RemoveCount = 0
local CheckContinue = true
local pause = false
GLR_Check = {}

local function CheckTicketNumbers()
	local ticket = 0
	pause = true
	for i = 1, #RandomizationTable.Tickets do
		for j = 1, #GLR_Check do
			if RandomizationTable.Tickets[i] == GLR_Check[j] then
				table.remove(GLR_Check, j)
				RemoveCount = RemoveCount + 1
				break
			end
		end
	end
	for i = 1, #GLR_Check do
		table.insert(RandomizationTable.Tickets, GLR_Check[1])
		table.remove(GLR_Check, 1)
		BuildCount = BuildCount + 1
	end
	for i = 1, RemoveCount do
		ticket = tostring(math.random(low, high))
		table.insert(GLR_Check, ticket)
	end
	if BuildCount == MaxCount then CheckContinue = false end
	C_Timer.After(1, function(self) pause = false end)
end

local function TestDebug()
	low = glrCharacter.Event.Lottery.FirstTicketNumber
	high = glrCharacter.Event.Lottery.LastTicketBought - 1
	local ticket = tostring(math.random(low, high))
	local continue = true
	MaxCount = 0
	BuildCount = 0
	RemoveCount = 0
	GLR_Check = {}
	RandomizationTable = { ["Names"] = {}, ["Numbers"] = {}, ["Totals"] = {}, ["Tickets"] = {}, }
	
	for i = 1, #glrCharacter.Lottery.Entries.Names do
		table.insert(RandomizationTable.Names, glrCharacter.Lottery.Entries.Names[i])
		RandomizationTable.Numbers[glrCharacter.Lottery.Entries.Names[i]] = {}
		RandomizationTable.Totals[glrCharacter.Lottery.Entries.Names[i]] = glrCharacter.Lottery.Entries.Tickets[glrCharacter.Lottery.Entries.Names[i]].NumberOfTickets
		MaxCount = MaxCount + RandomizationTable.Totals[glrCharacter.Lottery.Entries.Names[i]]
	end
	
	while true do
		table.insert(RandomizationTable.Tickets, ticket)
		ticket = tostring(math.random(low, high))
		BuildCount = BuildCount + 1
		if BuildCount == MaxCount then
			for i = 1, #RandomizationTable.Tickets do
				for j = 1, #RandomizationTable.Tickets do
					if RandomizationTable.Tickets[i] == RandomizationTable.Tickets[j] then
						table.remove(RandomizationTable.Tickets, j)
						RemoveCount = RemoveCount + 1
					end
				end
			end
			BuildCount = BuildCount - RemoveCount
			break
		end
	end
	
	for i = 1, RemoveCount do
		ticket = tostring(math.random(low, high))
		table.insert(GLR_Check, ticket)
	end
	
	while true do
		if not pause and CheckContinue then
			RemoveCount = 0
			CheckTicketNumbers()
		end
		if not CheckContinue then break end
	end
end

function GLR:DoDebug()
	
	print("Start")
	
	local continue = true
	local transfer = {}
	RandomizationTable = { ["Names"] = {}, ["Numbers"] = {}, ["Totals"] = {}, ["Tickets"] = {}, }
	
	for i = 1, #glrCharacter.Lottery.Entries.Names do
		table.insert(RandomizationTable.Names, glrCharacter.Lottery.Entries.Names[i])
		RandomizationTable.Numbers[glrCharacter.Lottery.Entries.Names[i]] = {}
		RandomizationTable.Totals[glrCharacter.Lottery.Entries.Names[i]] = glrCharacter.Lottery.Entries.Tickets[glrCharacter.Lottery.Entries.Names[i]].NumberOfTickets
		for j = 1, #glrCharacter.Lottery.Entries.TicketNumbers[glrCharacter.Lottery.Entries.Names[i]] do
			table.insert(transfer, glrCharacter.Lottery.Entries.TicketNumbers[glrCharacter.Lottery.Entries.Names[i]][j])
		end
	end
	
	RandomizationTable.Tickets = transfer
	high = #RandomizationTable.Tickets
	sort(RandomizationTable.Tickets)
	
	local number = tostring(math.random(glrCharacter.Event.Lottery.FirstTicketNumber, glrCharacter.Event.Lottery.LastTicketBought - 1))
	local check = math.random(1, high)
	local ticket = RandomizationTable.Tickets[check]
	local found = false
	local winner = ""
	
	for i = 1, #RandomizationTable.Names do
		for j = 1, RandomizationTable.Totals[RandomizationTable.Names[i]] do
			table.insert(RandomizationTable.Numbers[RandomizationTable.Names[i]], ticket)
			table.remove(RandomizationTable.Tickets, check)
			if #RandomizationTable.Tickets == 0 then break end
			high = #RandomizationTable.Tickets
			check = math.random(1, high)
			ticket = RandomizationTable.Tickets[check]
		end
	end
	
	if tonumber(number) % 2 == 0 then --Should only do this check if no winner is guaranteed.
		for i = 1, #RandomizationTable.Names do
			for j = 1, #RandomizationTable.Numbers[RandomizationTable.Names[i]] do
				if RandomizationTable.Numbers[RandomizationTable.Names[i]][j] == number then
					winner = RandomizationTable.Names[i]
					found = true
					break
				end
			end
			if found then break end
		end
	end
	
	print("Winner: "..winner.." Ticket: "..number)
	
	print("Done")
	--/script v, b, d, t = GetBuildInfo()
	--/script local v, b, d, t = GetBuildInfo() print(string.format("version = %s, build = %s, date = '%s', tocversion = %s.", v, b, d, t))
end